2021-02-25  Aidan Kehoe  <kehoea@parhasard.net>

	* Makefile (VERSION): XEmacs package 1.42 released.

2021-01-11  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/url-ldap.el:
	Sigh, the eval-when wrapper to attempt load- and run-time-only
	#'require of ldap was not enough.
	Revise the call to (apply #'require 'ldap nil) instead, which the
	byte-hunk-handler won't pick up.
	Last change tested on my local build which usually has ldap
	support, failure still evident on the package smoke test, failure
	elicited after removing ldap support, this change tested and works
	locally.

2021-01-10  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/url-ldap.el:
	Don't (require 'ldap) at compile time, it has no significant
	macros, load time is fine.
	* lisp/url-ldap.el (url-ldap):
	#'ldap-search-internal has been obsolete since 21.4, use
	#'ldap-search instead to attempt to maintain compatibility with
	GNU.

2014-06-22  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.41 released.

2014-06-02  Jerry James  <james@xemacs.org>

	* .hgignore: Fix paths to _pkg.el, auto-autoloads.el,
	custom-defines.el, and custom-load.el.
	* custom-load.el: Remove generated file.

2014-05-15  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.40 released.

2014-05-15  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.39 released.

2014-05-13  Jerry James  <james@xemacs.org>

	* .cvsignore: Remove.
	* lisp/.cvsignore: Remove.
	* texi/.cvsignore: Remove.
	* .hgignore: New file.
	* texi/w3.txi: Restore CVS keyword expansions.  Update for texinfo
	5.x.

2012-05-15  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.38 released.

2012-05-15  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/w3-menu.el (w3-menu-edit-menu):
	Check for the menubar or menu-bar feature before calling
	#'custom-menu-create, making building with a headless XEmacs
	practical.

2012-05-11  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.37 released.

2012-05-11  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/url-queue.el (float-time): Make this available if it's
	unbound, 21.4 doesn't have it.

	* lisp/url-http.el (url-http-create-request): We don't have
	#'string-as-unibyte, mapconcat with #'identity instead.

	* lisp/url-cookie.el (url-cookie-host-can-set-p): Don't bind an
	unused, non-special variable.

	* lisp/url-util.el (url-generate-unique-filename): Don't use
	with-no-warnings.
	(url-unhex-string): #'char-to-string, we don't have
	#'byte-to-string.

	* lisp/css.el (css-color-light-p): Don't bind an unused,
	non-special variable.
	(css-specificity): Ditto.
	(css-display): Ditto.

	* lisp/w3.el (w3-document-information):
	* lisp/w3-imap.el (w3-image-loadable-p):
	Call #'file-attributes, not #'url-file-attributes, in these two
	files.

	* lisp/url-cookie.el (url-cookie-handle-set-cookie): XEmacs;
	url-parse-args downcased the assoc list keys, no need for
	assoc-string rather than assoc.

	* lisp/url.el (url-retrieve-internal): (save-match-data
	(string-match "[^\x00-\x7f]" url)), not #'multibyte-string-p.
	(url-retrieve-internal): Change the documentation to reflect this.

	* lisp/url-file.el: 

	* lisp/w3-keymap.el: Add this, from upstream.

	* lisp/w3-speak-table.el: Don't load cl-extra.el at compile time,
	it's dumped in XEmacs.

	* lisp/w3-fast-parse.el: Add this file, from upstream.

	* lisp/w3-parse.el (w3-parse-munge-ethiopic-text):
	default-enable-multibyte-characters isn't available on XEmacs,
	don't look for it.

2012-05-10  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/w3-mouse.el (w3-mouse-button1, w3-mouse-button2)
	(w3-mouse-button3, not): Check for (featurep 'xemacs), not
	w3-running-xemacs

	* lisp/w3-hot.el (w3-grok-html-bookmarks): Add special
	declarations to this function, too.

2012-05-09  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/w3-display.el (w3-display-line-break): Remove binding for
	width, unused.

	* lisp/images.el (image-normalize): Bind coding-system-for-read on
	calling a process, rather than file-coding-system.

	* lisp/docomp.el (emacs-build-custom-load):
	#'Custom-make-dependencies, not #'custom-make-dependencies

2012-05-11  Aidan Kehoe  <kehoea@parhasard.net>

	Incorporate the following changes from upstream:

    2008-05-20  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-do-setup): Change homepage link.

    2008-03-26  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-fetch-callback): Don't disable multibyte.
	(w3-decode-charset): Don't reenable multibyte.

    2008-03-10  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-display.el (w3-display-table): Guard against empty
	colspan and rowspan elements.
	(w3-display-table-dimensions): Ditto.

    2008-03-01  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-speak-table.el: Modernize backquotes.

	* lisp/w3-parse.el: Modernize backquotes.

	* lisp/w3-java.el: Modernize backquotes.

	* lisp/w3-forms.el: Modernize backquotes.

	* lisp/Makefile.in (UTIL_SOURCES): Remove base64.el, md5.el,
	socks.el

	* lisp/base64.el: Remove.  Emacs has this builtin.

	* lisp/md5.el: Remove.  Emacs has this builtin.

	* lisp/socks.el: Remove.  Emacs already has it.

	* lisp/ssl.el: Don't require base64.

	* lisp/url-vars.el: Remove.  Emacs already has it.

    2008-02-04  Magnus Henoch  <mange@freemail.hu>

	* lisp/font.el (font-x-font-regexp-foundry-and-family): Add from
	last version of w3-sysdp.
	(x-font-create-object): Use it instead of
	x-font-regexp-foundry-and-family.

	* lisp/Makefile.in (EXTRAS): Remove w3-sysdp.el.
	(W3_SOURCES): Add w3-compat.el.

    2007-12-09  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-compat.el (w3-url-file-nondirectory): Fix thinko: alias
	to url-file-nondirectory, not url-file-directory.

    2007-11-16  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-compat.el (w3-alist-to-plist): Define.

	* lisp/w3-display.el (w3-parse-link)
	(w3-display-normalize-form-info, w3-display-node): Use
	w3-alist-to-plist instead of alist-to-plist.

    2007-11-15  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-display.el: Use w3-url-file-nondirectory instead of
	url-basepath (in many places).

	* lisp/w3.el: Require w3-compat.
	(w3-download-url): Use w3-url-file-nondirectory instead of
	url-basepath.

	* lisp/w3-compat.el: New file.
	(w3-url-file-nondirectory): New function.

	* lisp/images.el: Don't require w3-sysdp.

	* lisp/css.el: Ditto.
	(css-rule-specificity-internal): Drop old-style backquotes.
	(css-symbol-list-as-regexp): Ditto.

	* lisp/w3-dired.el: Don't require w3-sysdp.

	* lisp/w3-display.el: Ditto.  Also drop old-style backquotes.

	* lisp/w3-menu.el: Ditto.

	* lisp/w3.el: Ditto.
	(w3-download-callback): Skip HTTP headers when saving file.

	* lisp/w3-sysdp.el: Remove.

    2007-03-09  Magnus Henoch  <mange@freemail.hu>

	* lisp/css.el (css-expand-color): Catch errors and display a
	warning instead.

    2006-12-15  Klaus Straubinger <KSNetz@UseNet.ArcorNews.DE> (tiny change)

	* lisp/font.el (font-spatial-to-canonical): Fix conversion from
	pixels to points.

	* lisp/css.el (css-expand-length): Treat character based size
	specifications as such.

    2006-12-07  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-fetch-callback): Treat application/xhtml+xml as
	text/html.

    2006-11-29  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-download-redirect-callback): New function.
	(w3-download-url): Use it instead of w3-download-callback.

    2006-11-01  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-fetch-redirect-callback): Handle both old and new
	style of `url-retrieve' callback.

	* lisp/w3-display.el (w3-finalize-image-download-skip-redirects):
	Ditto.

    2006-10-17  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-save-url): Use kill-new.

	* lisp/w3-xemac.el (w3-store-in-clipboard): Remove.

    2006-10-13  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-parse.el (w3-slow-parse-buffer): Don't call
	w3-element-content-model on nil values.

    2006-10-12  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-imap.el (w3-image-loadable-p): Ignore errors in
	url-file-attributes.

	* lisp/w3-display.el (w3-finalize-image-download-skip-redirects):
	New function.
	(w3-maybe-start-background-image-download)
	(w3-maybe-start-image-download): Use it instead of
	w3-finalize-image-download.

    2006-10-11  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el (w3-fetch-redirect-callback): New function.
	(w3-fetch): Use it as url-retrieve callback instead of
	w3-fetch-callback.

    2006-10-09  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3.el: Require mm-decode here too.

    2006-10-08  Magnus Henoch  <mange@freemail.hu>

	* lisp/w3-display.el: Require mm-decode when compiling.

    2006-04-28  Dave Love  <fx@gnu.org>

	* texi/w3.txi: Change licence to GFDL. 

    2003-06-26  Sam Steingold  <sds@gnu.org>

	* lisp/w3-imap.el (w3-image-loadable-p): fixed the logic

    2003-01-12  Wolfgang Jenkner <wjenkner@inode.at>

	* lisp/w3.el (w3-fetch-callback)
	(w3-nasty-disgusting-http-equiv-handling): When searching for the
	':' meaning we are past the 'http/1.x' response, make sure that we
	save-execursion around it, or bad things happen.

    2002-10-28  Dave Love  <fx@gnu.org>

	* lisp/w3-display.el (w3-display-node): Don't use
	font-running-xemacs.

    2002-10-27  William M. Perry  <wmperry@gnu.org>

	* lisp/w3.el (w3-nasty-disgusting-http-equiv-handling): Now takes
	a second parameter, which is the URL that is being processed.
	This allows us to set url-current-object in the temporary buffer.
	This fixes the bug where a not-fully-qualified URL would cause
	url-expand-filename to get 'confused' and throw an error.
	(w3-fetch-callback): Pass the new URL argument to
	w3-nasty-disgusting-*

    2002-10-22  William M. Perry  <wmperry@gnu.org>

	* lisp/w3-forms.el (w3-form-create-option-list): Invalid call to
	truncate-string-to-width caused all reasonably sized <option>
	elements in a <select> to be invisible.
	(w3-form-default-button-update): Similar problem for buttons.

    2002-09-17  William M. Perry  <wmperry@gnu.org>

	* lisp/w3.el (w3-fetch-callback): Removed set-cookie handling.
	This needs to be handled in the HTTP protocol loader so that
	cookies that get set on redirects are honored.  This seems to be
	why my.yahoo.com has stopped working.

    2002-09-15  William M. Perry  <wmperry@gnu.org>

	* lisp/w3.el (w3-nasty-disgusting-http-equiv-handling): Need to
	make sure that we skip the 'HTTP/1.x' line at the top of the
	buffer (due to changes in the url library), or we end up confusing
	mail-header-extract if there are any <meta> elements with
	http-equiv headers in them.
	(w3-fetch-callback): I'm an idiot and was trying to compare the
	VALUE of a header against the actual header name for doing cookie
	handling.  Arguably this cookie handling should all be done in the
	HTTP handler itself.  Should move it somebday.

    2002-02-01  William M. Perry  <wmperry@gnu.org>

	* lisp/w3.el (w3-fetch-callback): Fiddling with how to display XML
	by default.

	* lisp/w3-widget.el: Attempt to make images work with Emacs 21.

	* lisp/w3-display.el (w3-display-node): Revert change for <hr>
	handling.

	* lisp/images.el: Use (featurep 'xemacs) instead of
	string-matching on emacs-version.

    2001-12-11  William M. Perry  <wmperry@gnu.org>

	* lisp/devices.el: Remove ancient NextStep support.

	* lisp/font.el: Merge with the version from XEmacs 21.5.  This
	pulls in lots of GTK fixes that I made ages ago.  Also removes
	ancient, unworking NextStep support.  Use new backquote syntax
	(emacs 19 can go away now).

    2002-01-22  Dave Love  <fx@gnu.org>

	* lisp/css.el (css-color-values): Maybe use `color-values'.

	* lisp/socks.el: Require cl only when compiling.  Require wid-edit
	when compiling.

	* lisp/font.el: Require cl only when compiling.  Remove second
	(require 'disp-table).  Wrap definitions of << & al in
	eval-and-compile.  Doc fixes.
	(font-set-font-encoding): Renamed from set-font-encoding (which is
	in fontset.el).

	* lisp/devices.el: Require cl only when compiling.

	* lisp/w3-java.el (url-util): Require.
	(w3-java-run-applet): Use url-generate-unique-filename, not
	non-existent mailcap-generate-unique-filename.

	* lisp/w3-menu.el (w3-first-n-items, w3-only-links)
	(w3-fix-spaces): Autoload to avoid compiler warnings.
	(w3-menu-filters-supported-p): Include Emacs 21.
	(w3-menu-links-constructor): Use modern backquote syntax.

	* lisp/ssl.el: Require cl only when compiling.  Require url.  Doc
	fixes.
	(ssl-view-certificate-program-arguments): Modify :type.
	(top-level): Delete custom compatibility code since we require a
	modern Emacs.
	(open-ssl-stream): Use modern backquote syntax.

	* lisp/w3-display.el (top-level): Declarations and autoloads to
	avoid compiler warnings.
	(w3-display-node): Use copy-sequence, not CL runtime copy-tree.

	* lisp/w3-parse.el (decode-char): Modify logic for compiler
	warning.

	* lisp/w3.el (w3-nasty-disgusting-http-equiv-handling): Make
	buffer arg compulsory and always set the buffer.  Parse a copy of
	the head region, since w3-parse-region widens the buffer and may
	mung it.
	(w3-fetch-callback): Give w3-nasty-disgusting-http-equiv-handling
	an arg.

    2001-12-04  William M. Perry  <wmperry@gnu.org>

	* lisp/w3-display.el (w3-display-node): Explicitly put in breaks
	for <hr> - <p> is not always inferred before and after (like when
	using w3-fast-parse.

    2001-11-25  William M. Perry  <wmperry@gnu.org>

	* lisp/w3-parse.el (w3-parse-buffer): Add : to the allowed tag
	names to deal with Microsoft XHTML.
	(w3-parse-buffer): Allow : in attribute names for XHTML

    2001-11-24  William M. Perry  <wmperry@gnu.org>

	* lisp/font.el (font-set-face-font-new-redisplay): Doh!  Fix my
	last font-size checking screwup.  *sigh*

	* lisp/ssl.el (ssl-get-command): New routine to handle wrapping
	the ssl program inside something that will redirect stderr to
	/dev/null.  Do this only on non-dos, non-windows, and non-vms
	system types.  This is necessary because the -quiet switch to
	openssl's s_client program doesn't do what it is supposed to do.
	*sigh*

	* lisp/font.el (font-set-face-font-new-redisplay): Check font-size
	for == 0, not just non-nil.

    2001-11-21  William M. Perry  <wmperry@gnu.org>

	* lisp/w3.el (w3-mode): Don't bother calling
	kill-all-local-variables.  It screws up too many things, namely
	emacspeak personality properties and XEmacs' buffer-local faces.

	* lisp/w3-display.el (w3-handle-string-content): Just go ahead an
	always put the personality (aural properties) on text.

	* lisp/w3-parse.el (w3-parse-buffer): Patch from Joe Wells to
	handle XHTML a little bit better.  Still a hack, but it will now
	work at all.

	* lisp/w3-display.el (w3-display-node): Add support for 'start'
	element on list start elements.  Some sites use this instead of
	seqnum.

    2001-10-31  Dave Love  <fx@gnu.org>

	* lisp/w3.el (w3-decode-charset): DTRT for explicit ascii charset.

    2001-10-11  Dave Love  <fx@gnu.org>

	* lisp/w3-style.el (cl): Require only when compiling.

	* lisp/w3-cus.el: Doc fixes.
	(w3-delay-image-loads): Fix default for Emacs 21.
	(w3-mule-charset-to-coding-alist): Remove.

	* lisp/w3.el (w3-parse-hotlist, w3-menu-install-menus): Autoload.
	(w3-explicit-coding-system): Move definition.
	(w3-decode-charset, w3-fetch-callback): Use it.

    2001-10-01  Dave Love  <fx@gnu.org>

	* lisp/w3-vars.el: Doc fixes.
	(w3-meta-content-type-charset-regexp)
	(w3-meta-charset-content-type-regexp): Removed.
	(w3-persistent-variables): Add url-current-mime-headers.

	* lisp/w3.el (w3-setup-reload-timer, w3-handle-refresh-header):
	New function.
	(w3-fetch-callback): Handle refresh and cookies.  Set
	url-current-object.  Don't destroy external parts immediately.
	For inlines, use w3-mode, require mm-view, lose cursor for images.

	(w3-document-information): Fix for current url stuff.
	(w3-replace-invalid-chars): Remove.

	* lisp/w3-display.el (w3-display-node): Fix <meta> and <link>
	handling.

    2001-09-24  Dave Love  <fx@gnu.org>

	* lisp/w3.el (w3-http-equiv-headers): New function.
	(w3-nasty-disgusting-http-equiv-handling): Use it to fix
	http-equiv handling.

    2001-09-09  Dave Love  <fx@gnu.org>

	* lisp/w3-display.el (w3-mode, w3-add-delayed-graphic)
	(w3-find-specific-link, w3-fix-spaces): Autoload.

	* lisp/w3-props.el (w3-fillin-text-property): Renamed from
	`fillin-text-property'.

    2001-08-24  Dave Love  <fx@gnu.org>

	* lisp/font.el (font-spatial-to-canonical): Don't choke if
	font-default-size-for-device returns nil, convert it to 0.
	From Jim Meyering <meyering@lucent.com>

    2001-07-19  Dave Love  <fx@gnu.org>

	* lisp/w3-toolbar.el (w3-toolbar-map): Don't lose on non-graphical
	display with tool-bar-mode t.

    2001-06-21  Dave Love  <fx@gnu.org>

	* lisp/w3-menu.el (w3-menu-hotlist-constructor): Require w3-hot,
	not w3-hotlist.

    2001-06-14  Dave Love  <fx@gnu.org>

	* lisp/Makefile.in (W3_SOURCES): Add w3-emacs.el, remove files it
	obsoletes.

    2001-06-07  Dave Love  <fx@gnu.org>

	* lisp/w3-print.el (mule-sysdp): Don't require.

	* lisp/w3-parse.el (mule-sysdp): Don't require.

	* lisp/w3-latex.el (mule-sysdp): Don't require.
	(w3-show-dvi): Avoid mule-write-region-no-coding-system.

	* lisp/w3-display.el (mule-sysdp): Don't require.
	(w3-display-get-cookie, w3-finalize-image-download): Avoid
	mule-write-region-no-coding-system.

	* lisp/w3-cus.el (mule-sysdp): Don't require.
	(w3-force-conversion-alist): Use binary, not
	mule-no-coding-system.

	* lisp/images.el (mule-sysdp): Don't require.
	(image-normalize): Use binary, not mule-no-coding-system.

	* lisp/w3-forms.el (wid-edit): Require unconditionally.
	(custom-magic-reset, w3-warn): Autoload.
	(w3-form-keymap): Use substitute-key-definition, not
	cl-map-keymap.
	(w3-form-create-custom): Require cus-edit unconditionally.
	(w3-all-widgets): Move definition.
	(w3-form-create-file-browser, w3-form-create-option-list)
	(w3-form-default-button-update): Avoid mule-truncate-string.
	(mule-sysdp): Don't require.
	(w3-form-encode-xwfu): Avoid mule-encode-string.

	* lisp/w3-emacs.el: New file.

	* lisp/w3-e19.el, lisp/w3-e20.el, lisp/w3-e21.el: Deleted in
	favour of w3-emacs.  (Avoid defadvice.)

	* lisp/w3.el (w3-load-flavors): Remove Emacs version-specifics --
	just require w3-emacs.

	* lisp/w3-toolbar.el (w3-toolbar-file-icon)
	(w3-toolbar-printer-icon, w3-toolbar-file-icon): New variable.
	(w3-toolbar-map): Transform `toolbar-' symbols into `w3-toolbar-'.

	* lisp/w3-sysdp.el (copy-tree): Fix cl- functions.
	(truncate-string-to-width): New.

    2001-06-05  Dave Love  <fx@gnu.org>

	* lisp/w3-display.el: Require cl only when compiling.
	(w3-line-breaks-vector): Deleted.
	(w3-display-line-break): Use justification arg of
	fill-region-as-paragraph.  Use insert-char.

	* lisp/css.el (w3-sysdp): Require.
	(url-expand-file-name, url-insert-file-contents, url-view-url):
	Autoload.
	(css-running-xemacs): Removed.  Change callers to use featurep.
	(css-handle-import, css-parse): Declare url-current-object
	special.
	(css-active-device-types): Use display-multi-font-p, not
	font-running-emacs-new-redisplay.

	* lisp/w3-parse.el (w3-invalid-sgml-char-replacement): Doc fix.
	(w3-resolve-numeric-char): Renamed from
	w3-resolve-numeric-entity.  Callers changed.

	* lisp/w3-vars.el (w3-version-number): Fix regexp, doc.
	(w3-html-entities): Modified per W3C entity list.

	* lisp/w3-toolbar.el (w3-toolbar-back-icon, w3-toolbar-forw-icon)
	(w3-toolbar-home-icon, w3-toolbar-reld-icon)
	(w3-toolbar-imag-icon, w3-toolbar-open-icon)
	(w3-toolbar-print-icon, w3-toolbar-find-icon)
	(w3-toolbar-stop-icon, w3-toolbar-help-icon)
	(w3-toolbar-hotl-icon) [(featurep 'tool-bar)]: Initialize to names
	of Emacs 21 icons.
	(toolbar-make-button-list) [(featurep 'tool-bar)]: Don't define.
	(w3-toolbar-make-buttons): Do nothing if (featurep 'tool-bar).
	(w3-toolbar-map): New variable.
	(w3-add-toolbar-to-buffer): Use it.

    2001-06-01  Dave Love  <fx@gnu.org>

	* lisp/w3-display.el (widget-convert-text): Only advise it if
	we're in Emacspeak.
	(append-suffixes-hack, w3-java-run-applet, mm-inline-text):
	Autoload.
	(w3-display-get-cookie): Use url-generate-unique-filename.
	(w3-display-table): Use copy-sequence, not copy-seq.

	* lisp/w3.el (w3-decode-charset): Set buffer file coding system.

    2001-05-31  Dave Love  <fx@gnu.org>

	* lisp/w3-menu.el (w3-menu-file-menu): Fix
	"---:shadowDoubleEtchedIn".  From Pavel JanÃ­k.

	* lisp/w3-parse.el (decode-char): Define with older Mule-UCS.
	(w3-expand-entity-at-point-maybe): Sanitize regexp for numeric
	entity.  Don't lose trailing space.  Grok hex form.

    2001-05-30  Dave Love  <fx@gnu.org>

	* lisp/w3-menu.el: Require w3-sysdp.
	(w3-popup-menu): Revert last change.

    2001-05-29  Dave Love  <fx@gnu.org>

	* lisp/w3-sysdp.el: Remove lots of unused stuff.

	* lisp/w3.el: Require cl only when compiling.  Doc and message
	fixes.

	* lisp/w3-toolbar.el (w3-toolbar): Bind w3-hotlist-view, not
	w3-show-hotlist.

	* lisp/w3-menu.el (w3-menu-hotlist-constructor): Require
	w3-hotlist.
	(w3-menu-bookmark-menu): Bind w3-hotlist-view, not
	w3-show-hotlist.
	(w3-popup-menu): In Emacs, use copy-keymap, not copy-tree.

	* lisp/w3-hotindex.el (w3-hotindex-query): Call w3-hotlist-view,
	not w3-show-hotlist.

	* lisp/w3-emulate.el (url-vars): Require.
	(w3-lynx-emulation-minor-mode-map)
	(w3-netscape-emulation-minor-mode-map): Bind w3-hotlist-view, not
	w3-show-hotlist.

	* lisp/w3-dired.el (w3-open-local, w3-fetch): Autoload.
	(add-minor-mode): Remove definition in favour of autoload.

	* lisp/w3-keymap.el (w3-mode-map): Bind w3-hotlist-view, not
	w3-show-hotlist.

	* lisp/w3-parse.el (w3-parse-buffer): Use
	w3-resolve-numeric-entity for bogus characters.

    2001-05-25  William M. Perry  <wmperry@gnu.org>

	* lisp/w3-speak-table.el: Make sure to load cl-extra at load time
	to work around a byte-optimizer bug in Emacs 21 that caused this
	module to fail to byte-compile.

    2001-05-24  Pavel JanÃ­k <Pavel@janik.cz>

	* lisp/w3-display.el (w3-resurrect-hyperlinks): Look for next
	single property change from `st' instead of `nd' to avoid
	potential infinite loops.

    2001-05-24  William M. Perry  <wmperry@gnu.org>

	* lisp/w3-cus.el (w3-honor-stylesheets): Turn off stylesheets for
	now - url-retrieve-synchronously seems to be acting quite
	strange.

    2001-05-22  William M. Perry  <wmperry@gnu.org>

	* lisp/css.el (css-handle-import): Use ignore-errors around url
	loading.
	(css-parse): Ditto.

	* lisp/docomp.el: Remove a bunch of the autoloading crap - it
	isn't needed anymore.

    2001-05-17  William M. Perry  <wmperry@gnu.org>

	* lisp/w3-parse.el w3-int-to-char: Deal with XEmacs more nicely.
	int-to-char does error checking, so passing in ?~ tends to blow
	things up.  Do better error checking for characters passed in, and
	for integers that are not capable of being converted to
	characters.

	* lisp/w3-display.el (w3-dingbats): Deal with a mule-less XEmacs
	in our conditions.

    2001-05-16  Dave Love  <fx@gnu.org>

	* lisp/w3.el (w3-decode-charset): Re-write.
	(w3-fetch-callback): Partly re-write for coding conversion.
	(w3-convert-code-for-mule, w3-coding-system-for-mime-charset):
	Deleted.
	(w3-save-as, w3-download-callback): Avoid
	mule-write-region-no-coding-system.
	(w3-mode): Do kill-all-local-variables in Emacs.

    2001-05-15  Dave Love  <fx@gnu.org>

	* lisp/w3-display.el (w3-sysdp): Require.
	(flatten): Autoload unconditionally.

	* lisp/w3-parse.el (w3-invalid-sgml-char-replacement): Redefined.
	(w3-resolve-numeric-entity): New function.
	(html-entities): Consider string and non-string returns from
	w3-resolve-numeric-entity.
	(w3-p-s-var-def): Use w3-resolve-numeric-entity.
	(w3-parse-hooks): Fix typo.
	(w3-int-to-char): New alias.

    2001-05-14  Dave Love  <fx@gnu.org>

	* lisp/w3-sysdp.el: Don't define extent-related functions, to
	avoid trouble with other packages.

	* lisp/w3.el: Don't require mule-sysdp.
	(w3-decode-charset): Remove prompting stuff.  Avoid
	gnus-strip-whitespace.  Use mm-charset-to-coding-system and return
	coding system used.
	(w3-fetch-callback): Bind and set mule-retrieval-coding-system.
	Call mm-enable-multibyte.
	(w3-widget-button-click): Add Emacs case.
	(w3-warn): Wrap definition in eval-and-compile.

	* lisp/w3-imap.el: Use new backquote syntax.
	(w3-image-invalid-glyph-p): Test for Emacs images.

	* lisp/w3-widget.el: Use (featurep 'xemacs).  Use modern backquote
	syntax.
	(widget): Don't require cl.
	(w3-vars): Require.
	(w3-point-in-map, w3-point-in-map): Autoload.
	(widget-image-value-set): Add Emacs 21 image test.
	(widget-image-usemap): Avoid a string-match.
	(widget-image-value-create): Use align property.  Fix call of
	image-type-available-p.  Some simplification.  Use `insert-image'
	in Emacs.
	(widget-image-delete): Maybe use delete-overlay.
	(widget-glyphp): Test for Emacs image.
	(widget-image-button-press): Add code for Emacs.

	* lisp/w3-display.el: Use (featurep 'xemacs), not
	w3-running-xemacs.  Use modern backquote syntax.
	(w3-maybe-start-image-download): Use display-graphic-p.  Don't use
	make-glyph in Emacs.
	(w3-maybe-start-background-image-download): Fix typo `mesage'.
	Don't use make-glyph in Emacs.
	(w3-finalize-image-download): For Emacs, grok `align' attribute.
	Use unibyte for image data in Emacs.  Only do xbm stuff in XEmacs.
	Don't do make-glyph by default.  Only call set-glyph-image if it's
	defined.
	(w3-handle-image): Use `align'.
	(w3-dingbats): Define without using mule-sysdep-version.
	(w3-make-char): Likewise.
	(w3-display-node): Minor logic simplification.

	* lisp/w3-menu.el (cl): Require cl when compiling.  Use (featurep
	'xemacs), not w3-running-xemacs.
	(w3-menu-file-menu): Allow ---:shadowDoubleEtchedIn in Emacs 21.
	(w3-menu-options-menu): Comment-out `download to disk'
	(w3-dump-to-disk not defined).

	* lisp/w3-parse.el (url-expand-file-name): Autoload.
	(cl): Require when compiling.
	(w3-invalid-sgml-char-replacement): Defvar when compiling.
	(w3-parse-munge-ethiopic-text): Don't bother supporting MULE 2.
	(w3-parse-hooks): Customize.  Default to nil, with
	w3-parse-munge-ethiopic-text as an option.

	* lisp/w3-dired.el (w3-dired-find-file-mouse): Use mouse-set-point.
	(dired-get-filename): Autoload.
	(w3-dired-find-file-dired): New function, renamed from second
	occurrence of w3-dired-find-file.

	* lisp/w3-hot.el (cl): Require when compiling.

    2001-05-10  Dave Love  <fx@gnu.org>

	* lisp/w3-menu.el (w3-menu-go-menu): Use url-history-track, not
	url-keep-history.

	* lisp/mule-sysdp.el: Removed in favour of one in url package.

    2001-01-04  Dave Love  <fx@gnu.org>

	* lisp/w3-toolbar.el (w3-add-toolbar-to-buffer) <featurep 'tool-bar>:
	Test display-graphic-p and tool-bar-lines.  Use mapc, not mapcar.

    2001-01-03  Dave Love  <fx@gnu.org>

	* lisp/w3-toolbar.el (w3-add-toolbar-to-buffer): In Emacs, test
	for graphic display and non-zero tool bar lines.

    2001-01-02  Sam Steingold  <sds@gnu.org>

	* lisp/docomp.el (load-path): Gnus and URL are two levels
	above w3/lisp by default.

    2000-12-20  Dave Love  <fx@gnu.org>

	* lisp/w3-sysdp.el: Use sysdep-defalias, not sysdep-fset.

	* lisp/w3-widget.el: Use defalias, not fset.

	* lisp/w3.el (w3-maybe-follow-link): Fix call of
	widget-button-press.

	* lisp/w3-parse.el (w3-char-int): New alias instead of char-int.

	* lisp/w3-menu.el (w3-event-glyph): New alias instead of
	event-glyph.

	* lisp/w3-display.el: Use defalias, not fset.
	(w3-widget-echo): Revert last change, following Emacs change.

	* lisp/mule-sysdp.el (cl): Require only when compiling.

	* lisp/font.el: Use defalias, not fset.  Don't use cl-...hash.

	* lisp/devices.el (device-class): Try display-color-p first.

	* lisp/socks.el (socks-char-int): New alias instead of char-int.
	Callers changed.
	(socks-original-open-network-stream, open-network-stream): Use
	defalias, not fset.
	(socks-wait-for-state-change, socks-filter)
	(socks-open-connection, socks-open-connection)
	(socks-send-command, socks-parse-services)
	(socks-find-services-entry, socks-open-network-stream)
	(socks-username/password-auth-filter)
	(socks-username/password-auth): Don't use cl-...hash.

	* lisp/css.el (css-get-internal, css-copy-stylesheet)
	(css-store-rule, css-display): Don't use cl-...hash.

    2000-11-15  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-mouse.el (not): Don't ever try to grab mouse-movement
	events if we are running Emacs 21.

	* lisp/w3-display.el (w3-decimal-to-alpha): Don't try to inline
	this - it called itself recursively and so blew up Emacs'
	byte-compiler.
	(w3-decimal-to-alpha): Also fixed bug where large numbers did not
	get converted correctly (3 letters or more were completely screwed
	up).
	(w3-decimal-to-roman): Don't inline this one either, just for
	safety.

    2000-10-16  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-e21.el (toolbar-file-icon): added definitions of
	toolbar-file-icon and toolbar-printer-icon

    2000-10-02  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-e21.el (w3-setup-version-specifics): Advise this
	function to create toolbar buttons in Emacs 21.x with toolbar
	support.
	(w3-mode-version-specifics): Advise this function to actually add
	the toolbars to each buffer.

	* lisp/w3-toolbar.el (w3-add-toolbar-to-buffer): Deal with
	toolbars in Emacs 21.

    2000-07-28  Sam Steingold  <sds@gnu.org>

	* lisp/Makefile.in: added w3-e21.el to W3_SOURCES

    2000-07-10  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-parse.el (w3-expand-entity-at-point-maybe): Wrap
	inserting of &#xxx; entities inside a condition-case so that we
	won't choke and die when parsing a bad document.

    1999-12-23  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-speak-table.el (w3-table-focus-on-this-cell): Synch'd up
	with Thierry & Raman.  Provide default value for at-depth.
	Resurrect hyperlinks and images when focusing on a cell.
	(w3-table-setup-keys): New bindings for `,' and `.' to focus on
	and speak table cells.

    1999-12-22  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-parse.el (w3-parse-buffer): Allow ':' in attribute
	names, to deal with stupid quasi-HTML/XML data output by MS Word
	9.x
	(w3-parse-buffer): Removed progress bar stuff, since it is causing
	XEmacs 21.2 betas to crash.

    1999-12-06  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-display.el (w3-prepare-tree): Analog to
	w3-prepare-buffer, but works on a ready-made parse tree instead of
	parsing it on the fly.

	* lisp/w3.el (w3-fetch-callback): Added in special case for
	handling content-type of application/x-elisp-parsed-html, for when
	we want to

	* lisp/css.el (css-handle-import): Protect against
	url-insert-file-contents signalling an error.
	(css-handle-import): Use url-insert-file-contents instead of the
	old url-retrieve interface.  We cannot retrieve stylesheets
	asynchronously (for now).
	(css-expand-value): Nuke quotes around URL attributes.

    1999-12-05  William M. Perry  <wmperry@aventail.com>

	* lisp/w3-display.el (w3-prepare-buffer): Don't do the history
	stuff - this died a long time ago anyway.

    1999-12-05  Dave Love  <fx@gnu.org>

	* lisp/Makefile.in (W3_OBJECTS): Use W3_SOURCES, not SOURCES.

    1999-12-05  William M. Perry  <wmperry@aventail.com>

	* lisp/w3.el (w3-fetch): Urk, call w3-notify-when-ready if we
	found a buffer visiting the URL, otherwise nothing happens.
	User just silently gets no feedback about the operation.

	* w3.el: Lots of changes to work with the new URL package.

	* w3-vars.el: Removed lots of old varialbes.  Updated to use new
	URL package where necessary.
	(w3-graphlink-menu): Removed the 'info' menu item.  Not
	(re)implemented yet.
	(w3-hyperlink-menu): Ditto.

	* w3-toolbar.el (w3-mouse-print-this-url): Ditto.

	* w3-print.el (w3-print-this-url): Removed LaTeX as an option.

	* w3-style.el, w3-parse.el: Deal with using new URL package.

	* w3-menu.el: Removed LaTeX-related menu entries.
	(w3-menu-links-constructor): Expand the URL in the menu
	constructor if necessary, don't use url-maybe-relative anymore.

	* w3-keymap.el: New separate file just for keymaps

	* w3-java.el: Deal with removal of old 'mm' file and use
	mailcap.el functions.

	* w3-forms.el: Removed gopher query support.

	* w3-emulate.el: Remove arena masquerade code.  Does anybody even
	use this masquerading code?

	* w3-jscript.el, w3-elisp.el, w3-script.el: Removed files related
	to scripting.

	* w3-xemac.el (w3-mouse-handler): Ditto.

	* w3-e19.el (w3-mouse-handler): Don't bother with scripting
	elements yet.

	* w3-display.el: Lots of changes to deal with the new URL package
	and using the new mailcap.el file from Gnus.

	* w3-cus.el: Removed lots of obsolete variables

	* w3-hot.el (w3-hotlist-add-document): Disable due to default use
	of html bookmark files now.
	(w3-hotlist-delete): Ditto.
	(w3-hotlist-apropos): Use new URL-based hotlist interface
	(w3-hotlist-view): Ditto.
	(w3-use-hotlist): Now deals with html-based bookmark lists.
	(w3-hot-convert-to-alist): New function to conver an internal
	bookmark list to an assoc list with oddly formatted keys.
	(w3-read-html-bookmarks): Don't set w3-html-bookmarks any more -
	this will be the main format now.
	(w3-hot-push-now-item): Don't push a menu-object onto the list,
	use a regular format we can convert to a menu when necessary.

	* url-hotlist.el: New URL-based interface for searching your
	hotlist.

    1999-12-04  William M. Perry  <wmperry@aventail.com>

	* lisp/base64.el: Updated to latest base64.el from Kyle.  Now no conflicts
	between this and the Gnus-distributed version.

    1999-12-03  William M. Perry  <wmperry@aventail.com>

	* lisp/font.el (font-set-face-font-new-redisplay): Don't set the :family
	face attribute if it is nil.  The new redisplay doesn't like that.
	
2012-01-10  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.36 released.

2011-12-31  Aidan Kehoe  <kehoea@parhasard.net>

	* lisp/w3-menu.el (w3-menu-edit-menu):
	Only call #'custom-menu-create if the menubar is available; avoids
	compilation problems when this code is evaluated as a result of
	(require 'w3-menu).

2008-07-23  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.35 released.

2007-09-04  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.34 released.

2007-09-04  Didier Verna  <didier@xemacs.org>

	* lisp/ssl.el (ssl-view-certificate-program-arguments): Fix misuse
	of the list widget type.
	* lisp/ssl.el (ssl-program-arguments): Ditto.
	* lisp/w3-java.el (w3-java-vm-arguments): Ditto.

2006-05-17  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.33 released.

2006-05-08  Malcolm Purvis  <malcolmp@xemacs.org>

	* lisp/Makefile.in (SOURCES):
	* lisp/css.el:
	* lisp/css.el (font-rgb-color-p): New.
	* lisp/css.el (font-rgb-color-red): New.
	* lisp/css.el (font-rgb-color-green): New.
	* lisp/css.el (font-rgb-color-blue): New.
	* lisp/css.el (css-replace-regexp):
	* lisp/css.el (css-running-xemacs): Removed.
	* lisp/css.el (featurep):
	* lisp/css.el (css-active-device-types):
	* lisp/devices.el (if):
	* lisp/images.el (if):
	* lisp/images.el (image-native-formats):
	* lisp/mule-sysdp.el (mule-sysdep-version):
	* lisp/url-file.el (url-dired-minor-mode-map):
	* lisp/url-vars.el (url-default-ports):
	* lisp/url-vars.el (url-running-xemacs): Removed.
	* lisp/url.el (if):
	* lisp/w3-display.el:
	* lisp/w3-display.el (set-font-style-by-keywords): New.
	* lisp/w3-display.el (w3-pause):
	* lisp/w3-display.el (w3-get-default-color):
	* lisp/w3-display.el (not):
	* lisp/w3-display.el (w3-finalize-image-download):
	* lisp/w3-display.el (w3-resurrect-hyperlinks):
	* lisp/w3-display.el (w3-display-node):
	* lisp/w3-display.el (w3-finish-drawing):
	* lisp/w3-menu.el (w3-menu-filters-supported-p):
	* lisp/w3-menu.el (w3-menu-dummy-menu):
	* lisp/w3-menu.el (w3-toggle-minibuffer):
	* lisp/w3-menu.el (w3-toggle-location):
	* lisp/w3-menu.el (w3-toggle-menubar):
	* lisp/w3-menu.el (w3-location-active):
	* lisp/w3-menu.el (w3-menubar-active):
	* lisp/w3-menu.el (w3-menu-global-menubar):
	* lisp/w3-menu.el (w3-menu-file-menu):
	* lisp/w3-menu.el (w3-menu-options-menu):
	* lisp/w3-menu.el (w3-menu-buffer-menu):
	* lisp/w3-menu.el (w3-menu-emacs-button):
	* lisp/w3-menu.el (w3-menu-install-menubar):
	* lisp/w3-menu.el (w3-menu-install-menubar-item):
	* lisp/w3-menu.el (w3-menu-set-menubar-dirty-flag):
	* lisp/w3-menu.el (w3-menu-toggle-menubar):
	* lisp/w3-menu.el (w3-menu-popup-menu):
	* lisp/w3-mouse.el (w3-mouse-button1):
	* lisp/w3-mouse.el (not):
	* lisp/w3-parse.el (w3-invalid-sgml-char-replacement):
	* lisp/w3-sysdp.el (window-system):
	* lisp/w3-vars.el:
	* lisp/w3-vars.el (w3-running-xemacs): Removed.
	* lisp/w3-widget.el (featurep):
	* lisp/w3-widget.el (widget-image-value-create):
	* lisp/w3.el (w3-load-flavors):
	Removed font.el because it is in core, some inline functions moved
	to other files.  Use (featurep 'xemacs) instead of string matches
	on emacs-version.

2005-12-29  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.32 released.

2003-09-08  Mike Sperber  <sperber@informatik.uni-tuebingen.de>

	* lisp/css.el (css-parse): Set `buffer-file-name' to nil after
	reading stylesheet, to avoid spurious requests for saving the
	file.

2005-05-10  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.31 released.

2004-06-18  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.30 released.

2004-06-18  Ilya N. Golubev  <gin@mo.msk.ru>

	* lisp/w3-display.el (w3-setup-terminal-chars): Fix
	`w3-table-hack-x-face' font parameters so that font with
	appropriate encoding is searched.

2003-10-31  Norbert Koch  <viteno@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.29 released.

2003-03-09  Ben Wing  <ben@xemacs.org>

	* Makefile:
	Delete explicit binkit: rule.
	Delete all targets except stylesheet from compile::.
	Don't add custom-load.elc to the list of generated elc's.
	Use EXPLICIT_DOCS instead of explicitly giving the targets
	and dependencies.
	Delete recursive building of docs, handled at top level.
	Use DOCS_TXI_EXTENSION.
	Use EXTRA_DEPENDENCIES for stylesheet.
	* texi/Makefile: Deleted.

2003-01-13  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.28 released.

2003-01-08  Ville Skyttä  <scop@xemacs.org>

	* lisp/url.el (url-write-global-history): Call
	`w3-write-explicit-encodings' only if it's available.

2003-01-07  Ville Skyttä  <scop@xemacs.org>

	* lisp/w3-cus.el (w3-configuration-direcory): Add autoload cookie.

2002-11-29  Ben Wing  <ben@xemacs.org>

	* lisp/.cvsignore: Remove files now handled automatically by CVS.
	* Makefile: Use `compile' instead of hard-coded `all'.

2002-12-06  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.27 released.

2002-12-04  Ville Skyttä  <scop@xemacs.org>

	* Sync with upstream 4.0pre47 (was practically already in sync).

	* lisp/url.el (url-remove-relative-links): Special handling for
	Windows drive letters, thanks to Dmitry Bely <dbely@mail.ru>.

2002-10-15  Ville Skyttä  <scop@xemacs.org>

	* Makefile (srckit): Remove.
	(.PHONY): Ditto.

2002-10-14  Ville Skyttä  <scop@xemacs.org>

	* Makefile (MANUAL): Removed (unused).

2002-09-25  Rendhalver [Peter Brown]  <rendhalver@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.26 released.

2002-09-17  Ville Skyttä  <scop@xemacs.org>

	* Makefile (REQUIRES): Add ecrypto, we'll use md5 from there.
	(EXTRA_SOURCES): Add lisp/md5.el.upstream.

	* package-info.in (provides): Remove md5.

	* lisp/md5.el: Renamed to lisp/md5.el.upstream.

2002-06-27  Steve Youngs  <youngs@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.25 released.

2002-06-26  Steve Youngs  <youngs@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.24 released.

2002-06-10  Adrian Aichner  <adrian@xemacs.org>

	* texi/Makefile (distclean): Convert to double-colon.

2002-05-09  Steve Youngs  <youngs@xemacs.org>

	* Makefile (VERSION): XEmacs package 1.23 released.

	* Makefile (PRELOADS): No need to push anything into the
	load-path.

2002-04-28  Steve Youngs  <youngs@xemacs.org>

	* lisp/mule-sysdp.el (mule-truncate-string): Use 'string-to-list'
	instead of 'string-to-char-list'.

2002-04-21  Steve Youngs  <youngs@xemacs.org>

	* lisp/url.el: Remove duplicate autoload for 'url-is-cached'.

2002-03-25  Steve Youngs  <youngs@xemacs.org>

	* Makefile (VERSION): 1.22 released.

2002-03-17  Adrian Aichner  <adrian@xemacs.org>

	* Makefile: Add html rule to invoke texi/Makefile.

2002-01-13  Steve Youngs  <youngs@xemacs.org>

	* package-info.in (provides): Update to include all provides.

2002-01-07  Adrian Aichner  <adrian@xemacs.org>

	* Makefile (HTML_FILES): New.
	* Makefile (HTML_DEP): New.

2001-06-18  Ben Wing  <ben@xemacs.org>

	* Makefile (all):
	Fix to compile in the absence of an installed package tree.

2001-05-11  Ben Wing  <ben@xemacs.org>

	* Makefile (PRELOADS):
	* Makefile (stylesheet):
	Fix to compile in the absence of an installed package tree.

2001-02-24  Ben Wing  <ben@xemacs.org>
	Conditionalize extra MS Windows quoting on
	XEMACS_NATIVE_NT_NEEDS_EXTRA_QUOTING, since it breaks things under
	newer Cygwins.

2000-11-14  Martin Buchholz <martin@xemacs.org>

	* ./lisp/url-cookie.el: Doc fix.

2000-11-08  Steve Youngs  <youngs@xemacs.org>

	* Makefile (ELCS): Removed base64.elc.

	* ./lisp/base64.elc: Moved to mail-lib.

2000-10-05  Martin Buchholz  <martin@xemacs.org>

	* *: Mega typo fix.

2000-08-22  Steve Youngs  <youngs@xemacs.org>

	* Makefile: Remove target 'clean' because it's covered in XEmacs.rules.

2000-06-25  AichnerAd  <aichner@ecf.teradyne.com>

	* Makefile (PRELOADS): Use lisp instead of `pwd`.  Handle
	Native-NT XEmacs command-line quoting.

1999-11-27  Andreas Jaeger  <aj@xemacs.org>

	* Makefile (ELCS): Add lisp/w3-java.elc.
	(PRELOADS): Load advice.

1999-11-14  William M. Perry  <wmperry@aventail.com>

* aclocal.m4 (AC_EMACS_LISP): work around bug in current Emacs 21.1
  pretests where (princ "foo") crashes in batch mode.

1999-11-13  William M. Perry  <wmperry@aventail.com>

* lisp/w3-cus.el (w3-use-terminal-glyphs): Changed default value to nil,
  was causing too many weirdnesses under Emacs (I loathe MULE sometimes)
  (w3-use-terminal-characters): Ditto.

* lisp/w3-display.el (w3-display-handle-java): Duh, give 2 arguments to
  push.

1999-11-12  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-display-handle-java): Make sure that there is
  ALWAYS a codebase attribute for java, or bad things could happen (like
  not being able to find the classes since we write to a temp file, etc.)

* lisp/w3-parse.el (w3-parse-buffer): Make sure that we expand the
  'codebase' attribute.

* lisp/w3-display.el (w3-auto-run-java): New variable to control whether
  Java applets are run
  (w3-display-handle-java): New function to convert our internal parse
  structure into something that `w3-java-run-applet' can understand.
  (w3-display-node): Use it.

* lisp/w3-java.el: New file for running java programs in an external
  process.

1999-11-07  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

* lisp/url.el (url-retrieve-internally): make-local-variable
  'track-mouse to workaround problem with `widget-button-click'.

1999-11-10  William M. Perry  <wmperry@aventail.com>

* lisp/w3-parse.el (textarea content model): Changed content model to
  XCDATA so that markup can be included in the default text.

* lisp/w3-menu.el (w3-menu-help-menu): Remove version information menu
  item.  It hasn't been updated in years.

1999-11-10  "T. V. Raman" <raman@cs.cornell.edu>

* lisp/w3-display.el (widget-convert-text): Added advice around this
  function to preserve the 'personality' text property, otherwise
  hyperlinks did not get the correct aural properties applied.

1999-11-10  Thierry Emery <Thierry.Emery@nmu.alcatel.fr>

* lisp/w3-display.el (w3-maybe-start-image-download): typo.
  (w3-handle-image): include row and column in hyperimage-info, to be used
  in `w3-resurrect-images'.
  (w3-resurrect-images): if `to-cut' gets negative, insert blanks.
  (w3-display-node): in case of a frameset, checks rows as well.
  (w3-frameset-dimensions-p): disregard anything containing "100%", such as
  "100%,0".
  (w3-display-frameset): Do not zap frameset-cardinal when computing
  default dimensions. Memorize next window before drawing a frame, as its
  HTML page may contain yet another (nested) frameset. Call `w3-warn' and
  inhibit splitting the window when there is not enough room left.

* lisp/mm.el (mm-parse-mailcap): Fix bad regexp for Emacs 21

1999-11-09  William M. Perry  <wmperry@aventail.com>

* build.bat: Make sure to build custom load files and info files.

* lisp/url-auth.el (url-register-auth-scheme): removed warning when
  replacing auth methods.

* lisp/url-file.el (url-file): Honor port numbers in ftp URLs.

1999-11-09  James LewisMoss  <dres@ioa.com>

* lisp/mm.el (mm-parse-mailcap): Fix invalid regular expressions caused by
  entries like "text/x-c++"

1999-11-09  Andrew Mazillius  <andrew_mazillius@pee.pioneer.be>

* lisp/socks.el (socks-nslookup-host): Make sure that we always call
  accept-process-output at least once.  Now deals correctly with multiple
  addresses returned by nslookup in the format 'Addresses: ip1, ip2, ip3'

1999-11-09  kyota@po.ntts.co.jp (Kyotaro HORIGUCHI)

* lisp/mule-sysdp.el: Patches to understand MULE 4.1

1999-11-09  Alexandre Guimond  <guim@guim.org>

* lisp/w3.el (w3-mail-document-author): Fix problem with 'Reply-To'
  headers.  They had not been converted to the (not quite so) new plist
  format.

1999-10-15  Dave Love  <fx@gnu.org>

* lisp/w3-parse.el (char-int): Alias it to `identity' if necessary.

1999-10-14  William M. Perry  <wmperry@aventail.com>

* lisp/url-ldap.el (url-ldap-certificate-formatter): Now uses
  ssl-certificate-information instead of hacked up bill-specific stuff.

* lisp/ssl.el (ssl-certificate-information): New function to get
  certificate information out of a DER encoded object.
  (ssl-program-name): Default to using OpenSSL now.

1999-10-11  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-fixup-eol-faces): only strip spaces off of
  newlines, not the surrounding shitepsace.  This makes colorized table
  cells look much better.

1999-09-16  Michael Sperber [Mr. Preprocessor]  <sperber@informatik.uni-tuebingen.de>

* lisp/url-cache.el:
* lisp/w3-display.el:
* lisp/w3.el: Added (require 'url-parse) because of the macros
  defined there.

1999-08-07  Bob Weiner  <weiner@beopen.com>

* w3-menu.el (w3-menu-make-xemacs-menubar): Fixed to work with
  BeOpen.com InfoDock.  Old code allowed multiple 'nil's to creep into the
  menubar which would cause a hang in the XEmacs menubar code.

1999-08-04  William M. Perry  <wmperry@aventail.com>

* lisp/url-cid.el (url-cid-gnus): Fixed so it will work in Emacs and
  XEmacs 21.2

1999-08-03  William M. Perry  <wmperry@aventail.com>

* lisp/mule-sysdp.el (mule-sysdep-version): Make
  enable-multibyte-characters buffer-local when in XEmacs, to better mimic
  the Emacs 20.x behaviour.

1999-07-19  William M. Perry  <wmperry@aventail.com>

* lisp/images.el (image-register-netpbm-utilities): Fixed typo in the ppm
  to xpm converter.

1999-06-27  William M. Perry  <wmperry@aventail.com>

* lisp/url-parse.el (url-generic-parse-url): Added in gross hack to
  preserve ';' in data URLs.  The usage as a separator for content-type
  and encoding-type clashes horribly with the ';' as an
  attribute-separator on normal URLs.

* lisp/w3-parse.el (w3-parse-hooks): New hook to be run just before
  parsing any document.  This can theoretically be used to rip out banner
  advertisements, etc.
  (w3-parse-munge-ethiopic-text): Moved the old ethiopic munging stuff
  into hook form.

* lisp/url-mail.el (url-mailto): Allow adding of more 'to' headers via the
  query interface for mailto URLs.  Would generate corrup To: headers
  otherwise.

1999-06-15  William M. Perry  <wmperry@aventail.com>

* lisp/url-ldap.el (url-ldap-attribute-formatters): Format naming contexts
  as hyperlinks back into the directory.
  (url-ldap-certificate-formatter): Save certificate data to a file.

1999-04-29  William M. Perry  <wmperry@aventail.com>

* lisp/font.el (font-find-available-family): Fixes for latest version of
  the new Emacs redisplay.

1999-04-08  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.43 released

* Fixed the hackmap stuff for Emacs 19/20

1999-04-08  Thierry Emery <Thierry.Emery@nmu.alcatel.fr>

* lisp/url-cookie.el (url-cookie-write-file): check
  `url-cookies-changed-since-last-save' and that the file is writable.
  (url-cookie-handle-set-cookie): set `url-cookies-changed-since-last-save'.

* lisp/url-http.el (url-create-mime-request): Moved Proxy Authorization up
  (before Cookie and Authorization).

* lisp/url-vars.el (url-cookies-changed-since-last-save): new variable.

* lisp/url.el (url-write-global-history): call `url-cookie-write-file' if
  `url-privacy-level' tolerates cookies.

1999-04-08  Thierry Emery <Thierry.Emery@nmu.alcatel.fr>

* lisp/w3-display.el (w3-resurrect-images): corrected regexp for
  removing trailing blanks from alt.

1999-04-05  William M. Perry  <wmperry@aventail.com>

* lisp/w3-forms.el (w3-form-keymap): Ditto for form fields.

* lisp/w3-display.el (w3-resurrect-hyperlinks): Hack around lossage in
  XEmacs' Widget package.  button3 was used to activate the widget instead
  of popping up a context-sensitive menu like everywhere else.

1999-04-03  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el: Make sure we load mule-sysdp at compile time.

1999-04-03  Thierry Emery  <Thierry.Emery@nmu.alcatel.fr>

* lisp/url-file.el (inline): require `w3-sysdp', necessary for
  `add-minor-mode' in Gnu Emacs when Emacs-W3 is autoloaded through
  `url-dired-find-file'.
  (url-insert-possibly-compressed-file): set `url-current-mime-encoding'.
  (url-dired-find-file): handle ange-ftp dired.
  (url-file-asynch-callback, url-file): call
  `url-insert-possibly-compressed-file' instead of
  `insert-file-contents-literally'.
  (url-file): compute `url-current-mime-type' and `viewer' from
  `uncompressed-filename'; specify extension for
  `mm-generate-unique-filename'.

* lisp/url.el (url-file-directly-accessible-p): call
  `url-host-is-local-p' and check that the file is not compressed.
  (url-generate-unique-filename-counter): new variable.
  (url-generate-unique-filename): use
  `url-generate-unique-filename-counter' to ensure that filenames are
  unique within an Emacs session.

1999-04-03  Thierry Emery  <Thierry.Emery@nmu.alcatel.fr>

* lisp/url.el (url-write-global-history): call
  `w3-write-explicit-encodings'.

* lisp/w3-cus.el (w3-explicit-encodings-file): new user option, which
  specifies where to save `w3-explicit-conversion-tree'.

* lisp/w3-vars.el: new variables
  w3-explicit-conversion-tree: Tree to hold explicit coding systems
  for URLs and their superdirs:
  ((hostN default-coding (dirN-1 default-coding (dirN-1-1 ...) ...) ...)
    ...),
  w3-explicit-encodings-changed-since-last-save: whether
  `w3-explicit-conversion-tree' needs saving.

* lisp/w3.el:
  w3-convert-code-for-mule: call `w3-recall-explicit-coding-system'
  after checking `w3-explicit-coding-system' and `mmcharset'.
  w3-reload-document: call `w3-record-explicit-coding-system'.
  w3-recall-explicit-coding-system, w3-find-explicit-coding-system,
  w3-record-explicit-coding-system, w3-add-explicit-coding-system,
  w3-write-explicit-encodings: new functions to perform retrieval and
  storage of user-specified (through C-u g `w3-reload-document')
  explicit coding systems.
  w3-do-setup: load `w3-explicit-encodings-file' if it exists.

1999-03-24  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.40 released

* lisp/url.el (url-do-setup): Always register the LDAP URL format.

* lisp/url-ldap.el (url-ldap): Deal with non-LDAP enabled emacsen better.

1999-03-22  Markus Rost <markus.rost@mathematik.uni-regensburg.de>

* lisp/w3.el (w3-fetch): Gracefully accept 'nil' as the URL.

1999-03-22  Martin Schwenke <Martin.Schwenke@cs.anu.edu.au>

* lisp/w3-sysdp.el (frame-parameter): This was not defined in 19.34.

1999-03-19  William Perry <wmperry@aventail.com>

* lisp/w3-parse.el (w3-parse-buffer): Make sure we restore the old syntax
  table when we are done parsing.

1999-03-18  Kenichi Handa <handa@etl.go.jp>

* lisp/w3.el (w3-viewer-filter): Do not create the 'output' buffer if the
  length of the string received by the filter is 0.  Evidently solaris
  sends an empty string to the filter when the process exits.

1999-03-18  "T. V. Raman" <raman@adobe.com>

* lisp/w3-display.el (w3-widget-echo): Use buffer-substring --rather than
  buffer-substring-no-properties when picking out the text under the
  current link.

  This is good for emacspeak because you can then tell while
  tabbing through a  page whether the link you just hit has
  been visited.

1999-03-02  SL Baur  <steve@xemacs.org>

	* lisp/docomp.el (byte-compile-dest-file): Disable munging.
	Building for XEmacs requires the usual semantics.

	* Makefile (EXTRA_SOURCES): Add BUGS.
	(ELCS): Add dummy w3-auto.elc.
	(PRELOADS): Add url-parse.el and cus-face.

1999-01-08  William M. Perry  <wmperry@aventail.com>

* lisp/docomp.el (emacs-build-autoloads): Only do the autoloads one way
  for Emacs or XEmacs.

1999-01-07  William M. Perry  <wmperry@aventail.com>

* build.bat: More tweaking of finding EMACSDIR automatically.

* lisp/w3-vars.el (w3-mode-map): Don't use read-kbd-macro

1999-01-05  William M. Perry  <wmperry@aventail.com>

* build.bat: Make sure that we build the autoload files under windows.
  Easier setting of the environment variables.  Also can now pass in
  EMACSDIR on the command line.

* lisp/docomp.el (byte-compile-dest-file): Downcase file names if we are
  in windows of any flavor.  Sometimes we get foo.EL instead of foo.el and
  we were just naming the output file foo.EL.elc
  (compile-it): Make sure we get *.EL from directory-files as well.
  (emacs-build-autoloads): Ditto.  %!@!ing windows file systems.
  (emacs-build-autoloads): Deal with Emacs or XEmacs way of rebuilding
  autoloads in lisp instead of relying on autoconf.  This will make
  everything much happier under windows.

1999-01-04  William M. Perry  <wmperry@aventail.com>

* Makefile.in (dotemacs): Wrap the require we stick into $(DOTEMACS) in a
  `condition-case' for people that share their setups between emacsen or
  machines with different installed packages.

* lisp/w3-forms.el (w3-form-encode-xwfu): Don't forget to deal with the
  new attributes if we are doing just a plain old form submission!

1999-01-04  Milan Zamazal <pdm@freesoft.cz>

* lisp/w3-forms.el (w3-submit-form): Correctly shorten the separator
  generated... was including too few characters.
  (w3-form-encode-helper): Added ability to specify additional attributes
  for the `file' input type so that we can keep track of the filename.
  (w3-form-encode-make-mime-part): Create content-disposition header
  instead of content-id and content-length
  (w3-form-encode-multipart/x-www-form-data): Use CRLF instead of just LF
  for separators.
  (w3-form-encode-multipart/x-www-form-data): Don't forget to add in the
  separator at the end of the message.

1998-01-04  William M. Perry  <wmperry@aventail.com>

* lisp/w3-forms.el (w3-form-encode-multipart/x-www-form-data): Better
  separator generation.

1999-01-04  Laurent Martelli <martelli@iie.cnam.fr>

* lisp/w3-hotindex.el: Added autoload statements.

1999-01-04  Kenichi Handa  <handa@etl.go.jp>

* lisp/Makefile.in (w3-auto.el): Generate w3-auto.el from
  auto-autoloads.el just build in the current directory.

1998-12-31  William M. Perry  <wmperry@aventail.com>

* lisp/font.el: Various mergings with the XEmacs distributed version of
  font.el.  Lots of byte-compile warnings squashed when not building with
  Emacs/W3.

1998-12-31  Jonathan Harris  <jhar@tardis.ed.ac.uk>

* font.el: Split font-family-mappings into X and mswindows-specific
  versions.  mswindows-font-create-[object|name]: Treat supplied size as a
  pointsize. Added underline and strikethru handling.

1998-12-30  William M. Perry  <wmperry@aventail.com>

* lisp/url.el (url-file-exists): If url-user is nil use anonymous ftp.
  (url-file-size): Ditto.

* lisp/w3.el (w3-find-this-file): Protect against sticking 'nil@' in the
  filename spec when we go to retrieve something.

1998-12-30  Milan Zamazal <pdm@pvt.net>

* lisp/url-auth.el (url-basic-auth): Make sure to use base64-encode-string
  instead of base64-encode to work with new Emacs/XEmacs that have native
  base64 encoding/decoding primitives.

1998-12-29  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre38 released

* lisp/url.el (url-file-attributes): use 'anonymous' instead of 'ftp' as
  the username if none specified.

1998-12-29  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

* url.el (url-file-attributes): If url-user is nil use anonymous ftp.

1998-12-29  William M. Perry  <wmperry@aventail.com>

* lisp/mule-sysdp.el (mule-detect-coding-version): Doh - make sure we
  don't blow up in XEmacs w/Mule when making sure we have a valid coding
  system.

* Emacs/W3 4.0pre37 released

* lisp/socks.el (socks-find-route): Fixed bug where we would not honor the
  '!' at the front of the regexp to mean _do_ redirect the connection.  I
  need to finish the socks-redirection-rules stuff sometime soon.

* lisp/mule-sysdp.el (mule-detect-coding-version): Put back in the
  ultra-anal checks to make sure that what detect-coding-region and
  friends find is actually a coding system.  Apparently the bug where
  bizarre combinations of CRLF and LF separators in a file make Emacs 20.3
  return a number as a coding system is back.  Bug reported to the Emacs
  maintainers.

1998-12-28  Milan Zamazal <pdm@freesoft.cz>

* lisp/mm.el (mm-possible-viewers): Don't reverse exact & wildcard when
  concatenating them.  Reason: `mm-mime-data' contains mailcap entries in
  the opposite order than they are in the mailcap file.  The function
  `mm-possible-viewers' should return found items in the opposite order
  again, so that the first viewer from the mailcap was invoked.  The patch
  ensures this.

* lisp/mm.el (mm-mime-data-default): New variable that holds all the
  defaults.  mm-mime-data now holds _only_ the user supplied viewers.

* lisp/mm.el (mm-mime-info): Give preference to things found in
  mm-mime-data (the user stuff) and then fall back onto
  mm-mime-data-default.

* lisp/url-http.el (url-parse-viewer-types): Apply both mm-mime-data and
  mm-mime-data-default when building the acceptable viewer list.

1998-12-28  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-prepare-buffer): Use an unwind-protect form
  around w3-draw-tree.  This means that even if something in the drawing
  causes an error, the buffer will still be thrown into w3-mode
  (w3-region): Make w3-region interactive and give it a doc string.
  (w3-pause): Mark the buffer as temporarily read-only, so that
  self-inserting keystrokes will signal an error, which will be caught and
  ignored by the condition-case.
  (w3-widget-buffer): New function to get the buffer a widget is in.
  (w3-widget-echo): Use it, since with Gnus, it is very likely that you
  will be in a different buffer when you are mousing around the rendered
  HTML.

* lisp/url-file.el (url-file): Modify the filename in the URL if we are
  actually visiting a directory without a trailing '/' or '\', and we do
  the auto-find of the index.html file.

* lisp/url.el (url-looks-like-html): New function that determines whether
  a document looks like HTML or not.  This is for ancient HTTP/0.9
  responses for things without a file extension (ie: /, /a/b/, etc)
  (url-retrieve-internally): Use it if we cannot find a content-type any
  other way.

* lisp/url-cid.el: Try to avoid compile-time-errors when gnus' mm-decode
  cannot be found.

1998-12-26  William M. Perry  <wmperry@aventail.com>

* lisp/url.el (url-expand-file-name): Make sure to normalize the 'default'
  value before we get to the point of bailing out if we get the empty
  string, otherwise the vector-ized version of the URL could sneak out,
  and the 'nil' default case would screw us too.

1998-12-26  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

* w3-display.el (w3-display-get-cookie): No buffer-file-name for "
  *cookie*" buffers.

1998-12-26  William M. Perry  <wmperry@aventail.com>

* lisp/base64.el: Added alias for base64-encode-string -> base64-encode
  and base64-decode-string -> base64-decode, for compatibility with
  Emacs/XEmacs with native base64 support.

* lisp/w3-about.el: Use base64-encode-string instead of base64-encode, for
  compatibility with Emacs/XEmacs with native base64 support.

1998-12-25  William M. Perry  <wmperry@aventail.com>

* lisp/url-ldap.el: New file to implement LDAP support ala RFC2255

* lisp/url.el (url-do-setup): Register the LDAP URL handler if the feature
  is present.

* Emacs/W3 4.0pre36 released

* lisp/url.el (url-default-expander): Make sure that we remove any query
  strings from the URL before we remove relative links.
  (url-remove-relative-links): Tack on a trailing '/' if necessary so that
  we don't fail any URL parsing tests on things like 'g/.', which should
  be normalized to just 'g/'

1998-12-24  William M. Perry  <wmperry@aventail.com>

* lisp/url-cookie.el (url-cookie-host-can-set-p): Fixed cookie
  vulnerability as described in
  http://www.paradise.net.nz/~glineham/cookiemonster.html

1998-12-23  Markus Rost  <markus.rost@mathematik.uni-regensburg.de>

* w3-menu.el (w3-menu-initialize-w3-mode-menu-map): Block also
  the global menubar entry [menubar mule].

1998-12-23  William M. Perry  <wmperry@aventail.com>

* lisp/w3-cus.el (w3-force-conversion-alist): Mixed mismatched custom type
  (w3-default-stylesheet): Ditto.
  (w3-html-errors-font-lock-keywords): Ditto.
  (w3-default-configuration-file): Ditto.
  (w3-modeline-format): Ditto.

1998-12-22  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre35 released

* lisp/w3-display.el (w3-get-default-color): Function to get the default
  foreground or background color, even if face-(fore|back)ground returns
  nil, which it does under Emacs fairly often.  We fall back to getting
  the colors out of the frame properties.  I think this is gross, but oh
  well.
  (w3-display-background-useless-p): Use it.
  (w3-display-foreground-useless-p): Use it.

* lisp/w3.el (w3-reload-document): Avoid using interactive spec 'Z', since
  it doesn't exist in older versions of Emacs (19.xx)

* lisp/w3-parse.el (w3-parse-buffer): Add ',' to the `whitespace' at the
  front of an attribute that we should skip over.  This is so that people
  can do horrible nasty things like <input type="foo", name="bar"> and
  still have it work.  Sometimes I feel so... unclean.

* lisp/url-news.el (url-check-gnus-version): Use gnus-continuum-version if
  at all possible.  This way I will never have to add another string-match
  to the list of acceptable versions (at least not until another 15
  releases of Gnus.

1998-12-22  Dave Love <d.love@dl.ac.uk>

* lisp/w3-display.el (w3-image-alt): Pay better attention to the alt
  specified by the document.  Don't try to special case the empty string
  so much.

1998-12-22  William Perry  <wmperry@aventail.com>

* lisp/css.el (css-parse): Wrap the calls to forward sexp in
  condition-case so that an invalid stylesheet does not completely choke.

1998-12-22  Milan Zamazal <pdm@pvt.net>

* lisp/w3.el (w3-replace-invalid-chars): Make sure we tell replace-regexp
  to be 'literal' so that somet hings in the invalid chars table don't
  signal an error (ie: S\\v was looking for the regexp quote match, etc)

1998-12-22  William Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-display-table): Backed out old change to use less
  space for borderless tables - it was screwing up spacing at the
  beginning of celles.

1998-12-22  Thierry Emery <Thierry.Emery@nmu.alcatel.fr>

* lisp/url.el (url-expand-file-name): Do not remove blanks from target
  anchors (#xxx).

1998-12-21  William M. Perry  <wmperry@aventail.com>

* lisp/docomp.el: If WIDGETDIR is not set, or set to `no', then scream and
  bitch and die, to avoid more arcane errors later on.
  (emacs-build-custom-load): Try to work around emacs19 that doesn't have
  cus-dep installed.

* lisp/w3.el (w3-fetch): Avoid use of with-current-buffer, since it
  doesn't exist in Emacs 19.xx
  (w3-convert-code-for-mule): Finished rename to mule-coding-system-p

1998-12-20  Bertil Askelid <bertil@ioc.net>

* lisp/w3-mouse.el: Don't bind mouse-movement unless w3-track-mouse is
  set.

1998-12-19  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre34 released

* lisp/mule-sysdp.el (mule-coding-system-p-version): Renamed and fixed
  mule-coding-system-p for non-MULE Emacs/XEmacs.

1998-12-18  Kenichi Handa  <handa@etl.go.jp>

* lisp/mule-sysdp.el (mule-coding-system-p-version): New function.
  (mule-coding-system-version): Use mule-coding-system-p-version.
  (mule-detect-coding-version): Likewise.
  (mule-invalid-char-coding-systems): Change iso-latin-1 to iso-8859-1.
  (mule-coding-system-with-invalid-chars): Check mule-sysdep-version
  for XEmacs.

* lisp/w3.el (w3-convert-code-for-mule): Use mule-coding-system-p-version.
  (w3-coding-system-for-mime-charset): Likewise.

1998-12-19  William M. Perry  <wmperry@aventail.com>

* configure.in: Ditto

* aclocal.m4: Added appropriate magic to run autoconf whenever aclocal.m4
  is modified.

1998-12-18  William M. Perry  <wmperry@aventail.com>

* lisp/Makefile.in: No longer include auto-autoloads.el and custom-load in
  the distribution.  We can rebuild it anywhere now.

* aclocal.m4 (AC_CHECK_CUSTOMLOADS): Use the new functions in the
  appropriate place.
  (EMACS_REBUILD_AUTOLOADS): Ditto.

* lisp/docomp.el (emacs-build-custom-load): New function to build
  custom-load.el under Emacs.
  (emacs-build-autoloads): Ditto for the auto-autoloads.el file.

1998-12-15  Kenichi Handa  <handa@etl.go.jp>

* lisp/Makefile.in (.el.elc): Set shell variable W3SRCDIR to $(srcdir).

* lisp/docomp.el (load-path): Check shell variable W3SRCDIR.

* lisp/w3.el (w3-convert-code-for-mule): Call
  mule-coding-system-with-invalid-chars.
 (w3-coding-system-with-invalid-chars): This function deleted.

* lisp/mule-sysdp.el (w3-mime-charset-coding-alist): Fix coding
  system for Mule.
  (mule-invalid-char-coding-systems): New variable.
  (mule-coding-system-with-invalid-chars): New function.
  (mule-write-region-no-coding-system): Fix argument of write-region for
  Mule 2.3.

1998-12-17  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre32 released

* lisp/font.el (font-x-font-regexp): Add a trailing dash to the
  font-regexp.  For some reason Emacs 19.xx under 95/NT sticks a trailing
  slash on the end.  This was the cause of the odd errors in
  font-spatial-to-canonical since it was getting an empty font object
  because the regexp failed to match.

1998-12-16  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el (w3-coding-system-for-mime-charset): Make sure the
  coding-system-p is defined before we use it.
  (w3-convert-code-for-mule): Ditto.

* Makefile.in (SUPPORTFILES): Now include 'BUGS' support file in the
  distributions.

1998-12-16  Simon Josefsson <jas@pdc.kth.se>

* lisp/mm.el (mm-parse-mailcaps): More protection against badly formed
  MAILCAPS variable.

1998-12-16  William M. Perry  <wmperry@aventail.com>

* lisp/w3-cus.el (w3-bullets): Fixed customization type for this option.
  Would lead to mismatches in customize buffers.  Ick!
  (w3-maximum-line-length): Ditto.

1998-12-08  Ken'ichi HANDA <handa@etl.go.jp>

* lisp/mule-sysdp.el (mule-detect-coding-version): Check that
  mule-sysdep-version is a number before comparing it to one.  Under
  XEmacs it is a symbol `xemacs'.

1998-12-03  William M. Perry  <wmperry@aventail.com>

* Updated all copyright dates and now specify that this _is_ a
  part of Emacs, since it soon will be.  Maybe.  If I get ambitious.  what
  are the odds posted in vegas?

* lisp/w3-display.el (w3-display-infer-contrasting-color): New function to
  chooise black or white as an appropriate color if the author of an HTML
  page was stupid enough to do something like: <body bgcolor="white"> (ie:
  not specifying the foreground color as well).  If this conflicts with
  the users foreground, the text used to be invisible.  Now it will be
  whichever contrasts best (black on mint cream, white on dark red, etc)
  (w3-display-node): If the foreground specified conflicts with the users'
  background, ignore it.
  (w3-display-node): If the background specified conflicts with the users'
  foreground, infer an appropriate foreground.

* Emacs/W3 4.0pre31 released

* configure.in (CIDFILE): Stop spitting out a warning about
  multipart/related stuff if we can't find Gnus at configure time.  We're
  hacking around it in a different way now.

* lisp/Makefile.in (URLSOURCES): Add url-cid.el into the definition via
  configure substitutions ONLY.  It will still get installed because we
  stick it in EXTRAS.  This means 1 extra file copy at install time, but
  who cares?  The file isn't that large.

* lisp/url-cid.el: New file to contain the content-id handling stuff,
  because we cannot compile this file unless we can find a very recent
  version of Gnus at compile time (without .emacs).

* etc/default.css: Use the newer @media tags instead of @x*emacs so that
  everything will work right with the new Emacs redisplay.

* lisp/css.el (css-active-device-types): Added new @media tags.
  multifont is now defined if the Emacsen we are running in can display
  multiple font families and sizes correctly (new emacs redisplay or
  XEmacs), and unifont if it cannot.

* lisp/font.el (font-set-face-font-new-redisplay): New function for
  dealing with the new Emacs redisplay font abstraction.  You can now beat
  the crap out of the new redisplay engine with Emacs/W3.  Ahh, feels like
  the heady old days of Lucid Emacs 19.10 and XEmacs 19.12.

1998-12-02  Simon Josefsson <jas@pdc.kth.se>

* lisp/mm.el (mm-parse-mailcaps): Deal gracefully with bad entries in the
  MAILCAP list, or it would bug out with things like 'file:' where it
  would try to open the current directory.

1998-11-29  William M. Perry  <wmperry@aventail.com>

* lisp/docomp.el (load-path): Append the GNUSDIR environment variable to
  the load-path, similar to how we deal with WIDGETDIR

* INSTALL: Document the new --with-gnus arguments.

* configure.in: Use AC_CHECK_GNUS and spit out appropriate warnings about
  cid URLS not working when appropriate.

* aclocal.m4 (AC_CHECK_GNUS): Try to find mm-get-content-id in mm-decode
  for newer gnus releases that can handle the content-id stuff.  Also
  added new configure switch '--with-gnus=/path/to/gnus/lisp/dir' to
  override this, similar to how the custom stuff works.

* lisp/url-misc.el (url-cid-gnus): Try to load mm-decode at compile time.
  (url-cid-gnus): Fixed some compilation warnings.

* lisp/url.el (url-cid): Ooops - forgot to add an autoload for url-cid

* Emacs/W3 4.0pre30 released

* lisp/url.el (url-do-setup): Duh, forgot to register the CID handler.
  Good thing lars was doing it too.

* Emacs/W3 4.0pre29 released

* lisp/url-misc.el (url-cid): New URL handler for dealing with content-id
  based references.  Able to be extended for different mail/news readers.
  Need to coordinate with Lars and Kyle on exactly how to determine which
  UA is invoking us, so we don't try and use Gnus functions when VM is
  giving us the data, etc.
  (url-cid-gnus): First implementation of CID retrieval for Pterodactyl
  Gnus.

* lisp/w3-display.el (w3-finalize-image-download): Make sure we call
  url-uncompress in w3-finalize-image-download, or content-id and data URL
  based images won't get uncompressed correctly.  Arguably this should be
  done in url-default-callback, but I'm not sure what that would fubar
  right now.

* lisp/w3-parse.el (w3-parse-buffer): Changed regexp for handling
  NET-enabling start tags to be not so restrictive.  I don't think this
  will have any negative side-effects

1998-11-28  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre28 released

1998-11-23  Thierry Emery <Thierry.Emery@nmu.alcatel.fr>

* lisp/mule-sysdp.el
  (w3-mime-charset-coding-alist): completed and reordered;
  (mule-detect-coding-version): removed MIME type parsing (already done in
  w3-sentinel) and moved use of w3-mime-charset-coding-alist to
  w3-coding-system-for-mime-charset;

* lisp/w3.el
  (w3-convert-code-for-mule): added call to w3-coding-system-for-mime-charset
  for handling specified MIME charset;
  (w3-coding-system-for-mime-charset): code moved from
  mule-detect-coding-version, which uses w3-mime-charset-coding-alist;
  (w3-sentinel): moved downcase of MIME type and charset to
  w3-convert-code-for-mule call arguments and generalized it to encoding;
  replaced hacking out "x-" in MIME charsets with proper reference to
  w3-mime-charset-coding-alist in w3-coding-system-for-mime-charset.

1998-11-20  Ken'ichi HANDA <handa@etl.go.jp>

* lisp/w3.el
  (w3-explicit-coding-system): new variable for user-specified coding system
  on C-u [w3-reload-document];
  (w3-convert-code-for-mule, w3-reload-document): added handling of
  w3-explicit-coding-system.

1998-11-24  Kenichi Handa  <handa@etl.go.jp>

* lisp/mule-sysdp.el (mule-sysdep-version): Check the mule version
  correctly.
  (mule-coding-system-version): New function.
  (w3-mime-charset-coding-alist): New variable.
  (w3-url-domain-language-environment-alist): New variable.
  (w3-url-domain-coding-alist): New variable.
  (mule-retrieval-coding-system): Call mule-coding-system-version.
  (mule-no-coding-system): Likewise.
  (insert-file-contents-literally): Re-define this function for Mule
  Ver.2.3.
  (mule-detect-coding-version): Pay attention to
  w3-mime-charset-coding-alist,
  w3-url-domain-language-environment-alist, and
  w3-url-domain-coding-alist.
  (mule-code-convert-region): Change argument to CODE only.  If
  default-enable-multibyte-characters is nil, does no code
  conversion.

* lisp/url-cache.el (url-store-in-cache): Write to a file with no
  code conversion.

* lisp/w3.el (w3-convert-code-for-mule): Call
  mule-code-convert-version with one arg CODING-SYSTEM.

1998-11-22  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre27 released

* lisp/w3.el (w3-mode): ditto

* lisp/w3-display.el (w3-display-node): Make sure we don't try to
  save/restore variables in w3-persistent-variables if they are not
  'boundp'

1998-11-20  Thierry Emery  <Thierry.Emery@nmu.alcatel.fr>

* lisp/mule-sysdp.el
  (mule-write-region-no-coding-system): added additional write-region arguments
  and protections moved from w3-download-callback.

* lisp/mm.el (mm-find-available-multiparts), lisp/url-cache.el
  (url-store-in-cache), lisp/w3-display.el (w3-display-get-cookie,
  w3-finalize-image-download), lisp/w3-latex.el (w3-show-dvi), lisp/w3-print.el
  (w3-print-this-url), lisp/w3.el (w3-save-as, w3-download-callback):
  use mule-write-region-no-coding-system.

* lisp/url-vars.el, lisp/url-http.el (url-parse-mime-headers): added
  url-current-mime-charset and url-mime-content-type-charset-regexp.

* lisp/w3-cus.el (w3-force-conversion-alist): new user option, alist of URL
  host/filename regexps and coding systems.

* lisp/w3-vars.el
  (w3-meta-content-type-charset-regexp, w3-meta-charset-content-type-regexp):
  new variables for parsing <META Content-Type...> tag;

  (w3-persistent-variables): added buffer-file-coding-system.

* list/w3.el
  (w3-mail-current-document): use buffer-file-coding-system or iso-8859-1;
  (w3-compression-encodings, w3-no-conversion-encodings): new variables used to
  inhibit conversion;
  (w3-convert-code-for-mule): removed regexp matching on
  w3-mime-list-for-code-conversion (replaced by downcase in w3-sentinel);
  (w3-sentinel): switch to other window if in minibuffer, handle specified
  charset (in MIME headers or META tag), handle w3-force-conversion-alist, hack
  out "x-" in MIME charsets.

1998-11-18  Kenichi Handa  <handa@etl.go.jp>

* Makefile.in (Makefile): Correct the dependency.  Execute
  config.status in the current directory.

* etc/Makefile.in (install): If a file is not in the current
  directory, install that file of the source directory.

* lisp/Makefile.in (w3-auto.el): Update target in the current
  directory.
  (auto-autoloads.el): Do the work in $(srcdir).
  (custom-load.el): Likewise.
  (install): If a file is not in the current directory, install that
  file of the source directory.

* lisp/docomp.el (byte-compile-dest-file): New function for
  writing out *.elc to the current directory.

1998-09-26  Gareth Jones  <gdj1@gdjones.demon.co.uk>

* lisp/w3-vars.el: defvar'ed w3-current-buffer.

* lisp/w3.el (w3-fetch): set w3-current-last-buffer for reused URLs.
  (w3-pass-to-viewer): set w3-current-last-buffer to w3-current-buffer.
  (w3-fetch): bind w3-current-buffer to (current-buffer).
	Make history work with url-be-asynchronous t.

1998-09-25  Gareth Jones  <gdj1@gdjones.demon.co.uk>

* lisp/w3-vars.el (w3-mode-map): Bind [backspace] to scroll-down.

1998-09-09  Gareth Jones  <gdj1@gdjones.demon.co.uk>

* lisp/w3-emulate.el (w3-lynx-emulation-minor-mode-map): Corrected C-f
  to be `scroll-up', added bindings for C-b, C-n and C-p.

* lisp/w3-cus.el (w3-latex-use-latex2e): Documentation fix.  LaTeX
  "generator" makes more sense than "parser".

* lisp/url.el (url-do-setup): ditto for url-cookie-file and
  url-global-history-file.

* lisp/url-cache.el (url-cache-directory): use w3-configuration-directory
  rather than hardwire "~/.w3/"

* lisp/url-news.el (url-nntp): fixed call to url-news-fetch-newsgroup with
  only one argument.
  (url-check-gnus-version): Added Pterodactyl Gnus to the list of
  acceptable Gnusen.

* lisp/url-mail.el (url-mailto): url-mailto would not handle %3F (`?')
  in addresses because url-unhex-string changed match-end.
  Added support for "body" hname.  Emit style warning for <mailto:/.*>.

1998-10-29  William Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-region): Make me autoloaded.

1998-10-28  William M. Perry  <wmperry@aventail.com>

* lisp/mule-sysdp.el (mule-code-convert-region): Try to avoid lossage when
  point-max changes due to a set-buffer-multibyte operation.

1998-10-28  Laurent Martelli <martelli@iie.cnam.fr>

* Patches to add hotindex support.  It's a patch to W3/Emacs allowing you
  to associate keywords to your  hotlist  entries.  You can then query
  for  the entries matching a keyword. I  did  this because  I find it
  hard  to find  a particular bookmark when  you more than  a hundred,
  even with hotlist-apropos. And I think  that folders and subfolders
  are not  very convenient because  an entry usually belongs to more
  than one folder.

1998-10-26  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre25 released

* lisp/w3-display.el (w3-get-all-face-info): Fixed stupid problem where
  w3-user-fonts-take-precedence was being used backwards!

* Emacs/W3 4.0pre24 released

1998-07-18  SL Baur  <steve@altair.xemacs.org>

	* lisp/w3-cfg.el: added to XEmacs distribution.

1998-06-22  William M. Perry  <wmperry@aventail.com>

* lisp/w3-cfg.el.in (w3-configuration-data): Allow the cdr of the assoc
  list to be something to be eval'd.  Allows things to work better under
  NT/95 Emacs/XEmacs without needing to do a 'configure' run.  See new
  file w3-cfg.nt.

* lisp/w3.el (w3-viewer-filter): Start showing output from the viewer
  program as soon as we get it instead of after it exits.  This allows
  viewers to spit out instructions on their use (ie: imageviewer under
  solaris says things like 'hit q to make the window disappear'.

* build.bat: Copy new w3-cfg.nt file over to w3-cfg.el before doing the
  compile for those NT/Win95 people.

Wed Jun 17 18:30:11 1998  Jonathan Harris <jhar@tardis.ed.ac.uk>

* lisp/font.el (mswindows-font-create-object): various mswindows fixes -
  please speak up if anything is broken!

1998-06-18  Stefan Hornburg  <racke@gundel.han.de>

* lisp/url-file.el (url-file): Fixed a regexp that should match drive
  letters.  This fixes a longstanding bug where efs/ange-ftp would get
  invoked instead of looking locally.

1998-06-13  William M. Perry  <wmperry@aventail.com>

* lisp/w3-hot.el (finish-submenu): Ignore empty strings when searching for
  sublist titles.  Reading netscape bookmark files works correctly again.

1998-06-12  William M. Perry  <wmperry@aventail.com>

* lisp/w3-xemac.el (w3-mouse-handler): Make sure we don't do anything if
  the current buffer is not the one our event is destined for.  Avoids
  some weird errors in XEmacs on corner cases w/mouse movement.

* lisp/w3-annotat.el: Removed some old variables - evidently nobody uses
  this shit any more. :)

* lisp/w3-menu.el (w3-menu-breakup): Moved into this file because it is
  where it belongs.  Also changed so that 'more...' menu items are spliced
  in at the end of the menu where they belong.
  All the filter menus should work under Emacs 20.3 now.
  (w3-popup-menu): No longer use 'popup-menu' - this removes the need
  under Emacs to (require 'lmenu), which caused lots and lots of problems
  with invalid macros, etc.

1998-06-10  William M. Perry  <wmperry@aventail.com>

* lisp/w3-menu.el (w3-menu-filters-supported-p): New variable to determine
  whether this flavor of Emacs supports the :filter keyword on
  menus.  Emacs 20.3 will support the :filter keyword, so lets use it.
  (w3-menu-go-menu): Use it.
  (w3-menu-bookmark-menu): Ditto.
  (w3-menu-html-links-constructor): Make this work with easymenu.
  (w3-menu-hotlist-constructor): Ditto.
  (w3-menu-links-constructor): Ditto.
  (w3-menu-e19-show-navigate-menu): Moved from w3-e19.el
  (w3-menu-e19-show-links-menu): Ditto.
  (w3-menu-e19-show-hotlist-menu): Ditto.

* lisp/w3-xemac.el (w3-store-in-clipboard): Make this work under mswindows
  devices.

1998-06-09  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el (w3-find-default-stylesheets): Use w3-configuration-data to
  slap the 'datadir' macro into the search path for stylesheets.

* lisp/w3-cfg.el.in: New file that will store information from the
  configure run for use later.
  (w3-configuration-data): New function to retrieve configure-time
  information later.

* lisp/url-vars.el (url-privacy-level): changed customization properties.

1998-06-08  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.pre21 released

* lisp/w3-parse.el (w3-parse-buffer): Better dealing with the
  sera-to-fidel stuff in MULE - and don't bother calling it when
  default-enable-multibyte-characters is nil for mule 4.x

* lisp/w3.el (w3-download-callback): Use
  mule-write-region-no-coding-system so that all the MULE variations are
  hidden within mule-sysdp.el, where they belong.

1998-06-05  Dave Love  <d.love@dl.ac.uk>

* lisp/mule-sysdp.el (mule-retrieval-coding-system,
  mule-no-coding-system, mule-detect-coding-version,
  mule-inhibit-code-conversion, mule-encode-string,
  truncate-string-to-width, mule-coding-system-name,
  mule-find-coding-system): Test for mule-sysdep-version == 4.0.
  (mule-code-convert-region, mule-make-iso-character): Test for
  mule-sysdep-version == 4.0.  Also test
  default-enable-multibyte-characters.
  (mule-truncate-string): Test for mule-sysdep-version == 4.0.  Use
  truncate-string-to-width in Emacs 20.

1998-06-04  William M. Perry  <wmperry@aventail.com>

* lisp/url-http.el (url-create-mime-request): New behaviour wrt
  url-mime-language-string - if it is nil, then no accept-language header
  will be sent.  This is to work around problem when dealing with apache -
  the old default of '*' would cause the server to return the first
  version of a document it could find (w3c site would typically send out
  danish or japanese) - definitely suboptimal.  I don't know how this will
  impact you MULE folks though - speak up!

* lisp/url-vars.el (url-mime-language-string): Better customization of
  this - new default value of nil.

1998-06-02  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.pre20 released

1998-06-02  Thierry Emery <Thierry.Emery@nmu.alcatel.fr>

* lisp/w3-display.el (w3-refresh-buffer): Try to stay as close to current
  point as we can when you do a refresh-buffer.

* lisp/w3-display.el (w3-display-table): Fix for Emacspeak table
  traversal that was broken by the new borderless table features.

* lisp/w3-display.el: Various fixes for alternate image text in tables.

1998-05-25  William M. Perry  <wmperry@aventail.com>

* lisp/w3-menu.el (w3-menu-options-menu): Fixed problem where newest
  easymenu (emacs 20.2.93) is a little pickier than before and dies on
  'nil' menu entries.

* lisp/mule-sysdp.el: Avoid setting enable-multibyte-characters directly
  under Emacs 20.3-to-be, since it is now a read-only variable.  Use
  set-buffer-multibyte instead.

1998-05-24  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre19 released

1998-05-01  SL Baur  <steve@altair.xemacs.org>

	* lisp/w3-xemac.el (w3-setup-version-specifics): Suppress adding
	"WWW" menu to the help menu if running InfoDock.

1998-04-17  T. V. Raman  <raman@Adobe.COM>

* lisp/w3-speak-table.el (w3-table-setup-keys): Base keymappings off of
  emacspeak-prefix, instead of hardcoded C-z.

1998-04-17  William M. Perry  <wmperry@aventail.com>

* lisp/: updated copyright statements, removed quite a few old files from
  the tree.

* lisp/xml.el: New way to parse XML documents using an external process
  and some new support tools based upon 'expat', the XML parser from James
  Clark.

* aclocal.m4 (AC_EMACS_PACKAGES): resurrected the --with-package-dir
  option.

1998-04-15  William M. Perry  <wmperry@aventail.com>

* configure.in: Changes to where it installs things by default, more
  GNUish now.  Need to think about how packages need to be done in
  autoconf more.

* lisp/w3-cus.el (w3): Put the 'url' group within the W3 group
  automatically.

* lisp/w3-menu.el (w3-menu-options-menu): Do customize-browse instead of
  w3-preferences-edit for Options->Edit Preferences menu item.

* lisp/docomp.el: Use w3-load-flavors and w3-setup-version-specifics in
  docomp.el, just to make sure everything works.

* lisp/w3.el (w3-load-flavors): Don't bitch about XEmacs being unsupported
  on windows anymore, because it is again!

* lisp/w3-xemac.el: Force loading of new widget/custom libraries on
  XEmacsen that are too old, but had them dumped in, so load-path munging
  doesn't do anything.

* lisp/socks.el: Added socks v4 support.  To do this I had to change how
  socks servers are defined - try the new customization support: C-u M-x
  customize [RET] socks to see what has changed.

* lisp/mule-sysdp.el (mule-sysdep-version): Try to deal with MBSK Emacs
  not really being mule, but still mostly lying about it.

* lisp/w3-speak-table.el: New file to actually take advantage of the new
  table structure.

* lisp/w3-display.el: Changes from Raman and Thierry for keeping track of
  table structure.

1998-04-13  William M. Perry  <wmperry@aventail.com>

* lisp/w3-parse.el (w3-parse-buffer): Wrap calls to sera-to-fidel-marker
  in a condition-case to avoid lossage on MBSK emacsen.

1998-03-08  Laurent Martelli <laurent@lolo.martelli.fr>

* lisp/w3-hot.el (w3-hotlist-rename-entry): Could select the wrong entry
  if one hotlist title was the same as the beginning of another one.

1998-03-07  William M. Perry  <wmperry@aventail.com>

* lisp/docomp.el: require lmenu during compiles, or Emacs 20.x will
  choke.

1998-03-07  Greg Stark <gsstark@mit.edu>

* lisp/w3-forms.el (w3-form-determine-size): Fix various misalignments in
  tables.

1998-02-22  William M. Perry  <wmperry@aventail.com>

* lisp/docomp.el (compile-it): This should now work in v19 emacsen, since
  they didn't support the 'files-only' final argument.

1998-01-29  Dieter Maurer <dieter@hit.handshake.de>

* lisp/mm.el (mm-parse-mime-headers): Handle continuation lines in headers

1998-01-29  William M. Perry  <wmperry@aventail.com>

* lisp/socks.el: Fixed various int vs. char problems, made the error
  reporting a little clearer that they were actual errors from the SOCKS
  server, not necessarily the ultimate destination.

1998-01-28  William M. Perry  <wmperry@aventail.com>

* lisp/url-cookie.el (url-cookie-handle-set-cookie): Allow
  url-privacy-level == paranoid to deny all cookies.

1998-01-27  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el (w3-download-url): Fix in the case where a filename is passed
  in - was calling the callback with the wrong # of arguments.

1998-01-20  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre14 released

* lisp/w3-toolbar.el (w3-toolbar-make-buttons): Don't die horribly if you
  cannot make the toolbar buttons - this made TTY XEmacs 20.5beta +
  Emacs/W3 choke big time.  all better now.

1998-01-09  William M. Perry  <wmperry@aventail.com>

* lisp/w3-parse.el (w3-parse-buffer): Don't use insert-char for SGML
  entities, because with the new MULE replacements for stupid windows
  character sets, some of them are no longer single characters.

1998-01-06  Laurent MARTELLI  <martelli@iie.cnam.fr

* lisp/w3-menu.el (w3-menu-search-menu): Added 'ftp search' at
  http://ftpsearch.ntnu.no/home.html to the search menu.

1998-01-06  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre13 released

* lisp/url-http.el (url-create-mime-request): Added better protection
  around calls to getting proxy authentication when we aren't really
  proxying anything.

* lisp/w3-hot.el (w3-hotlist-refresh): Make sure w3-do-setup has been
  run.

* lisp/url-http.el (url-create-mime-request): Fixed proxy authentication
  and excessive prompting

1998-01-05  William M. Perry  <wmperry@aventail.com>

* lisp/w3-menu.el (w3-menu-make-xemacs-menubar): Fixed problem where
  XEmacs would never install the 'buffers' menu
  (w3-menu-install-menubar): Fixed test for whether to initialize the
  menubar.

1998-01-05  Laurent Martelli <laurent@iie.cnam.fr>

* lisp/w3-cus.el (w3-defined-link-types): Added 'contents' and 'top' from
  the HTML 3.2 reference spec to the predefined sets of <LINK> types.

1997-12-31  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre12 released

1997-12-29  William M. Perry  <wmperry@aventail.com>

* lisp/Makefile.in: don't remove the old custom-load.el and
  auto-autoloads.el, so that people using Emacs 19/20 can muck with the
  source and not destroy the autoloads in the process.

1997-12-26  William M. Perry  <wmperry@aventail.com>

* lisp/url-misc.el (url-do-terminal-emulator): Removed extra ')' DUGH!

1997-12-25  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre11 released

* lisp/url.el (url-lazy-message): Don't show messages if there is an
  active minibuffer window.

* lisp/Makefile.in (w3-auto.el): removed use of $^ macro, since some SYSV
  machines seem to croak on it.

1997-12-24  Ching-Mo Chang  <chang@wsu.edu>

* lisp/url-file.el (url-file): fix for stripping out leading '/' from
  local filenames under OS/2.

1997-12-24  William M. Perry  <wmperry@aventail.com>

* lisp/url-misc.el (url-do-terminal-emulator): Fixed for the case where
  the user was not specified (vast majority)

* lisp/w3.el (w3-save-as): Don't double latex output

* lisp/w3-parse.el (w3-parse-buffer): Deal with comments slightly
  differently - on large documents, we could hit a stack overflow in the
  regexp engine.

* lisp/css.el (css-expand-value): default to using :normal for unknown
  weights, not :bold.

1997-12-24  Vladimir Alexiev <vladimir@cs.ualberta.ca>
* lisp/w3-xemac.el: Compatibility stuff for XEmacs 19.13

1997-12-24  William M. Perry  <wmperry@aventail.com>

* lisp/w3-forms.el (w3-form-determine-size): If someone specifies a 'size'
  of 0 for a form element, bring sanity back to the world.

* lisp/w3-cus.el (w3-display-frames): Changed default to 't' to
  automatically display frames.

* lisp/w3-parse.el: Added nobr tag to %special - it should parse fine
  now.

* lisp/socks.el (socks-override-functions): New variable to control
  whether or not to overwrite the builtin open-network-stream function
  with one of our own.

* lisp/font.el: Added explicit require of disp-table, so we will work with
  older XEmacsen.

* lisp/w3-style.el (w3-display-stylesheet): Default to using
  w3-user-stylesheet if w3-current-stylesheet is not set yet (ie: no page
  loaded in current window).  Also throws an error if none of those are
  defined yet.

1997-12-22  Michael Ernst <mernst@cs.washington.edu>

* url.el (url-get-url-at-point): Strip surrounding parens from a
  potential URL.

1997-12-22  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-pause): Use a dedicated variable instead of
  coopting cur-viewing-pos, to protect against errors.

1997-12-22  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* w3-parse.el: Deal with invalid SGML characters in mule better.

1997-12-22  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.pre10 released

* lisp/w3-parse.el (w3-parse-buffer): Make sure we expand the 'background'
  tag, so stylesheets created after mucking with the <body> attributes
  will work correctly.

* configure.in: Disable caching of configure results - I've become
  convinced this is the right thing to do.

* Makefile.in (install): Don't automatically hack up someone's .emacs file
  - make them explicitly do a 'make dotemacs'

* configure.in: Moved some of the --with-FOO stuff into aclocal.m4 and the
  appropriate AC_DEFUN macros, where they belong.

* aclocal.m4 (library): Fixed setting of package directory (typo).

1997-12-04  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* lisp/w3.el (w3-mail-current-document): ditto.

* lisp/w3-display.el (w3-maybe-start-image-download): ditto.

* lisp/url.el (url-insert-file-contents): protects url-be-asynchronous
  against elisp errors in code sections where its default value is
  temporarily modified.

1997-11-27  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.pre9 released

1997-11-27  Cord Kielhorn <kielhorn@thphy.uni-duesseldorf.de>

* lisp/w3-hot.el (w3-grok-html-bookmarks-internal): Some fixes for HTML
  hotlists in xmosaic hotlist format 3

1997-11-27  William M. Perry  <wmperry@aventail.com>

* lisp/w3-cus.el (w3-delay-image-loads): Default to not loading images if
  this version of Emacs does not support any image formats other than XPM
  or XBM.

1997-11-20  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-resurrect-hyperlinks): Keep track of start and
  end of the widget, since widget-convert-text doesn't appear to.
  (w3-display-node): Keep track of :visited and :active faces for
  hyperlinks.
  (w3-follow-hyperlink): Apply the :visited face to a widget after we
  fetch it.

1997-11-20  Thierry Emery  <Thierry.Emery@aar.alcatel-alsthom.fr>

* lisp/w3-display.el (w3-display-node): more frames work

1997-11-07  William M. Perry  <wmperry@aventail.com>

* lisp/css.el (css-expand-length): Fixed percentages in css-expand-length

1998-01-25  SL Baur  <steve@altair.xemacs.org>

	* lisp/auto-autoloads.el: Restore to ease dependencies.

1998-01-24  SL Baur  <steve@altair.xemacs.org>

	* Makefile (VERSION): Update to package standard 1.0.

1997-11-05  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0.pre8 released

* aclocal.m4 (elisp): Use a temporary file for elisp configuration tests,
  to avoid weirdness that gets shoved to stdout/stderr by the various
  emacsen.

* lisp/w3-cus.el (w3-image-mappings): Use imagick for everything if XEmacs
  was compiled with it.

* lisp/w3-display.el (w3-maybe-start-image-download): Protect against bad
  instantiation of glyphs of already loaded images.

1997-11-04  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* Support relative frameset dimensions (ie: "2*,*")

* Fixed problem with doubling or tripling of image 'alt' text for images
  in tables.

1997-11-03  William M. Perry  <wmperry@aventail.com>

* aclocal.m4 (elisp): Simplified version of AC_EMACS_VERSION that just
  uses AC_EMASC_LISP to print out emacs-major-version . emacs-minor-version

1997-10-28  William M. Perry  <wmperry@aventail.com>

* lisp/url-cookie.el (url-cookie-parse-file): Fixed autoload cookie (hah)

1997-10-27  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre7 released

1997-10-27  Jens-Ulrik Holger Petersen  <petersen@kurims.kyoto-u.ac.jp>

* url.el (url-retrieve-internally): Ensure that coding system for
  the url buffer is set to no-conversion.

1997-10-23  William M. Perry  <wmperry@aventail.com>

* aclocal.m4: Fixed detection of how to rebuild custom-loads.el and
  auto-autoloads.el

1997-10-23  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* lisp/w3-display.el lisp/w3-widget.el: Lots of fixes for images.
  image hyperlinks are active, even when inside tables (thanks to a
  w3-hyperimage-info text-property, a content for w3-resurrect-images
  and the fact that :href and :target info are now passed on down to
  the children widgets),

  a face can be specified in the stylesheet, which will be used for
  the `alt' tags, e.g.:
  img:link    { color: goldenrod  }
  img:active  { color: goldenrod  }
  img:visited { color: firebrick  }

  the `alt' tag of image maps is displayed, to ease visual
  recognition,

  when the `alt' tag is "" and w3-auto-image-alt is non nil,
  an `alt' tag is made from the image src file basename. (WMP change)

1997-10-20  Ching-Mo Chang  <chang@wsu.edu>

* lisp/url-file.el (url-host-is-local-p): recognize XXX:/ as local file
  under NT/Win95/OS2.

* lisp/url-cache.el (url-cache-extract): replace 'os2' with 'emx' when
  comparing system-type.

* lisp/w3-e19.el (w3-store-in-clipboard): Deal gracefully with
  interprogram-cut-function being bound, but nil - we should fall back to
  the device-specific stuff, not just do nothing.

1997-10-20  William M. Perry  <wmperry@aventail.com>

* texi/w3-faq.txi (Runtime FAQ): New FAQ about Mule 20.x and \201 in front
  of everything.

1997-10-17  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 4.0pre6 released

* lisp/images.el (image-register-netpbm-utilities): Don't automatically
  dither PNM/PPM files to 256 colors when converting to XPM - its not
  necessary.

1997-10-17  Colin Rafferty <craffert@ml.com>

* lisp/url-auth.el (url-auth-user-prompt): New function to create a pretty
  prompt that shows the realm or URL that the user should be
  authenticating to.

1997-10-17  William M. Perry  <wmperry@aventail.com>

* contrib/w3-imenu.el: New version of w3-imenu for the contrib directory.

* Emacs/W3 4.0pre5 released.

* lisp/w3.el (w3-find-default-stylesheets): Should now find the stylesheet
  much more often given the new directory layout under Emacs 19.x & 20.x

* lisp/Makefile.in (custom-load.el): Automatically rebuild auto-autoloads
  and custom-load.el if any of the source files have changed.  configure
  now auto-detects how to rebuild them.

Fri Oct 17 06:27:07 1997  William M. Perry  <wmperry@aventail.com>

* lisp/url-cookie.el: autoload url-cookie-parse-file

1997-10-16  William M. Perry  <wmperry@aventail.com>
* lisp/w3-display.el (w3-insert-terminal-char): better handling of HR
  within borderless tables

* lisp/w3-parse.el (w3-p-s-entity): Don't cons up a string just to insert
  a single character.

* lisp/w3-display.el (w3-display-line-break): 2.3 Mule's char-before requires
  the 'pos' argument, so always send in (point).

* lisp/w3-display.el (w3-dingbats): don't crap out in mule 2.3

* lisp/w3.el (w3-find-default-stylesheets): Make finding no stylesheets a
  fatal error.

1997-10-15  William M. Perry  <wmperry@aventail.com>

* configure.in: Deal with EMACS="t", so you can now configure Emacs/W3
  from within an emacs shell buffer.

1997-10-13  William M. Perry  <wmperry@aventail.com>

* lisp/w3-toolbar.el (w3-toolbar-make-buttons): Default to using text only
  buttons if w3-toolbar-icon-directory doesn't exist (or is nil if
  locate-data-directory fails)

1997-10-04  SL Baur  <steve@altair.xemacs.org>

* lisp/w3.el (w3-find-default-stylesheets): Use `locate-data-directory' if
  it exists.

* lisp/w3-toolbar.el (w3-toolbar-make-buttons): Use `locate-data-directory'
  if it exists.

1997-10-03  William M. Perry  <wmperry@aventail.com>

* texi/Makefile.in (install): Ignore errors from the installinfo stage.

1997-10-02  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el: Added autoload for w3-version

* texi/Makefile.in (install): Don't global when doing install-info

1997-09-30  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el (w3-map-links): Use the exposed widget-map-buttons function,
  since XEmacs no longer uses overlays for its internal representation of
  widgets.

1997-09-29  William M. Perry  <wmperry@aventail.com>

* lisp/url-news.el (url-news-version-too-old): Deal with quassia gnus

1997-09-25  William M. Perry  <wmperry@aventail.com>

* lisp/url-news.el (url-format-news): Use 'gnus-article-display-hook
  instead of manually calling gnus-article-hide-headers
  (url-format-news): Also bind gnus-article-current, because some hooks
  might need to use it.

1997-09-22  William M. Perry  <wmperry@aventail.com>

* lisp/url-ns.el (url-ns-prefs): Can now parse a netscape preferences.js
  file and query items out of it.

1997-09-19  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.105 released

* Removed the custom and widget libraries from the distribution.

* configure.in, aclocal.m4: Lots of changes and additional macros for
  detecting features in Emacs Lisp.  New way of detecting acceptable
  widget/custom combinations, and warnings about where to go to get the
  newest version.

1997-09-16  William M. Perry  <wmperry@aventail.com>

* Updated to Widget/Custom 1.9958

1997-09-16  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* lisp/w3-display.el, lisp/w3.el: Better frame navigation -- 'q','l', etc
  should now back up by framesets, not just by single buffers.

Sat Sep 13 16:26:47 1997  Istvan Marko <istvan@cmdmail.amd.com>

* lisp/w3-mouse.el (w3-follow-inlined-image): Fixed
  w3-follow-inlined-image

Thu Sep 11 15:17:27 1997  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el: Go back to creating the 'nil' face all the time,
  even in Emacs - otherwise ps-print chokes.

1997-09-10  William M. Perry  <wmperry@aventail.com>

* lisp/w3-parse.el (w3-parse-buffer): Latest Emacs 20.x has renamed the
  sera-to-fidel-marker function to ethio-sera-to-fidel-marker, so we were
  losing on ethiopic texts.

1997-09-05  William M. Perry  <wmperry@aventail.com>

* Makefile.in: Now includes the 'contrib' directory in distributions.

* aclocal.m4: Fixed custom detection - would sometimes set CUSTOM to the
  directory, sometimes to the filename... ick.

* Makefile.in (dotemacs): Tweaked the install of autoloads into .emacs file

* lisp/font.el (font-normalize-color): Ditto

* lisp/url.el (url-setup-privacy-info): Ditto

* lisp/devices.el: Everything now recognizes 'w32' as an alias for the
  'win32' device type.  This is for Emacs 20.x compatibility, which will
  have this change.

1997-09-04  William M. Perry  <wmperry@aventail.com>

* Updated to Widget/Custom 1.9956

1997-08-25  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el (w3-document-information): Fixed bug with empty 'meta' links.

1997-08-20  William M. Perry  <wmperry@aventail.com>

* lisp/w3-menu.el ((fboundp 'id-menubar-set)): Avoid fset'ing
  id-menubar-set - it was confusing oobr

1997-08-19  William M. Perry  <wmperry@aventail.com>

* New file w3-imenu.el from T.V. Raman <raman@adobe.com>

1997-08-15  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.102 released

* lisp/Makefile.in: Fix for some buggy makes that didn't like my very long
  substitutions on the SOURCES macro.

1997-08-14  Roland McGrath <roland@ai.mit.edu>

* lisp/md5.el (md5): protect kill-buffer from getting already dead buffers
  by using 'buffer-name'

1997-08-12  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-display-nil-face): Don't make the 'nil' face
  under Emacs 19.

* lisp/wid-edit.el (widget-before-change): Allow inhbit-read-only to
  override the before-change checks for if we are at a widget or not.

* lisp/cus-face.el: Path to make cus-face.el play nice with
  emacs 19 without X support.

* lisp/w3-e19.el (w3-mode-version-specifics): Dont' do read-only

1997-08-10  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* lisp/w3-display.el: Patch for frames on TTY devices.

1997-08-08  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el (w3-table-ascii-border-chars): Back to more
  rectangular ascii art for table borders.

* lisp/socks.el (socks-find-route): Allow negation of regexps by
  prepending a ! to them for a 'proxy if they match' type rule.  The whole
  configuration of this module needs to change.

1997-08-08  Istvan Marko <istvan@cmdmail.amd.com>

* lisp/url-misc.el (url-proxy): Fix for all proxy access.

1997-08-08  William M. Perry  <wmperry@aventail.com>

* lisp/w3-display.el: Fixed compilation problems under Emacs 20.x that had
  to do with char tables and such.

* lisp/w3-e20.el (w3-e20): Added provide statement for this file - duh.

1997-08-07  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.98 released

* Synch'd up to custom 1.9954

Thu Aug  7 08:16:Denys Duchier <Denys.Duchier@ps.uni-sb.de>

* lisp/w3-display.el (w3-widget-echo): Use
  buffer-substring-no-properties for w3-widget-echo to avoid spurious
  'attempt to change text outside editable field' errors.  Is this needed
  with the new custom?  Doubtful, but its still a good idea. (wmp)

Fri Aug  1 06:00:02 1997  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* w3-display.el: take into account hierarchical framesets in a same page
  and discards useless "*" values for cols or rows.

Sun Jul 27 18:43:41 1997  William M. Perry  <wmperry@aventail.com>

* configure.in: Added --with-lispdir configure option.

* lisp/url-misc.el (url-proxy): Strip out "#foo" anchors in proxy requests

* configure.in: Fixed guessing of .emacs location to work in shells where
  ~/ is not expanded.

1997-07-26  SL Baur  <steve@altair.xemacs.org>

* mm.el (mm-extension-to-mime): Use `eq' for character comparison.

Sun Jun 29 22:26:43 1997  William M. Perry  <wmperry@aventail.com>

* lisp/w3-emulate.el: Make sure we call widget-button-press not w3-follow-link

* configure.in: New --enable-site-install option to control whether init
  code goes in user's .emacs file or default.el

* Makefile.in (dotemacs): New target for modifying the user's .emacs file
  or the sitewide default init.
  (html): New target for building html versions of the manuals.

Fri Jun 27 21:08:24 1997  William M. Perry  <wmperry@aventail.com>

* texi/Makefile.in (%.html): Added targets for making HTML versions of the
  info files.

1997-06-27  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el: In non-XEmacs, the version-specific stuff is loaded from
  (format "w3-e%d" emacs-major-version), in case we need to do anything
  special for Emacs 20.x with Mule support.

* Only use one conditionalization variable - w3-running-xemacs

1997-06-26  William M. Perry  <wmperry@aventail.com>

* Makefile.in: Make sure we recursively make usin $(MAKE), not
  vanilla 'make'.

* lisp/w3.el (w3-insert-formatted-url): Works again, forgot to update it
  to use the new widget properties.
  (w3-maybe-follow-link): Ditto.
  (w3-view-this-url): Ditto.
  (w3-follow-link): Ditto.
  (w3-complete-link): Ditto.

Wed Jun 25 07:29:46 1997  William M. Perry  <wmperry@aventail.com>

* lisp/w3.el (w3-find-default-stylesheets): Added more directories to the
  stylesheet search path.

* Emacs/W3 3.0.92 released

* Moved lisp stuff into its own subdirectory, integrated into configure,
  make, and install procedures.

* Makefile.in (Makefile): Ditto

* texi/Makefile.in: Automatically rebuilds out-of-date Makefiles

* configure.in: Make sure we create texi/Makefile

* w3-display.el (w3-table-ascii-border-chars): Slightly nicer rounded
  edges for ascii borders on tables.

Tue Jun 24 14:35:05 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.91 Released

* Moved texinfo stuff into its own subdirectory, integrated into
  configure, make, and install procedures.

* url-file.el: Visiting directories with an index file works in asynch
  mode now.

* docomp.el (cl): Load cl during builds

* w3.el (w3-find-default-stylesheets): Added more directories to the
  stylesheet search path.
  (w3-do-setup): Make sure we don't infinitely recurse if we are using
  html bookmarks.  w3-parse-hotlist could call w3-parse-buffer, which will
  call w3-do-setup if we don't set our global flag as 't'.

* Makefile.in (SOURCES): Some reordering to make the stupid thing at least
  compile with Emacs 19.

Tue Jun 24 11:44:59 1997  Per Abrahamsen  <abraham@dina.kvl.dk>

* w3.el (w3-mode): Avoid calling the global bindings for RET and mouse-2.

1997-06-24  William M. Perry  <wmperry@aventail.com>

* Synch'd up to custom/widget 1.9936

* Emacs/W3 3.0.90 released

* Moved the documentation into its own subdirectory

* w3-menu.el: Slightly less complete version of id-menubar-set when not in
  InfoDock - was causing lots of errors in XEmacs when trying to run a
  non-existent hook.  Bleah.

* configure.in: Fixed AC_CHECK_PROG for emacs/xemacs - duh.

* aclocal.m4: Don't check custom sanity if it was specified on the
  configure line

1997-06-23  William M. Perry  <wmperry@aventail.com>

* url-file.el (url-file): Make sure we set the content-type when loading
  files.  Was screwed when we were asynch.

* Upped planned release # to 4.0

* Emacs/W3 3.0.89 released.

* configure.in: Fixed --with-x*emacs switches.

* Emacs/W3 3.0.88 aborted.

* w3-display.el (w3-display-node): deal with empty selections

* Now uses autoconf to deal with all configuration issues, including
  sanity checking the installation of the custom and widget libraries.

Mon Jun 23 17:08:55 1997  Per Abrahamsen  <abraham@dina.kvl.dk>

* w3.el (w3-mode): Don't call `widget-minor-mode'.

* w3-vars.el (w3-mode-map): Use `make-sparse-keymap'.
  Use `widget-keymap' as parent.
  (wid-edit): require.

Mon Jun 23 07:09:51 1997  William M. Perry  <wmperry@aventail.com>

* w3-parse.el (w3-parse-buffer): Make sure we always have a newline at the
  end of the buffer before starting the parse.

Fri Jun 20 11:23:28 1997  William M. Perry  <wmperry@aventail.com>

* Synch'd up to Widget 1.9929

* w3-mouse.el: Deal with InfoDock button bindings - we don't need to bind
  _anything_ since hyperbole knows all about hyperlinks and stuff.

* w3-menu.el (w3-menu-install-menubar): Deal with InfoDock way of
  specifying mode menubars.

* w3-toolbar.el (w3-add-toolbar-to-buffer): Don't install the toolbar
  under InfoDock - it uses different toolbars than straight XEmacs.

* w3-mouse.el: Don't bind shift-button2 - this is reserved for hyperbole.
  This is now on meta.

1997-06-19  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-map-links): Deal with new keywords.

* w3-menu.el (w3-menu-links-constructor): Deal with new keywords on
  links/images.
  (w3-popup-menu): Ditto.

* w3-display.el (w3-widget-echo): Deal with new keywords we use on widgets.
  (w3-follow-hyperlink): Ditto.
  (w3-balloon-help-callback): Ditto.
  (w3-maybe-start-image-download): Ditto.
  (w3-handle-image): Use new keywords.
  (w3-display-convert-arglist): New function to convert an assoc list into
  a property list with real CL-style keywords.
  (w3-display-node): Use it when building a hyperlink.
  (w3-resurrect-hyperlinks): Now uses widget-convert-text instead of nasty
  knowledge of internals of the widget library.

Tue Jun 17 21:45:06 1997  William M. Perry  <wmperry@aventail.com>

* custom-check: Was misusing 'tr'

Sun Jun 15 22:17:01 1997  William M. Perry  <wmperry@aventail.com>

* Synch'd up to custom 1.9920

Sat Jun 14 15:37:09 1997  William M. Perry  <wmperry@aventail.com>

* Synch'd up to custom 1.9918 - now distribute all of custom, just to be
  anal.

* w3-display.el (w3-display-line-break): Ebola vaccination
  (w3-maybe-start-background-image-download): Don't try to load background
  images in Emacs 19 or on a TTY.
  (w3-display-node): Keep track of the active face of a hyperlink.  Need
  to make the widget library smarter about this.

Fri Jun 13 22:16:59 1997  William M. Perry  <wmperry@aventail.com>

* w3-parse.el:  Some stupid sites put meta tags in the middle of their
  documents.  Sigh. Allow it, but bitch and moan.

* Added custom library to the distribution.

1997-06-11  William M. Perry  <wmperry@aventail.com>

* w3-parse.el : Allow <meta> tags in %body.content for stupid cnn.com
  site.

* Emacs/W3 3.0.87 released.

* Synched up to Widget 1.9907 - you must be running this version for most
  things to work.  Make sure you are not picking up a widget library from
  gnus or something like that before the one in the w3 directory.

* w3-display.el (w3-maybe-start-background-image-download): New function
  that takes a URL and a face and does its best to set the background
  pixmap of that face to the image pointed to by the URL.
  (w3-display-node): Implemented 'background' property on 'body' or 'html'
  tags.
  (w3-finalize-image-download): Changed a fair bit - shared between normal
  image downloads and background image downloads.
  (w3-display-node): w3-user-colors-take-precedence now controls whether
  background faces are retrieved or not.
  (w3-face-for-element): Stylesheets use of background-image should almost
  work now.
  (w3-display-node): Stylesheets use of background-image should work
  completely now.

Tue Jun 10 07:24:09 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-only-links): This will now use w3-map-links
  (w3-mode): Dont' set inhibit-read-only, ever.
  (w3-mode): back to using widget-minor-mode, since inheriting the keymap
  doesn't seem to do much good.

* w3-vars.el: Don't bind anything to widget-button-press, let
  widget-minor-mode do that.

* w3.el (w3-map-links): Revamped this to work with the new way widget is
  using overlays instead of text properties.
  (w3-mode): Use widget-minor-mode instead of binding a lot of
  navigational commands ourselves.

* w3-display.el: Make sure we don't try to redefine the w3-dingbats
  character set when loading this file more than once.
  (w3-display-node): Rearranged some of the insert-before handling so that
  any text inserted does _not_ have the properties of the tag on it
  (colors on hyperlinks won't bleed anymore)
  (w3-resurrect-hyperlinks): New semi-working way of resurrecting
  hyperlinks

Mon Jun  9 22:53:14 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-node): Protect against stylesheet specified
  widths on horizontal rules.

Mon Jun  9 22:42:26 1997  Istvan Marko <istvan@cmdmail.amd.com>

* w3-hot.el (w3-hotlist-apropos): Let this work when reuse-buffers != no

Mon Jun  9 22:35:04 1997  Dieter Maurer <dieter@hit.handshake.de>

* mm.el (mm-decode-quoted-printable): Fix for some multipart attachments
  showing up empty due to badness in mm-decode-quoted-printable and
  'ignore' not moving to the end of the region just decoded.

Mon Jun  9 22:35:04 1997  William M. Perry  <wmperry@aventail.com>

* w3-parse.el (w3-parse-buffer): Call w3-do-setup to make sure our
  hashtables and things are set up correctly or gnus can choke big time.

Mon Jun  9 22:26:29 1997  Michael Ernst <mernst@cs.washington.edu>

* url.el (url-get-url-filename-chars): Fixed problem with bad use of a
  hyphen in the regexp.  Would cause problems when invoking
  url-get-url-at-point when point was in front of a hyphen.

1997-05-28  William M. Perry  <wmperry@aventail.com>

* w3-cus.el: Use a :prefix on most of the groups to make the options look
  nicer.

Thu May 15 05:06:30 1997  William M. Perry  <wmperry@aventail.com>

* w3-sysdp.el: removed bogus definition of buffer-substring-no-properties
  - will now use the more correct one that was already there.

* w3-display.el (w3-pause): Now has its own mini-event loop to pass off
  scrolling commands, etc.  Keeps buffer position constant while doing
  incremental display.

Mon May 12 08:13:27 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-view-this-url): Check the parent widget for an href if you
  don't find one right away.  This means that all commands that act on the
  URL at point will now work on image widgets, etc. that are hyperlinks.

Sat May 10 14:37:25 1997  William M. Perry  <wmperry@aventail.com>

* css.el (css-parse): Deal better with newline-challenged stylesheets
  (css-parse): Don't be so aggressive in finding block data for @xyzzy
  directives.

* mm.el (mm-viewer-passes-test): Always run the tests in the users home
  directory.

* w3-mouse.el: Use down-mouse-N in Emacs 19, to be more consistent with
  how the XEmacs keybindings work.

Fri May  9 11:32:46 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-document-information): some formatting changes

Thu May  8 14:06:40 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.86 released

* mule-sysdp.el (mule-code-convert-region): Try to deal gracefully with
  the recent XEmacs 20.0 -> 20.2 renaming of the autodetect coding system
  to automatic-conversion

* w3-sysdp.el (event-point): New stub.

* url-cookie.el (url-cookie-handle-set-cookie): Don't use the 'warn'
  facility for bad cookie 'set' commands, was too annoying.

* w3.el (w3-save-as): Make sure to require ps-print before trying to
  save/mail a document as postscript.  The local binding of
  ps-spool-buffer-name was causing the defvar not to happen, and you would
  get errors when trying to kill emacs later.  Ugh.
  (w3-document-information): Make sure to escape entities for meta and
  other info we throw in.

* url-file.el (url-file): ftp/file retrieval can now be asynchronous
  through the magic of [ange-ftp|efs]-copy-file-internal

* url.el (url-sentinel): Allow a buffer as the first argument to
  the sentinel function.
  (url-retrieve-internally): Allow asynch ftp transfers

* url-file.el (url-file): Asynchronous ftp downloads work now.

* w3.el (w3-download-url): Made this function interactive.

Mon Apr 28 13:31:36 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-download-url-at-point): new function to download document
  under point.
  (w3-download-this-url): new function to download current document.

* w3-vars.el (w3-mode-map): Added 'D' and 'd' bindings for starting
  document downloads.

Thu Apr 24 08:29:34 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.85 released

* w3-display.el (w3-display-table-dimensions): Deal with
  colgroup/thead/tfoot/col better.  Before was ignoring the rest of the
  table.  ack.
  (w3-display-table): ditto

* w3-prefs.el (w3-preferences-restore-variables): Slap things into
  custom-land where they belong.

* A few customization tweaks.

Wed Apr 23 21:44:59 1997  <chang@wsu.edu>

* w3-e19.el (w3-store-in-clipboard): Make this work under OS/2

Tue Apr 22 07:23:51 1997  William M. Perry  <wmperry@aventail.com>

* devices.el: Removed defsubsts so that we should be able to share .elc
  files again between emacs and XEmacs.

* font.el: Added in code to make a face blink.  Causes lots of screen
  flicker under Emacs 19 though, so it is turned off by default.  Turn it
  on with ESC-: (font-blink-initialize) - should be able to optimize when
  the callback actually does anything based on what fonts are visible in
  the visible buffers.
  (font-face-visible-in-window-p): New function to tell if a face is
  visible in a buffer window.
  (font-map-windows): New function to map a function over all visible
  windows.
  (font-blink-callback): Use them to optimize so that invert-face is not
  called unless absolutely necessary.

Mon Apr 21 08:58:02 1997  William M. Perry  <wmperry@aventail.com>

* w3-e19.el: Added in compile-time require of w3-props so that pages with
  backgrounds don't puke and die.

* w3.el (w3-find-default-stylesheets): Don't load a user's personal
  stylesheet if we started up in '-q' mode.

* Emacs/W3 3.0.84 released

* w3-display.el: When using XEmacs 20.x w/mule support, we now define our
  own special character set.  This means that the table border chars work
  again in XEmacs/mule

* devices.el: Added magic to not optimize this file under XEmacs - its not
  actually used, so no damage.  It wouldn't compile under XEmacs because
  it has subrs for all these, and our declaring them as defsubsts
  thoroughly confuses the byte-compiler.

Sun Apr 20 12:19:56 1997  William M. Perry  <wmperry@aventail.com>

* w3-sysdp.el: Moved device stuf out into its own devices.el file so that
  it can be correctly byte-compiled.
  Ditto for the text properties stuff (into w3-props.el)

Fri Apr 18 13:09:31 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.83 released

* Synch'd up to Widget 1.89

Thu Apr 17 06:20:56 1997  "T. V. Raman" <raman@Adobe.COM>

* default.css (pre/xmp/plaintext/key/code/tt): Changes to default
  stylesheet for spoken output of normally `monospaced' text.

Tue Apr 15 16:28:11 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-find-specific-link): Don't signal an error in a target anchor
  (#foo) is not found.

Tue Apr 15 08:22:37 1997  John Palmieri <palmieri@math.mit.edu>

* w3.el (w3-complete-link): protect against errors when hitting return
  when point isn't on a link

Mon Apr 14 16:18:43 1997  William M. Perry  <wmperry@aventail.com>

* mm.el (mm-parse-mailcaps): Moved ~/.mailcap to the front of the list so
  that it gets parsed last, and has the highest priority.

Sun Apr 13 20:28:30 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-complete-link): now correctly defaults to following the link
  at point.

Sat Apr 12 19:35:26 1997  William M. Perry  <wmperry@aventail.com>

* w3-speak.el: use widget-at instead of emacspeak-widget-at

Fri Apr 11 07:39:26 1997  William M. Perry  <wmperry@aventail.com>

* w3-menu.el (w3-menu-edit-menu): Addded a preferences submenu with all
  the W3 & URL customization items underneat it.

* css.el (css-split-font-shorthand): Handle bad lists better

* Emacs/W3 3.0.82 released

* Synch'd up with Widget 1.78

* w3-display.el (w3-get-face-info): Don't look for face attributes on tags
  unless w3-user-colors-take-precedence is nil
  (w3-display-node): Don't honor face attributes on <body> tag unless
  w3-user-colors-take-precedence is nil

* url-vars.el: Modified a few customizations to make them prettier

* url-cache.el (url-cache-creation-function): Modified customization

Fri Apr 11 07:03:20 1997  Hrvoje Niksic <hniksic@srce.hr>

* url-cache.el, url-gw.el, url-cookie.el, url-irc.el, url-vars.el, url.el:
  All URL related variables are now customizable.

Wed Apr  9 16:46:52 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.81 released

* w3-xemac.el (w3-text-pixel-width): And a XEmacs specific version of it.

* w3-e19.el (w3-text-pixel-width): New function to return the pixel width
  of a piece of text.

* url.el (url-handle-no-scheme): Use it.

* url-vars.el (url-handle-no-scheme-hook): New hook that should expand a
  partial url like 'gnu' to a full URL, like 'http://www.gnu.org/'.

* w3-sysdp.el (run-hook-with-args-until-success): Added a stub for
  run-hook-with-args-until-success

Tue Apr  8 12:20:39 1997  William M. Perry  <wmperry@aventail.com>

* w3-auto.el: Added autoloads for all the functions in url-ns for proxy
  functions, and url-mail

* url-ns.el (isPlainHostName): Fixed isPlainHostName

* w3-parse.el (w3-parse-buffer): now throws up a bad style warning for
  images without ALT attributes.

* mm.el (mm-parse-mailcaps): Reverse the ':|;' separated path for MAILCAPS
  so that earlier items take precedence, like standard unix PATH-like
  variables do.
  (mm-parse-mimetypes): Ditto for MIMETYPES

Mon Apr  7 06:23:11 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.80 released

* w3-parse.el: Some more transitions - don't imply <p> after some form
  tags.

* url-misc.el (url-finger): Ditto

* url-http.el (url-http): Ditto

* url-gopher.el (url-gopher-retrieve): Put in a process-sentinel of
  'ignore so that stupid 'process xxx exited with code nnn' messages are
  not shown.

* url.el (url-sentinel): Ditto

* w3.el (w3-sentinel): remove call to url-clean-text - no longer needed

Mon Apr  7 02:57:19 1997  Greg Stark  <gsstark@mit.edu>

* url.el (url-sentinel): once and for all eliminate the "first character
  goes to wrong buffer" bug through brute force by setting the current
  buffer to the buffer of the selected window at the end of a sentinel.

* w3.el (w3-viewer-sentinel): ditto

* w3-widget.el (widget-image-value-create): set tab-order to -1 on the
  choice-items of client-side imagemaps to avoid having tab stop on them
  three times, (it still stops on them twice)

* Makefile: add "make fast" rule to not run a bazillion emacsen

* FAQ: typos

* docomp.el: try setting byte-compile-dynamic to t to reduce memory usage

Fri Apr  4 06:23:31 1997  William M. Perry  <wmperry@aventail.com>

* url-file.el (url-format-directory): Use insert-file-contents instead of
  -literally, so that ftp index files will work.

* w3-emulate.el: lots of new commands to spoof the user-agent string.  See
  turn-[on|off]-[lynx|netscape|ie|arena]-masquerade-mode functions.

Thu Apr  3 07:22:27 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.79 released

* w3-parse.el: Put in <p> as part of the content-model of <ul/ol> so that
  <p> at the front of a list doesn't cause a bogus list item to be shown.

* url-http.el (url-parse-mime-headers): Make proxy authentication sort of
  work again.

* w3-display.el (w3-setup-terminal-chars): Check to see whether face is
  actually different before trying to set its font to a terminal one.

* url.el (url-buffer-visiting): Better matching of URLs - it was taking
  the target into account - bad bad bad.

Wed Apr  2 18:05:11 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-add-element): New way to do hidden form
  fields that retains the order information - damned idiots out there rely
  on ordering.  !#%!@

* w3.el (w3-fetch): Put some of the logic about _blank/_top frame targets
  into w3-fetch

* w3-display.el (w3-get-all-face-info): Added in support for the 'face'
  attribute to specify font-family

Wed Apr  2 13:08:36 1997  Frederic Lepied <Frederic.Lepied@sugix.frmug.org>

* w3-print.el (w3-print-this-url): Need to run LaTeX to get the indices
  right.

Tue Apr  1 11:20:54 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.78 released

* css.el (css-color-light-p): New function
  (css-active-device-types): Use it to add a 'dark' or 'light' property to
  the active device types as necessary

Mon Mar 31 09:07:13 1997  William M. Perry  <wmperry@aventail.com>

* w3-parse.el: More error transitions for tables (push tr before td/th
  just after a table)

* w3-display.el (w3-display-node): Use it for body/html attribute handling
  (w3-fix-color): New function to make sure we don't pass hex values without
  "#" in front of them.

Sun Mar 30 15:00:59 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-node): Now honors alink/vlink/link attributes
  on the body tag.
  (w3-fixup-eol-faces): Fixed nuking of faces at end of line to deal with
  bad underlining behaviour of Emacs 19.

Sun Mar 30 14:28:32 1997  Greg Stark <gsstark@mit.edu>

* w3-e19.el (w3-mode-version-specifics): Fixed buffer read-only errors
  when trying to set a background face.

Fri Mar 28 10:41:43 1997  William M. Perry  <wmperry@aventail.com>

* Emacs/W3 3.0.77 released

* w3-display.el (w3-display-table): Face properties specified on the
  'table' element now propogate to table cells correctly.

Fri Mar 28 07:53:48 1997  Greg Stark <gsstark@mit.edu>

* w3-forms.el: Make sure we set the button-face on all widgets

Fri Mar 28 07:53:48 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-frames): Use make-frame, not make-frame-command, so it
  will work on XEmacs.

* w3-e19.el (w3-mode-version-specifics): Now honors background/foreground
  color requests in Emacs19 by coloring in the whole buffer.  Oh how I
  wish Emacs 19 had buffer-local faces.

* w3-display.el (w3-display-table): Tables now look better under Emacs 19

Thu Mar 27 08:05:34 1997  William M. Perry  <wmperry@aventail.com>

* font.el (font-x-registry-and-encoding-regexp): got rid of compile
  warning under Emacs 19

* w3-display.el (w3-display-handle-list-type): manually remove faces on
  bullet/list items
  (w3-display-node): We were being a bit rude to inhibit-read-only -
  sometimes would leave it 't', which is bad bad bad, some might even say
  pure evil.

* Emacs-W3 3.0.76 released

* Synch'd up to Widget 1.68

* w3-display.el (w3-display-node): Handles 'text' attribute correctly now
  to set the default foreground when requested.

* mm.el (mm-play-sound-file): Fixed it for new mule stuff

* url-gw.el (url-gateway-nslookup-host): Added autoload for
  gateway-nslookup-host

* w3-display.el (w3-display-table): Expand each line of a table cell out
  to the border, so that we get nicely colors backgrounds for table cells
  now.

* font.el (font-x-registry-and-encoding-regexp): New variable to match the
  registry and encoding of a font name under X
  (x-font-create-object): Use it to set the default registry and encoding
  for font objects we create from font names.
  (x-font-create-name): Grab the registry and encoding from the default
  object for this device before defaulting back to '*'

* w3-display.el (w3-setup-terminal-chars): Explicitly specify wildcard
  registry and encoding for the table-hack-x-face, to deal with changes in
  the font library.

Wed Mar 26 06:23:51 1997  William M. Perry  <wmperry@aventail.com>

* custom-check: Should work better now, and spit out better instructions
  for rebuilding correctly.

* Emacs-W3 3.0.75 released

* url.el (url-clean-text): Better matching of bogus process exited
  messages.

* font.el (font-rgb-color-p): No longer match "^#xxyyzz" as an rgb-color,
  this screwed up bigtime in font-color-rgb-components.
  (font-set-face-foreground): Do the test here instead.
  (font-set-face-background): and here.

* w3-widget.el (widget-image-value-create): For client side imagemaps,
  make sure case-fold-search or :ignore-case is specified.

* url-gw.el (url-gateway-nslookup-program): Default to using 'nslookup' as
  url-gateway-nslookup-program

Tue Mar 25 16:06:28 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.74 released

Tue Mar 25 15:31:56 1997  Greg Stark <gsstark@mit.edu>

* url-cookie.el (url-cookie-handle-set-cookie): don't deal with #!%@ed
  microsoft web site cookies - they break good, clean, wholesome sites
  like yahoo's stock pages.

* ssl.el (ssl-program-arguments): Make sure everything gets turned into a
  string, not an integer.
  (open-ssl-stream): use a pipe instead of a pty if possible (why?)

* w3-display.el (w3-display-node): Added back in <keygen> support

* w3.el (w3-notify-when-ready): protect against bad buffer switching
  (minibuffer as active window lossage, etc)

* w3-toolbar.el (w3-toolbar-make-buttons): Don't warn about toolbar
  directory on Emacsen that can't do toolbars!

Tue Mar 25 15:31:56 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.73 released

* w3-display.el (w3-get-face-info): Allow passing in a second argument
  that means 'check this attribute of the html tag if you don't find
  something in the stylesheet'.  This automatically enables <font color>
  and <table|td|tr bgcolor>.

Tue Mar 25 06:45:02 1997  T. V. Raman <raman@Adobe.COM>

* w3-forms.el (w3-form-keymap): patch to avoid lossage with emacspeak &
  using terminal.el

Tue Mar 25 06:45:02 1997  William M. Perry  <wmperry@aventail.com>

* ssl.el (ssl-program-arguments): Removed -quiet switch, since it requires
  patches to s_client

Mon Mar 24 10:56:11 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.72 released

* w3-display.el (w3-display-node): Better handling of body and html style
  attributes in XEmacs

* w3.el (w3-mode): Removed call to kill-all-local-variables, as it
  nukes buffer-local faces as well.

* css.el (css-expand-length): Don't choke and use the wrong damn thing to
  base percentages off of on percentage heights (ie: font-size: 80%)

Mon Mar 24 07:12:52 1997  Gerry S Hayes <sumner@CMU.EDU>

* url-gw.el (url-open-telnet): Fixed stupid typo into-to-string ->
  int-to-string
  (url-open-rlogin): Ditto.

Sun Mar 23 09:43:24 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-table-ascii-border-chars): Use a '+' in the ascii art
  version of table borders.

Sat Mar 22 00:45:34 1997  William M. Perry  <wmperry@aventail.com>

* w3-menu.el (w3-use-menus): Customized this variable

* w3-display.el (w3-display-node): Don't run multiline text area's default
  value through w3-normalize-spaces

Thu Mar 20 23:44:50 1997  Greg Stark  <gsstark@mit.edu>

* w3-cus.el (w3-use-terminal-characters): New variable
  (w3-use-terminal-characters-on-tty): New variable
  (w3-use-terminal-glyphs): New variable
  (w3-horizontal-rule-char): Make setting it to nil allow use of graphic
  characters (also means people can avoid using graphic charactes for
  horizontal rules if they wish)
* w3-display.el (w3-handle-image): clean up whitespace in alt tags
  (w3-table-glyph-border-chars): New variable
  (w3-table-graphic-border-chars): New variable
  (w3-terminal-properties): New variable
  (w3-insert-terminal-char): New inline function
  (w3-horizontal-rule-char): New inline function
  (w3-setup-terminal-chars): Set up all of these and make using graphic
  characters work on XEmacs using text properties (and optionally use text
  properties on FSF Emacs too).
  (w3-table-hack-borders): Remove, obsoleted by w3-setup-terminal-chars
  (w3-table-unhack-borders): don't have to fiddle with
  w3-horizontal-rule-char any more.
  (w3-display-table): Use w3-insert-terminal-char
  (w3-size-of-tree):  Use w3-horizontal-rule-char
  (w3-display-node):  Use w3-horizontal-rule-char, w3-insert-terminal-char,
  uhm, i'm not sure if it was correct to remove the handle-content
* w3-forms.el (w3-fixup-eol-faces): try to remove mouse-face from end-of-lines as
  well, uhm, this doesn't seem to work though.
  (w3-form-determine-size): add keygen
  (w3-form-encode-helper): add keygen support for the day when the ssl code
  itself is released.
* w3-widget.el (widget-image-value-create): use 'item widgets instead of
  'push-button widgets and specify the format ourselves so we don't get
  widget.el's arbitrary formatting.
* w3.el (w3-do-setup): call w3-setup-terminal-chars to make nice tables and
  horizontal rules the default at least under X.
* mm.el added x-x509-ca-cert and x-x509-user-cert viewers but the tests
  will fail so no one should should see this change until i release the
  functions.

Fri Mar 21 18:52:31 1997  William M. Perry  <wmperry@aventail.com>

* css.el (css-expand-length): Better support for percentage values in
  lengths

Thu Mar 20 06:22:29 1997  Istvan Marko <istvan@cmdmail.amd.com>

* Added slot for no_proxy settings under the preferences panel

Thu Mar 20 06:22:29 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.71 released

* w3-parse.el:Added more transitions for error handling of raw 'td' or
  'th' outside of a 'tr' in tablebody.

* url.el (url-default-callback): asynch downloads should now be cached

* w3-script.el (w3-do-scripting): Customized, turned off by default

Wed Mar 19 20:53:23 1997  Steven L Baur  <steve@altair.xemacs.org>

* Makefile (xemacs-w3): Special target for XEmacs Build.

Wed Mar 19 05:56:56 1997  William M. Perry  <wmperry@aventail.com>

* font.el (x-font-families-for-device): Just in case
  font-default-family-for-device fails under Emacs/NT, return "monospace"
  at the front of the list.

* url-vars.el (url-privacy-level): Now defaults to not sending your email
  address in HTTP requests.

Tue Mar 18 13:09:13 1997  William M. Perry  <wmperry@aventail.com>

* url-cookie.el (url-cookie-handle-set-cookie): Fixed variable typos -
  doh.  Today just hasn't been my day.

* Emacs-W3 3.0.70 released

* We now pass all tests on the forms tester page
  http://www.research.digital.com/nsl/formtest/home.html

* w3-display.el (w3-display-node): Better handling of <select multiple>
  and <select> in general.

* w3-forms.el (w3-form-encode-xwfu): Encode : and / in xwfu, since the
  form tester expects it.

* url-cookie.el (url-cookie-trusted-urls): New variable - list of regexps
  of URLs that you will accept cookies from without question.
  (url-cookie-untrusted-urls): New variable - list of regexps of URLs that
  you will _never_ accept cookies from.
  (url-cookie-handle-set-cookie): Use them
  (url-cookie-handle-set-cookie): When asking whether to allow a site to
  set a cookie, show the cookies they are wanting to set.

Tue Mar 18 06:47:46 1997  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* w3-display.el: Latest round of patches for <frames> support.

* w3-cus.el (w3-display-frames): can now have 4 values.
	nil		no frame display whatsoever (currently the default)
	'as-links	display frame hyperlinks, but do not fetch them
	'ask		display frame hyperlinks and ask whether to fetch them
	t		display frame hyperlinks and fetch them

Tue Mar 18 06:47:46 1997  William M. Perry  <wmperry@aventail.com>

* w3-parse.el (w3-parse-buffer): Duh, don't do `=' comparison on results
  of char-after, since it is nil at the end of the buffer.

Mon Mar 17 08:44:46 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.69 released

* w3-sysdp.el (buffer-substring-no-properties): Added stub

* url-gopher.el (url-gopher-retrieve): Ditto.

* url.el: Ditto

* w3-parse.el: Removed all sorts of fun (following-char) commands that can
  cause ebola warnings under XEmacs 20.x

* w3.el (w3-popup-info): Default to the URL under point instead of the
  documents URL

* w3-auto.el: updated autoloads - made sure everything was interactive if
  appropriate.

* w3-menu.el (w3-popup-menu): If w3-popup-menu-on-mouse-3 is nil, call
  whatever button3 is bound to in global-map

* w3-display.el: Added XEmacs version of frame-char-height and
  frame-char-width
  (w3-frames): If w3-display-frames is non-nil, then do a refresh with it
  bound locally, so everything should just work.

* url.el (url-do-setup): Global history file now defaults to ~/.w3/history
  (url-do-setup): Cookie storage now defaults to ~/.w3/cookies

Mon Mar 17 06:51:07 1997  Paul Stodghill <stodghil@CS.Cornell.EDU>

* mm.el (mm-temporary-directory): Initialize variable from TMPDIR
  environment variable

Fri Mar 14 13:35:56 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-create-custom): Fixed the 'custom' input type for
  new filenames in the widget/custom package.

* ssl.el (ssl-certificate-verification-depth): New variable to control how
  far up a cert chain to look.
  (ssl-view-certificate-program-name): New variable.
  (ssl-view-certificate-program-arguments): New variable.
  (ssl-certificate-directory-style): New variable.
  (ssl-rehash-program-name): New variable.
  (ssl-certificate-directory): New variable.
  (ssl-program-arguments): Use some of them.
  (ssl-accept-ca-certificate): Use the rest.

* css.el (css-parse-args): Removed old code that could cause infinite loop
  in stylesheet parsing on bad things like "foo=bar" instead of "foo:bar"

* w3-cus.el: Added better groupings for the customization stuff.

Thu Mar 13 19:54:50 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.68 released

* w3-cus.el: Added customization support for Emacs-W3

* w3.el (w3-mail-current-document): Use url-mail-command instead of
  w3-mail-command

Thu Mar 13 11:41:42 1997  Greg Stark  <gsstark@mit.edu>

* w3-prefs.el: Implemented privacy panel

Wed Mar 12 10:25:38 1997  William M. Perry  <wmperry@aventail.com>

* w3-e19.el (w3-mode-version-specifics): Use the nasty crufty
  buffer-access-fontify-functions to make sure that we never yank
  read-only text out of the Emacs-W3 buffer.

* Synch'd up to Widget 1.62

Wed Mar 12 06:36:41 1997  Paul Stodghill <stodghil@CS.Cornell.EDU>

* base64.el (base64-decode-region): Fixed typo in calling
  command-on-region.

Tue Mar 11 07:03:48 1997  William M. Perry  <wmperry@aventail.com>

* w3-auto.el (w3-use-hotlist): Made autoload interactive

* w3-widget.el (widget-image-value-create): Was a little too aggressive
  about when to apply the -1 :tab-order property.  Now only images that
  are not hyperlinks or imagemaps will not be tabbed to.

* w3-prefs.el (w3-preferences-init-proxy-panel): Updated preferences panel
  for new format of url-proxy-services

* w3-vars.el (w3-hyperlink-menu): Fixed problem with calling wrong
  bookmark function - would create a bookmark to the current document, not
  the document under the mouse.
  (w3-popup-menu): Added a few menu itmes (reload, show images, add bookmark)

* w3-hot.el (w3-hotlist-add-document-at-point): Extract the title
  correctly for the new widget implementation of hyperlinks.

Mon Mar 10 06:31:48 1997  William M. Perry  <wmperry@aventail.com>

* w3-menu.el (w3-menu-options-menu): Fixed problem with XEmacs when
  building without toolbars - would insert nil in the menu in a very wrong
  place.

* font.el (font-normalize-color): Under win32, make sure we define the
  color before we try to use it, since Emacs doesn't support raw #RRGGBB
  color specifications yet.
  (font-rgb-color-p): make all #RRGGBB color specs go through
  font-normalize-color

* Emacs-W3 3.0.67 released

Mon Mar 10 1997  Dave Love  <d.love@dl.ac.uk>

* w3.el (w3-do-setup): Make configuration file loading contingent
  on init-file-user (i.e. suppressed with -q).

Sun Mar  9 13:09:38 1997  William M. Perry  <wmperry@aventail.com>

* w3-widget.el (widget-image-value-create): Set :tab-order to -1 so the
  latest widget library won't tab to image widgets.

* w3.el (w3-mode): Make sure w3-mode-hook is run last, so that people can
  turn off truncate-lines if they want.

* ssl.el (open-ssl-stream): ssl-program-arguments is now dynamically
  evaluated, similar to ps-lpr-switches.  The special symbols 'host' and
  'port' are available, and bound to the hostname and port#/service we are
  about to connect to.

* w3-display.el (w3-finish-drawing): Remove all read-only properties on
  text.

* url-cache.el (url-cache-expired): fixed standalone mode

Sat Mar  8 09:13:59 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.66 released.

* url-cache.el (url-cache-prepare): Threw a condition-case around the
  make-directory call, just in case we can't create the file for some
  reason.  Also fixed bug where the file wouldn't be cached until the
  second time you visited it.

* url.el (url-retrieve-internally): Deal with https asynch

* w3-xemac.el (w3-mode-version-specifics): Don't try to add the toolbar if
  device-type == 'stream.

* w3-vars.el (w3-temporary-directory): Ditto.

* url-vars.el (url-temporary-directory): Initialize from TMPDIR
  environment variable.

* w3.el (w3-start-viewer): Ditto.

* md5.el (md5): Ditto.

* mm.el (mm-compose-type): Don't use hardcoded /bin/sh and -c - use
  shell-file-name and shell-command-switch
  (mm-viewer-passes-test): ditto.

* w3-sysdp.el: Better device-* functions for Emacs-19 under win32 and OS/2

* w3-display.el (w3-display-node): Better handling for <noframes> support.

Fri Mar  7 06:13:20 1997  William M. Perry  <wmperry@aventail.com>

* w3-script.el (w3-script-evaluate-form): protect against bad input during
  the read-from-string when parsing emacs-lisp scripts.

* w3-auto.el (w3-preferences-edit): Make the autoload for this be
  interactive so that the user can actually find it!

* Emacs-W3 3.0.65 released.

* w3.el (w3-document-information): Better handling of last-modified
  findings.

* w3-forms.el (w3-form-create-image): Try to use the value of an
  image-input area as the label for the widget we create.

* w3-elisp.el (w3-elisp-safe-eval): Throw a condition-case() around the
  eval to catch bad forms, etc.

* w3-script.el (w3-script-evaluate-form): Don't signal an error on unknown
  scripting languages, just show a warning.

Thu Mar  6 08:24:49 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-complete-link): Protect against malformed widgets (null :from
  or :to).  Is this from delayed image widgets?

* w3-vars.el (w3-mode-map): Changed binding of M-s to w3-save-as instead
  of w3-search - does anybody use that instead of the forms interface?

* w3.el (w3-document-information): Show document size

* css.el (css-parse): Removed warning about old-style stuff for
  device-dependent styles - was too annoying.  Need to just remove this
  support totally for the 3.0 release.

* w3.el (w3-internal-handle-preview): When previewing a buffer, remove all
  text properties from the document source before doing anything.
  (w3-mail-current-document): Bind case-fold-search when looking for where
  to insert the <base> tag.
  (w3-loaded-stylesheets): New variable to keep track of what stylesheets
  were loaded at startup.

* url-cache.el (url-cache-create-filename-human-readable): New function to
  create cached filenames using the old method, that was slightly more
  human readable.

Wed Mar  5 15:38:00 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.64 released

* w3-parse.el: OH god, finally got raw text inside a <tr> to push a <td>
  onto the parse tree.  got raw text inside a <table> to push a <tr>
  onto the parse tee.

* w3-widget.el: Support 'target' in img widgets

Tue Mar  4 07:55:56 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-node): Support 'seqnum' attribute

* w3.el (w3-mail-document-author): Fixed for new 'link' representation
  (w3-document-information): If a document has a 'Last modified: blah' line,
  use it as the last modified information as a last resort.

* Synch'ed up with widget 1.50

* w3-forms.el: Try to play nice with old and new versions of
  widget-edit/wid-edit.el

Tue Mar  4 06:23:41 1997  Michael Ernst <mernst@cs.washington.edu>

* url.el (url-get-url-at-point): If a possible URL starts with www., slap
  on 'http://', as someone probably just forgot it.

Tue Mar  4 06:23:41 1997  William M. Perry  <wmperry@aventail.com>

* w3-prefs.el (w3-preferences-hooks-variables): Removed some old variables.
  (w3-preferences-edit): The preferences panel actually works again.  No
  longer tries to use an imagemap - a dropdown is good enough dammit.

* w3-vars.el: Removed some old variables

* w3-display.el (w3-display-node): For <a> tags, do not embed a widget in
  the buffer unless it actually has an 'href' attribute.  This helps a
  _lot_ with <a name="blah">...</a> constructs.

Tue Mar  4 06:18:06 1997  Toby Speight <tms@ansa.co.uk>

* w3.el (w3-mail-current-document): Allow TM (if it's in use) to choose
  the appropriate Transfer-Encoding of a mailed document.
  (w3-mail-current-document): Try real hard to put <base> where it belongs
  (in the <head>, if that is not found, then just after <html>, otherwise
  just at the beginning of the document)

Mon Mar  3 07:10:11 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.63 released

* w3-forms.el (w3-form-field-label): Labels are now reimplemented for form
  fields

* w3-display.el (w3-parse-link): Now honors the old variable
  w3-honor-stylesheets, which hadn't made it back onto the reimplemented
  features list yet.

* font.el: Added quite a few autoloads.  Package no longer overwrites the
  set-face-* functions, as this was deemed evil in the extreme.

* w3-display.el (w3-face-for-element): Use the font-set-face-* functions
  instead of the raw set-face-* functions.

* w3-widget.el (widget-image-inaudible-p): New variable that controls
  whether image widgets are rendered inaudible by emacspeak or not.
  (widget-image-value-set): Use it.

* url-cache.el (url-cache-directory): New variable that controls where you
  cache files will be stored.  Defaults to "~/.w3/cache"
  (url-cache-creation-function): New variable that controls what function
  will be used to create cached filenames.
  (url-cache-create-filename-using-md5): This is now the default (and
  only) cache-file-creation function.  Suitably fast under Emacs 19 (lisp
  implementation), _very_ fast under XEmacs, where it is written in C.

Thu Feb 27 07:27:43 1997  William M. Perry  <wmperry@aventail.com>

* w3-sysdp.el: Added alias of make-symbolic-link to copy-file for NTEmacs

* w3-elisp.el: Removed face functions from the safe list.

Wed Feb 26 16:08:08 1997  Per Abrahamsen  <abraham@dina.kvl.dk>

* font.el (font-create-object): Added autoload.

Wed Feb 26 08:17:37 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-region): Fixed typo when binding
  w3-display-same-buffer - no wonder it wasn't working right.

* images.el (image-normalize): Bind file-coding-system to the appropriate
  no-conversion so that running subprocesses doesn't munge the data when
  running under MULE.
  (image-normalize): Now uses call-process-region instead of
  shell-command-on-region, and removed the explicit mention of '/bin/sh'
  and friends.  Uses the ability of call-process-region to specify a
  separate file to use for stderr - yipeee.

* url.el (url-setup-privacy-info): Slight change as to how url-system-type
  and url-os-type are set up.  No longer uses nested parens, as this seems
  to confuse some sites that try to use the User-Agent header as a
  state-tracker.

Mon Feb 24 10:15:45 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-widget-echo): Make sure that nothing that will be
  echoed is the empty string.

Sun Feb 23 08:34:18 1997  William M. Perry  <wmperry@aventail.com>

* url-cache.el (url-store-in-cache): fixed stupid bug in caching logic

Sat Feb 22 07:21:29 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.62 released

Thu Feb 20 13:40:22 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-summarize-password): By default, don't summarize
  password entry boxes.

Thu Feb 20 07:33:59 1997  Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr>

* w3-display.el (w3-frames): Better support for Frames

Thu Feb 20 07:33:59 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-complete-link): Fixed bug in using try-completion to make sure
  we have a match before passing a URL off to w3-fetch.

* Synch'd up to widget 1.44

* url.el (url-default-callback): Caching works in asynch mode now.

Wed Feb 19 05:48:40 1997  William M. Perry  <wmperry@aventail.com>

* css.el (css-split-font-shorthand): Make sure that the subelements of the
  'font' shorthand property get run through the property value-expansion
  routines before getting returned.  This royally screwed up font-family,
  font-weight, and friends.
  (css-expand-color):  Now recognizes 'transparent' and 'none' as special
  color names.
  (css-expand-value): When dealing with color-shorthand, make sure
  everything gets run through the value-expansion routines as well.  Ack.

* w3-elisp.el (w3-elisp-safe-function): You can now supply a validation
  function for the arguments of a script-enabled function, its no longer a
  binary operation on just the function name.  You can also give it a
  variable name, and the value of that variable at the time of execution
  is what controls whether it is safe or not.

* w3.el (w3-download-url): Finally fixed bug where w3-download-url would
  not save in the correct directory if you just accepted the default
  pathname it offered.

* url-cache.el (url-cache-ignored-protocols): New variable controlling
  what protocols we should never cache to disk.
  (url-cache-cachable-p): use it.

* w3.txi: Updated all nodes and menus, a few stylistic changes

* w3-elisp.el: Added read-access to devices, frames, windows, buffers, and
  property-lists.  Also added function, lambda, point, and list accessors
  (member, memq, assoc)

* w3-display.el (w3-display-node): Bind widget-push-button-gui to nil in
  w3-display-node so that images don't run into the
  visible-portion-of-buffer-is-not-modifiable-bug.  Ick.

* w3-elisp.el: Don't allow access to 'set'-type text-property functions
  from scripts.

Tue Feb 18 15:11:08 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.61 released

* w3.txi (Supported URLs): added sections on each protocol supported -
  needs lots of fleshing out.

* url-misc.el (url-info): Info URL loader now unhex's the target, so that
  you can have something like info:w3.info#Getting%20Started

* url.el (url-do-setup): Removed secure-http (SHTTP) handler - who the
  hell cares anymore, it lost.

* w3-display.el (w3-display-node): Correctly calculates right margin as
  documented (from window-width and right-margin)

* w3.el: Removed w3-batch-fetch

* url-vars.el: Removed lots of old variables

* url-misc.el: Removed x-exec URL handler - no interest anymore.

* w3-script.el (w3-script-evaluate-form): Use it.
(w3-do-scripting): New variable to control whether to do _any_ scripting
or not.

* The URL package now stores the current parsed URL object instead of 5 or
  6 separate variables.

* dist.Makefile: Removed old pgp and wais support, it was gross and
  apparently nobody was using it.

Tue Feb 18 06:13:03 1997  "T. V. Raman" <raman@adobe.com>

* w3-forms.el (w3-form-summarize-radio-button): Better radio button
  summarizer.

Tue Feb 18 06:13:03 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-finish-drawing): Moved #blah target finding in here,
  where it belongs.

* w3-vars.el (w3-mode-map): Added binding for raw '\t' instead of relying
  on [tab].  Apparently this keysym isn't aliased under Emacs 19 on a
  TTY.

Mon Feb 17 15:10:38 1997  William M. Perry  <wmperry@aventail.com>

* w3-elisp.el: Interface to Emacs-Lisp for safe scripting.

* w3-script.el: Basic client-side scripting has been implemented.

* w3-xemac.el (w3-mouse-handler): Ditto

* w3-e19.el (w3-mouse-handler): Plugged in handling of the onMouseOver event

* w3-display.el (w3-handle-string-content): Now adds a text property that
  contains w3-display-open-element-stack, so that from anywhere in the
  buffer you can find out where you are in the parse tree.

* default.css (input): ome default stylesheet updates for input fields on
  TTYs

Sun Feb 16 09:01:18 1997  Shuji Narazaki <narazaki@InetQ.or.jp>

* mule-sysdp.el: Updated for mule 3.0

Sat Feb 15 15:35:15 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.60 released

* w3-display.el (w3-display-node): use it.

* w3-vars.el (w3-display-frames): New variable for whether to show 'frame'
  documents as a list of the subelements.

* w3.txi (Speech Properties): finished this chapter.
(Media Selection): ditto
(Time Units): ditto
(Angle Units): ditto
(Properties): Explanatory text at beginnign of section

Fri Feb 14 09:34:35 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.59 released

* w3.txi: Lots of documentation about stylesheets, chapter layout
  changes.

Thu Feb 13 07:01:59 1997  William M. Perry  <wmperry@aventail.com>

* Synch'd up to widget 1.38

* w3-forms.el (w3-form-resurrect-widgets): For now, don't use the nice new
  GUI pushbuttons - they appear to suffer badly on long lines.

* w3-mouse.el (w3-running-FSF19): Use new w3-popup-menu-on-mouse-3 variable

* w3-vars.el: Removed _lots_ of obsolete variables
(w3-popup-menu-on-mouse-3): New variable to control whether W3 should
  override mouse-3 or not.

* Emacs-W3 3.0.58 released

* w3.txi: Added stubs for stylesheet chapters and supported URLs

* images.el (image-register-netpbm-utilities): This is now safe to call
  multiple times again.

Wed Feb 12 06:26:55 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-keymap): When binding widget-end-of-line, make sure
  that we do not overwrite Emacspeak's prefix-key.  Now does a
  where-is-internal to find the correct binding in global-map to
  override.

* w3-display.el (w3-display-node): bind :emacspeak-help to 'w3-widget-echo
  in all the hypertext links.

* w3-vars.el (w3-mode-map): New binding for \M-\t - this _should_ have
  been taken care of by the [(meta tab)] definition, but evidently it
  doesn't.  *sigh*

Tue Feb 11 07:33:50 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-create-option-list): Specify :menu-tag-get so that
  keyboard-based-completion doesn't get confused by the fact that some
  items will have spaces slapped in at the end.

* ssl.el (ssl-program-arguments): New variable - a list of command line
  switches to send to the SSL program in a subprocess, before the hostname
  and port number.
  (open-ssl-stream): Use it.

Mon Feb 10 07:45:31 1997  William M. Perry  <wmperry@aventail.com>

* url-file.el (url-file): Removed refs to variable url-use-hypertext-dired

* url-vars.el: Removed obsolete variable url-use-hypertext-dired

* url-file.el (url-dired-find-file-mouse): fixed bad typo of
  (interactive...) spec, added documentation to a few functions.
  (url-file): Removed refs to obsolete variable url-use-hypertext-dired

* w3-xemac.el (w3-setup-version-specifics): Workaround for users of XEmacs
  19.14 or 20.0 with the bad bad bad lossage with text properties that
  have null values.  This  bug is fixed in XEmacs 19.15, and will be in
  20.1 as well.  This bug would cause you to get errors like:
	internal error: no text-prop <#extent ....> start-open

* w3.el (w3-widget-button-click): Deal with new image capabilities of the
  widget checkbox/radio-button stuff.

* Synch'ed up to widget 1.31

Sun Feb  9 15:39:19 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.57 released

* url-file.el (url-dired-minor-mode): New minor mode that overrides a few
  of direds keybindings to use Emacs-W3 instead of straight find-file.
  (url-format-directory): Now just uses dired to display directory
  listings, much more powerful than the old way.  Can copy files, act on
  multiple files, you all know the drill.

* w3.txi: Added more chapters, reorg of others.

* w3-display.el (w3-maybe-start-image-download): Fixed handling of bad
  images in the cache again.  Duh.
  No longer log to the warnings buffer if we fail to load an image.  Just
  use message - much less intrusive.  We just usually don't care that much
  about failed image loads.

* url-gw.el (url-open-stream): fixed typo - was calling old
  url-nslookup-host instead of url-gateway-nslookup-host

* w3.el (w3-insert-formatted-url): Now inserts markup in lowercase.

Sat Feb  8 13:54:43 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.56 released.  Getting closer!

* w3-forms.el (w3-form-summarize-radio-button): Finally, a decent
  summarization of radio buttons
  Fixed typo in specifying summarizer for hidden form fields.
  (w3-form-keymap): Bind C-a and C-e by default.

* w3-widget.el (widget-image-value-create): When using emacspeak, show
  client side imagemaps as a table.  Need a more general solution for
  this, but this makes us nicer than IE again. :)

* Updated to widget 1.30

Fri Feb  7 16:49:55 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-handle-string-content): Make sure faces text
  properties are closed, so that things don't bleed over.
  (w3-fixup-eol-faces): New function for Emacs 19 that removes face
  information at newlines, so that underlining will not extend from the
  end of a line to the window edges - very ugly.

* w3-menu.el (w3-menu-initialize-w3-mode-menu-map): Don't support 'emacs
  in w3-use-menus under Emacs in Windows 95/NT.

* w3-display.el (w3-finalize-image-download): Deal with bad images better.
  (w3-finish-drawing): Better protection of putting images in.

* url-gw.el (url-open-stream): Don't auto-retry connections.  Don't throw
  an error if you fail to connect to a site.  This is for image loadings
  that fail for some reason or another.

* css.el (css-expand-length): better handling of float values and 'ex'
  unit type.

* font.el (x-font-create-object): Unconditionally make case-fold-search
  non-nil so that we don't lose big-time.  This was the cause of the very
  weird font-spatial-to-canonical lossage under XEmacs with font sizes of
  something like '+12pt'

* w3.el (w3-view-this-url): Use widget-echo-help if we didn't find a URL
  under point.

Fri Feb  7 15:22:25 1997  Charles Levert <charles@comm.polymtl.ca>

* w3-widget.el (widget-image-notify): Bad data being fed to w3-fetch if a
  client-side imagemap had an alt attribute (but only if the <map> came
  _after_ the use.

Fri Feb  7 15:22:25 1997  William M. Perry  <wmperry@aventail.com>

* font.el (font-spatial-to-canonical): protect against bad input to this
  function.

Fri Feb  7 15:19:36 1997  Toby Speight <tms@ansa.co.uk>

* w3-parse.el (w3-parse-buffer): Parser didn't allow for the fact that
  TAGC is optional on end-tags as well as on start-tags (i.e. "<b<i>
  bold-italic</i</b>" is legal).

Fri Feb  7 06:28:37 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-keymap): Now inherits from widget-keymap, with a
  few exceptions.

* url.el (url-uncompress): This function now no longer looks at the file
  extension to determine a compression/encoding method.  This is so that
  doing searches on `foo.tar.gz' will not bogusly cause the decompression
  steps to run.  Ick!

* url-file.el (url-insert-possibly-compressed-file): This function no
  longer atempts to decompress the file after loading it in.  Instead, it
  sets an appropriate content-transfer-encoding header based on the
  filename, so that this will allow url-uncompress to work correctly on the
  buffer.

Thu Feb  6 06:24:26 1997  William M. Perry  <wmperry@aventail.com>

* w3-print.el (w3-postscript-print-function): New variable to control what
  function is used to generate postscript output.
  (w3-print-this-url): Use it.

* w3-display.el (w3-handle-string-content): Make all inserted text
  read-only

* w3-forms.el (w3-form-use-old-style): New variable to control whether to
  use the old-style interaction with form fields instead of the 'type
  directly into the buffer' method
  (w3-form-determine-size): Use it.
  (w3-form-create-integer): Use it.
  (w3-form-create-float): Use it.
  (w3-form-create-text): Use it.
  (w3-form-create-password): Use it.
  (w3-revert-form): Fixed error with 'reset' buttons on forms that had
  hidden form fields.

* w3-vars.el (w3-mode-map): Define [backtab] by default

* w3-display.el (w3-size-of-tree): Removed some warnings
(w3-display-table-dimensions): ditto

* Updated to widget 1.26

* default.css: Some default formatting changes for input fields.
  Everything is underlined by default except submit/reset/image/button
  fields, so that they are a little easier to spot.

* w3-parse.el (w3-parse-buffer): Now slaps pseudo-elements into input
  fields so that stylesheets can access them.

Wed Feb  5 14:42:12 1997  William M. Perry  <wmperry@aventail.com>

* Updated to widget 1.24

* Happy birthday Jenny P.

Tue Feb  4 08:21:03 1997  William M. Perry  <wmperry@aventail.com>

* font.el (x-font-create-name): Better checking/optimizing of when to just
  return the default font.

* w3-forms.el: Make use of the new information, and pass it down to the
  widget library appropriately.

* w3-display.el (w3-display-node): Now passes in the entire list of active
  faces to form creation functions.

Mon Feb  3 07:26:18 1997  William M. Perry  <wmperry@aventail.com>

* w3-emulate.el (w3-lynx-emulation-minor-mode-map): Lots of new
  keybindings for lynx emulation minor mode.

* Emacs-W3 3.0.55 released

* w3-forms.el (w3-form-determine-size): Fixed _STUPID_ problem where
  option lists would lose everything but the first option in them.  I'm a
  dumbass.  Sort modifies its list parameter! ICK ICK ICK.

* url.el (url-after-change-function): Show prettier status messages.
  Sizes are converted to bytes, k, or M, depending on how big the file
  is.

* w3.txi: Lots of documentation changes - volunteers welcome.

* Removed personal annotation support, since it wasn't shown with the new
  display engine, it needs to be rethought, and nobody had complained in
  the entire beta cycle.

* w3.el (w3-history-find-url-internal): Redid the history mechanism.
  Toolbar and menu entries are now grayed out appropriately.

* url-http.el (url-create-mime-request): Fixed cookie support if not going
  through a proxy gateway.

Sun Feb  2 22:05:41 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-table): Fix for negative colwidth

Fri Jan 31 14:28:54 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-fetch): Fixed targetted links (http://blah/#foo)

Fri Jan 31 11:20:47 1997  Alf-Ivar Holm <alfh@ifi.uio.no>

* w3.el (w3-mail-current-document): Fixed problem with calling
  w3-parse-buffer with too many arguments when mailing LaTeX-ified
  files.

Fri Jan 31 11:19:37 1997  Cord Kielhorn <kielhorn@thphy.uni-duesseldorf.de>

* css.el (css-expand-length): Fixed bad regexps for percentage and
  character based lengths

Thu Jan 30 20:27:06 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.52 released

* w3-display.el (w3-handle-image): When doing table auto layout, don't
  start loading the images.

Wed Jan 29 06:15:37 1997  William M. Perry  <wmperry@aventail.com>

* font.el (x-font-create-name): Yet another fix for not screwing up the
  line-height in Emacs 19.

* w3-display.el (w3-face-for-element): Uhh, oblique seems to work.

* font.el (set-font-style-by-keywords): now deals with arguments that
  aren't lists, for the font-style and font-variant CSS stuff

* w3-display.el (w3-display-node): Reimplemented <cookie> tag.
(w3-display-node): Reimplemented <flame> tag.

* url.el (url-insert-file-contents): url-insert-file-contents now
  decodes/uncompresses the data before returning.

* w3-display.el (w3-display-node): Reimplemented <pinhead> tag

Tue Jan 28 06:22:08 1997  William M. Perry  <wmperry@aventail.com>

* font.el (x-font-create-name): Never take font size into account under
  Emacs - too much chance of totally screwing up the users leading by
  choosing a bigger font than their default.  This sucks.  But I can't
  find a better solution.

* w3.el: w3-mode now turns on truncate-lines by default.

* w3-forms.el (w3-form-create-image): Better image input type support.

Mon Jan 27 08:21:58 1997  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-create-password): Now uses real password entry
  widgets provided by 'widget' - you _MUST_USE_ the widget library that
  comes with Emacs-W3 for this, otherwise the info won't be hidden
  correctly.
  (w3-form-add-element): Deal with hidden text areas better when they are
  in forms

* Synch'd up to widget 1.22

Sun Jan 26 16:50:09 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.51 released

* w3-forms.el (w3-form-create-text): Now uses the real text entry widgets
  provided by 'widget' - still can't do this for password fields yet
  though.

* Synch'd up to Widget 1.20

Sat Jan 25 13:38:12 1997  William M. Perry  <wmperry@aventail.com>

* url.el (url-expand-file-name): Now strips out spaces as well as
  newlines/carriage returns. More fixes for that bastardized microsoft
  home page.

* url-http.el (url-create-mime-request): Make sure that we retrieve the
  cookies for the real URL we are retrieving when going through a proxy.
  Now the psychotic crap that is the microsoft home page should be
  successfully retrieved if going through an HTTP proxy.

* url-cookie.el (url-cookie-handle-set-cookie): Attempt to deal with
  idiotic microsoft home page that sends out set-cookie headers that look
  like MC1=ID=abc, and expects two cookies MC1='' and ID='abc'  *sigh*

* w3-forms.el, w3-display.el: Form elements now keep all their attributes
  with them.  Will be useful when we start allowing scripting.
  (w3-form-create-custom): Rudimentary patches to allow embedding 'custom'
  widgets into the buffer.  Interesting.

* w3-forms.el (w3-form-determine-size): New function to calculate how big
  a form field will be - option lists should look much better now.

Thu Jan 23 08:48:59 1997  William M. Perry  <wmperry@aventail.com>

* Synch'ed up to custom 1.19

* url-parse.el: document extra slots of url-generic-parse-url

Thu Jan 23 08:34:34 1997 Joe Wells <jbw@cs.bu.edu>

* url-file.el (url-file): Patch to tell ange-ftp and/or efs the password
  in a file/ftp URL so that you won't be prompted for the password, even
  if one was specified in the URL

* url-parse.el (url-generic-parse-url): Fixed bug where specifying a
  username and password in the URL would downcase the username and
  password as well as the hostname.

Wed Jan 22 08:28:13 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.50 released

* base64.el (base64-encode-region): Pulled in code from VM for quicker
  encoding/decoding

* mm.el (mm-content-transfer-encodings): Better base64 decoding

Wed Jan 22 07:31:03 1997  Alf-Ivar Holm <alfh@ifi.uio.no>

* w3-emulate.el (w3-lynx-emulation-minor-mode-map): Lynx [up] and [down]
  bound to non-existing functions.

* w3.el (w3-do-setup): Fixed installation of lynx emulation modes keymap.

Tue Jan 21 07:56:51 1997  William M. Perry  <wmperry@aventail.com>

* url-misc.el (url-data): Make sure to url-decode the data before
  inserting it into the buffer.

* w3-menu.el (w3-toggle-minibuffer): better version

* w3-forms.el (w3-form-create-integer): New form entry type
  (w3-form-create-float): new form entry type
  (w3-form-encode-helper): deal with the new integer/float types

* w3-display.el (w3-display-node): Reimplemented <select multiple> as a
  list of checkboxes

Mon Jan 20 06:29:07 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-node): Keep track of the last form's action,
  for theoretically 'naked' input fields that we want to try and handle as
  best we can anyway.

* w3-parse.el: Much more lenient about where form elements can be found.

* w3-forms.el: summarizer functions now take the widget as an extra
  parameter.

* w3.el (w3-find-etc-directory): New function - not used yet.

* w3.txi: Warning!  You now need a very new version of texinfo to compile
  the .info or .dvi file yourself.

* url-mail.el (url-mail): Now tries to use message-mail if it is bound
  instead of just plain old 'mail'.

* w3-forms.el (w3-form-add-element): Duh, fix hidden form fields.

* font.el (font-normalize-color): Hopefully fixed color lossage under OS/2
  and Windows

* w3-forms.el (w3-form-summarize-field): Actually 'message' the string as
  a workaround for emacspeak 5.0

Sun Jan 19 09:32:15 1997  William M. Perry  <wmperry@aventail.com>

* w3-xemac.el (w3-mouse-handler): Ditto

* w3-e19.el (w3-mouse-handler): Protect against 'bad format string' errors
  when showing a hexified URL

* w3-forms.el (w3-form-mark-widget): Be super paranoid and mark all
  children and their children's children, and the parents of a widget.
  (w3-form-create-radio-button): Make sure radio button children always
  get updated via w3-form-mark-widget.
  (w3-form-summarize-radio-button): Slightly better summarization of radio
  buttons.

* Emacs-W3 3.0.49 released

* Synch'ed up with widget 1.18

Fri Jan 17 06:25:36 1997  Dave Love <d.love@dl.ac.uk>

* w3-display.el: w3-echo-link now prefers the URL to the text of a link

Fri Jan 17 06:25:36 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el: Fixed handling of inlined styles

* w3-mouse.el: Some fixes for XEmacs when built with no X support

* default.css: Now uses the new @media directives instead of the old
  :blah: stuff

* css.el (css-handle-media-directive): New function to handle @media
  directives.
  (css-parse): Deprecate the old :mediatype: way of specifying media
  dependent styles.

* w3-style.el (w3-handle-style): Now gets passed a plist instead of an
  assoc list.
  (w3-handle-style): Pay attention to the new 'media' attribute on
  stylesheet links, and don't load the stylesheet if we aren't currently
  running on that type of media.

* css.el (css-properties): Added proposed printing properties from a W3C
  draft.

Thu Jan 16 06:06:45 1997  William M. Perry  <wmperry@aventail.com>

* css.el (css-handle-media-directive): Implemented the @media processing
  instruction.

* w3-forms.el (w3-form-summarize-option-list): Changed the summarize
  function for option lists.  Much saner now.

* w3.el (w3-read-url-with-default): Use the URL at point before falling
  back to http://www.
  (w3-source-document): When sourcing a document, let set-auto-mode do the
  right thing.  .html comes up in html-mode, or whatever now.

* url-cookie.el: Fixed some compile warnings under Emacs

* w3-forms.el (w3-form-summarize-option-list): Make each choice-item have
  emacspeak-help set.

* w3-speak.el (w3-widget-backward): New advice
(w3-widget-forward): New advice

* w3-forms.el (w3-form-create-option-list): Renamed function

* Emacs-W3 3.0.48 released

* w3-display.el (w3-face-for-element): Use background-color instead of
  just background for css property.

* w3-forms.el (w3-form-encode-helper): Fixed radio buttons, duh.

* url-misc.el (url-do-terminal-emulator): Fixed bad var reference left
  from old code.

* url-gw.el: Moved all the gateway variables into their own namespace to
  make it easier to turn this into a standalone package.

* dist.Makefile (SOURCES): Added url-gw and w3 to the build targets.

Wed Jan 15 08:00:37 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.47 released

* url.el (url-expand-file-name): Make sure to remove \r from the URL as
  well as \n

* url-gw.el (url-open-stream): Added in 'telnet' and 'rlogin' methods for
  url-gateway-method.  Code stolen from GNUS.  Thanks lars! :)  It would
  be nice to make this file its own package and be able to override
  open-network-stream so that all apps could get this for free.

* url-misc.el (url-generic-emulator-loader): Consolidated the tn3270,
  telnet, and rlogin URL loaders into one smarter function

* url.el: Made cookie and auth modules autoloaded, removed some old autoloads
(url-open-stream) Moved to url-gw.el

Mon Jan 13 22:11:00 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-widget-echo): w3-echo-link can now be a list, so the
  user can explicitly control fallback behaviour.

* w3.txi: Added some pointers to CSS documentation

* mule-sysdp.el (mule-code-convert-region): ditto

* w3.el (w3-convert-code-for-mule): Fixed bug in XEmacs 20.0 mule

Mon Jan 13 11:14:29 1997  T. V. Raman <raman@Adobe.COM>

* w3.el (w3-widget-forward): Call widget-forward interactively so that
  emacspeak will hook it correctly.

Mon Jan 13 11:14:29 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-refresh-buffer): Finally reimplemented
  w3-refresh-buffer.

Sun Jan 12 10:32:50 1997  Karl Eichwalder  <ke@ke.Central.DE>

* w3.txi: Add @dircategory and @direntry... @end.  `install-info'
  from texinfo-3.9 know about those.

Sun Jan 12 21:49:44 1997  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-save-as): Can now save a page as postscript again

* w3-display.el (w3-display-node): inline styles work again

* url-misc.el (url-data): Updated data: URL to the spec.
  ftp://ietf.org/internet-drafts/draft-masinter-url-data-02.txt

Sat Jan 11 20:47:24 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-w3 3.0.45 released

* url-misc.el (url-data): Now supports the 'data' URL type, which just
  'fetches' everything after the data: chunk of the URL

Fri Jan 10 11:49:43 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-node): Multicolumn works, but puts things
  across instead of down

* w3-parse.el: Basic support for parsing <multicol>

* w3-display.el (w3-display-node): Make our semi-widgety hyperlinks
  start/end open under XEmacs.

* w3.el (w3-complete-link): Make sure we take case into account when doing
  link completion.  The user can use 'test' to complete to link titled
  'Test'.  Uses try-completion for this, which seems to work since we
  require a match.  Is this the best way to do this?  Other than not being
  case-insensitive at this point?

* w3-forms.el (w3-form-default-widget-creator): Better way of handling
  updates to text entry fields.
  (w3-revert-form): Everything should be reverted correctly, both in
  internal storage and in the buffer
  (w3-form-create-radio-button): Get a more unique identifier to store
  radio elements by - old way could theoretically get collisions.

* w3-display.el (w3-display-handle-list-type): Updated use of 'list-style'
  to use new property 'list-style-type'
  (w3-prepare-buffer): Now kills the source buffer before it starts
  drawing the tree, to avoid *URL-n* buffers when not really necessary.

* css.el (css-properties): Updated all the properties to the W3C's latest
  'recommendation' level CSS specification.
  (css-handle-import): much better handling of @import
  (css-parse): Better handling of '@' directives in general
  (css-expand-value): General cleanup, reference the CSS and ACSS specs
  for how/why we are parsing something the way we are.

Thu Jan  9 06:17:08 1997  William M. Perry  <wmperry@aventail.com>

* Updated all copyright notices.  Happy belated new year!

* w3-display.el (w3-region): Fixed a few bugs with nuking too much of a
  buffer when using w3-region

* w3.el (w3-read-url-with-default): Use new variable.

* w3-vars.el (w3-fetch-with-default): New variable to control whether or
  not w3-fetch will figure out a good default value for the URL or not.

* w3-forms.el (w3-form-mark-widget): New function to mark a widget and all
  its children with an appropriate :emacspeak-help and 'w3-form-data
  Now defines a few keywords to look more widget-y

Wed Jan  8 09:27:47 1997  William M. Perry  <wmperry@aventail.com>

* css.el (css-expand-value): Added elevation, angle, and time units.

* w3-display.el (w3-display-node): Turn on voice-lock-mode by default in
  all w3 buffers.

* css.el (css-properties): Added in new speech properties from the ACSS
  note from the W3C.  Please see
  http://www.w3.org/pub/WWW/Style/CSS/Speech/NOTE-ACSS for more
  information.

* w3-forms.el: Moved all the form entry summarization functions from
  w3-speak.el into w3-forms.  Easier to keep in synch this way.

* w3-display.el (w3-display-node): Reimplimented the 'keygen' form entry
  type for netscape compatibility.

Tue Jan  7 07:20:08 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-region): New function that parses the HTML in a region
  'in-place', so that things like MIME mailers/gnus readers can show HTML
  inline a lot easier.

* w3-forms.el (w3-form-resurrect-widgets): Fixed case where a widget goes
  all the way to point-max and next-single-property-change will return
  nil.  Would pass bad args to delete-region.
  (w3-form-summarize-field): Moved some of the smarts about summarizing W3
  widgets from w3-speak into the core forms code.

* font.el (define-font-keywords): New function for defining keywords that
  will actually work across Emacs and XEmacs

* w3-display.el (w3-display-node): Reimplemented 'note' functionality, by
  converting it into a two-cell table.
  (w3-display-node): Implemented <dir> as multi-column, as-per the RFC and
  HTML 3.x specifications

* default.css: Added default display type for dir and menu

Mon Jan  6 21:49:52 1997  William M. Perry  <wmperry@aventail.com>

* url-http.el (url-create-mime-request): Fixed yet another stupid problem
  in Host: header handling.  Was never sending the right information if
  you were not going through a proxy this time.  *sigh*

* w3-forms.el (w3-form-add-element): Fixed hidden form fields

Sun Jan  5 22:38:54 1997  William M. Perry  <wmperry@aventail.com>

* url-vars.el (url-proxy-services): updated documentation string

* w3-widget.el (widget-image-notify): Fixed client side handling of
imagemaps on a TTY or a delayed/broken image. Duhhh

Fri Jan  3  Dave Love  <d.love@dl.ac.uk>

* w3-e19.el (w3-mouse-handler): Fix link echoing.

Fri Jan  3 08:43:56 1997  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.43 released

* font.el (make-font): Treat args as a plist, just for sanity's sake.

Thu Jan  2 12:19:31 1997  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-table-hack-borders): Fix stupid use of 'otheriwse'
  instead of 'otherwise' in a case statement.

* w3-forms.el (w3-form-add-element): Fix stupid use of 'otheriwse'
  instead of 'otherwise' in a case statement.
  (w3-form-resurrect-widgets): Fixed XEmacs handling of widget recreation,
  and also fixed problem where some widgets would be skipped.

Tue Dec 31 07:37:17 1996  William M. Perry  <wmperry@aventail.com>

* w3-e19.el: All the menus in Emacs-19 now use the same constructors that
  the :filter entries under XEmacs do.  This will make things much easier
  in the future in not duplicating crufty menu-construction code once for
  XEmacs menu-structs and once for Emacs keymaps.

* w3-menu.el (w3-menu-html-links-constructor): Now works with the Emacs 19
  implementation of property lists.

Mon Dec 30 06:25:28 1996  William M. Perry  <wmperry@aventail.com>

* w3-menu.el (w3-popup-menu): context-sensitive menus over delayed images
  work again

* w3-display.el (w3-parse-link): New way to store <link> information from
  an HTML document.

* w3.el (w3-search): Deal with new <link> storage

* w3-menu.el (w3-menu-html-links-constructor): Deal with new way <link>
  items are stored - now uses the 'title' attribute if present.

* w3-auto.el (w3-form-resurrect-widgets): Added autoload

* url-file.el (url-format-directory): Removed url-forms-based-ftp option -
  didn't really work anyway.

Sun Dec 29 15:54:21 1996  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-resurrect-widgets): fixed stupid problem in munging
  of the size of form elements.

* Emacs-W3 3.0.42 released

* w3-display.el (w3-table-hack-borders): Deal gracefully with not finding
  a 'terminal' font to display hacked border chars in

* w3-hot.el (w3-hotlist-add-document): don't hexify a url before sticking
  it in the hotlist buffer

* w3-display.el (w3-display-node): hyperlinks with images at the start
  will now have a button associated with the entire link, not just the
  image part.

* w3-sysdp.el (fillin-text-property): made it work under Emacs19

Sun Dec 29 00:07:39 1996  Takahiro Hayata <hayata@sc511t.s.kobe-u.ac.jp>

* mule-sysdp.el (mule-write-region-no-coding-system): Patch for Mule 2.3

Sun Dec 29 00:07:39 1996  William M. Perry  <wmperry@aventail.com>

* w3-forms.el (w3-form-add-element): Only insert stubs of the right length
  for a for element, and do munging of that text into the actual widgets
  later.  This saves us a lot of grief and heartache when handling things
  like radio buttons that span table elements because the markers have
  become completely insane by the time the next widget is ready to be
  created.

Sat Dec 28 17:24:08 1996  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-display-table): Don't crap out on invalid tables where
  table-dimensions tells us we have a 0 column or 0 row table.

* w3-widget.el (widget-image-value-create): Use :action instead of :notify
  for widget-image-callback - hyperlinked images under Emacs 19 should
  work again.

Thu Dec 26 18:26:25 1996  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-widget-forward): Use this instead of widget-forward.
(w3-widget-backward): Ditto.  Need to make both of these smart for w3.

* w3-display.el (w3-display-node): Implemented the display class 'none'
  for turning off the rendering of an element and its subcontent.

Thu Dec 26 07:21:58 1996  William Perry  <wmperry@aventail.com>

* w3-parse.el (w3-parse-buffer): *sigh* Allow _ in attribute names.

* Emacs-W3 3.0.41 released

* url-parse.el (url-generic-parse-url): bind inhibit-read-only to 't' in
  url parsing buffers, to avoid 'attempt to modify read-only text'
  problems when the string passed to url-generic-parse-url has the
  read-only text property set.

* w3-e19.el (w3-setup-version-specifics): popup menus should work in
  Emacs19 again.

* css.el (css-expand-value): For margin and padding, make sure we _always_
  convert into a valid length spec.  Setting a 'margin' or 'padding'
  property group instead of individual margin-* or padding-* values would
  cause the display engine to crap out.
  (css-get): Fixed generic class-only lookups (.foo, etc)

* w3-display.el (w3-display-handle-list-type): Tweaks to list indentation

* w3-menu.el (w3-menu-html-links-constructor): Fixed stupid problem with
  the new navigate menu under XEmacs.

Tue Dec 24 22:46:11 1996  William M. Perry  <wmperry@aventail.com>

* css.el (css-expand-color): Better handling of X-style color specs -
  convert them to internal RGB format.

Tue Dec 24 02:50:08 1996  Christian Limpach  <chris@nice.ch>

* font.el (ns-font-families-for-device): added test for unbound
  device-fonts-cache variable.
  (ns-font-create-name): handle font-styles which are numbers.

* w3-sysdp.el (try-font-name): added support for Nextstep.

Tue Dec 24 06:16:33 1996  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-open-local): Send filename through expand-file-name in
  w3-open-local to avoid having illegal URLs like file:/~/test.html

* w3-widget.el (widget-image-value-create): fixed new problem with client
  side imagemaps.  Should really work this time.

* w3.el (w3-map-links): w3-map-links and hence w3-complete-link will now
  find images that are also hyperlinks.

Mon Dec 23 22:28:58 1996  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.40 released

* w3-menu.el (w3-menu-go-menu): Added 'navigate' submenu to hold the
  predefined <link> types.

* w3-widget.el (widget-image-summarize): Image widgets should now be much
  better at identifying themselves when being tab'ed to or waggled at with
  the mouse.

* w3-prefs.el: Fixed a few references to w3-glyphp (now widget-glyphp)

* w3.el (w3-url-completion-function): Fixed completion of URLs

Sat Dec 21 Dave Love  <d.love@dl.ac.uk>

* w3-display.el, w3-vars.el, w3.el: Define and use
  w3-defined-link-types to canonicalize link descriptions' case for
  ease of use.

* w3-e19.el (w3-build-FSF19-menu): Add any recognised <link> items
  to the menu in the absence of a toolbar.

Thu Dec 19 13:52:35 1996  William Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.39 released

* w3-forms.el (w3-form-encode-xwfu): Ditto.

* url.el (url-hexify-string): Updated to use url-unreserved-chars when
  escaping, ala
  http://www.ics.uci.edu/pub/ietf/uri/draft-fielding-url-syntax-02.txt

Wed Dec 18 22:09:41 1996  William M. Perry  <wmperry@aventail.com>

* w3.el (w3-mode): Removed bogus setting of widget-motion-hook from way
  back

* w3-parse.el (w3-parse-buffer): Better handling of <base> tag.

* w3-display.el (w3-widget-echo): Better falling-back when the preferred
  echo method yields nil.

* url.el, w3-display.el, w3.el: Remove last vestiges of url-hash.el and
  removed it from the distribution.

Wed Dec 18 08:07:32 1996  William Perry  <wmperry@aventail.com>

* dsssl.el: Moved the DSSSL parser and friends into its own namespace.

Removed dependencies on url-hash.

* custom.el: Synch'd up to custom 1.13

Tue Dec 17 16:36:05 1996  William M. Perry  <wmperry@aventail.com>

* url.el (url-expand-file-name): If we weren't given a base object to work
  from, and url-current-object is null, set it to the object returned by
  parsing url-view-url.

* url-http.el (url-create-mime-request): Send the right information in the
  'Host' header field when going through a proxy.
  (url-setup-reload-timer): Emacs 19 doesn't deal well with 0-length
  timeouts, so protect against trying to create one when dealing with the
  refresh header.

* w3-parse.el: Removed lots of crap for the old display engine - shouldn't
  cons up as much garbage as before.  Now it will just cons up garbage
  that we actually need.

Tue Dec 17 07:10:47 1996  William Perry  <wmperry@aventail.com>

* css.el (css-properties): New property type 'string-list' for font-family

* w3.el (w3-find-default-stylesheets): Make sure to look in
  data-directory/../../w3 for stylesheets

Tue Dec 17 06:07:08 1996  William M. Perry  <wmperry@aventail.com>

* w3-toolbar.el: wrapped a condition-case around the require for
  xpm-button and xbm-button so that it will compile under Emacs

Mon Dec 16 08:19:40 1996  William Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.38 released.

* dist.Makefile (OBJECTS): Removed xpm-button and xbm-button from the
  distribution.  Any version of XEmacs that can run the latest 3.0 stuff
  has them already.

* default.css: Make nested ol/ul items display class 'line' so they look
  prettier.

* w3-display.el (w3-display-node): EVIL hack to make the first item in a
  nested list get indented correctly.

* w3-about.el (w3-about): Fixed the about:style stylesheet to be
  up-to-date with new CSS spec.

* default.css: Turned down indentation on list items by default.

* w3-display.el (w3-display-node): Mouse tracking should work under XEmacs
  again.

* dist.Makefile (all): Removed 'emacs' from dependency list.

Mon Dec 16 06:03:14 1996  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-table-hack-borders): This should work on TTY's again.

Sun Dec 15 14:19:53 1996  William M. Perry  <wmperry@aventail.com>

* Emacs-W3 3.0.37 released

* w3-display.el: Better handling of paragraphs (well, any block-level
  element within a list-item display group.

* default.css (address): Changed <address> display tpye to line so that
  right-justification will take effect.

Sat Dec 14 10:24:13 1996  William M. Perry  <wmperry@aventail.com>

* w3-sysdp.el: Removed stubs for add-submenu - it was confusing 'custom'

* dist.Makefile: More GNU-ish project makefile

* url.el (url-default-find-proxy-for-url): Fixed no_proxy handling
(url-default-find-proxy-for-url): Don't pass 'www://' links to a proxy

Fri Dec 13 22:50:45 1996  William M. Perry  <wmperry@aventail.com>

* dist.Makefile (URLSOURCES): Added socks.el to the distribution.  Not
  used just yet.

* css.el (css-copy-stylesheet): Fixed problem with sharing the list
  structure between the hash tables - document stylesheets would infect
  the main w3-user-stylesheet and cause weirdness.

Fri Dec 13 09:47:40 1996  William Perry  <wmperry@aventail.com>

* w3-style.el (w3-display-stylesheet): Fixed problem where
  w3-display-stylesheet would override the buffer css-display was showing
  the stylesheet in.  Duhh.

* mule-sysdp.el (mule-encode-string): Fixed stupid problem on non-XEmacs
  mule
  (mule-sysdep-version): Ditto.

Fri Dec 13 06:25:45 1996  William M. Perry  <wmperry@aventail.com>

* css.el (css-get): Removed bogus recursive call to css-get, and moved the
  guts of css-get out into its own fuction, which is in turn inlined into
  css-get.  Might even make things faster.  At the least, I expect it to
  get rid of the 'takes two makes to make w3-display.elc' problem some
  people have been seeing.

* w3-display.el (w3-display-handle-list-type): Fixed stupid problem with
  margin handling where list-item display items were always flush-left

Fri Dec 13 02:51:24 1996  Greg Stark  <gsstark@mit.edu>
* w3-display.el (w3-display-line-break): correct right justification code
  (w3-min-size-of-string): removed unused function that didn't work.
  (w3-size-of-tree): maintain consistent w3-display-open-element-stack
  don't hard code assumption that hr's are drawn with '-'
  (w3-display-table-dimensions): major bug if the last column rowspans
  (w3-table-lookup-char): new function
  (w3-table-hack-borders): new function makes table borders use pretty
  graphic characters instead of ascii characters.
  (w3-table-unhack-borders): new function restore lame ascii borders.
  (w3-display-table): Major changes to support drawing better borders
  also fix various bugs and tweak various things.

* w3-parse.el: remove = from set of characters that terminate an attribute
	       when guessing about an syntactically invalid attribute.
	       (didn't this get changed once already?)

* w3.el (w3-sentinel): hack around bug that bit w3-preview-this-buffer
		       but I don't know what the right thing for Mule.

Thu Dec 12 08:36:01 1996  William Perry  <wmperry@aventail.com>
* Synch'd up to widget 1.13

* w3-display.el (w3-get-pad-string): Ack - watch for negative values in
  w3-get-pad-string

* Released 3.0.36

* w3-style.el (w3-display-stylesheet): Use new css-display function

* css.el (css-get): Better class checking
  (css-display): New function to pretty-print a stylesheet that is in
  memory.

* w3-parse.el (w3-parse-buffer): *sigh* Parser now keeps track of 'base'
  of this document.  Also normalizes 'align' attribute, as well as
  auto-expanding any SRC or HREF attributes.

* w3-display.el (w3-display-handle-list-type): Now handles text-indent
  style property.
  (w3-display-table): Can now specify properties on 'tr', for
  vertical-alignment, etc.
  (w3-display-node): Lots of changes to deal with new method of munging
  class/align/etc in the parser.

Wed Dec 11 17:37:14 1996  William M. Perry  <wmperry@aventail.com>

* w3-parse.el (w3-parse-buffer): Do munging of align/src/href/class
  attributes to save time in w3-display-node and friends.

* w3-prefs.el (w3-preferences-compatibility-variables): Fixed problems
  with renaming of w3-style-ie-compatibility to css-ie-compatibility

* w3-display.el (w3-display-node): fix for hyperlinks / form info in
  tables. Duhh.

Wed Dec 11 07:36:08 1996  William Perry  <wmperry@aventail.com>

* css.el (css-copy-stylesheet): New function

* w3-display.el (w3-display-node): use it

* mule-sysdp.el (mule-encode-string): Fixes for XEmacs w/mule
(mule-decode-string): Fixes for XEmacs w/mule

* w3-display.el (w3-display-node): Fixed problem in isindex handling.
  Using forms for isindex handling should work again.

* css.el (css-specificity): new function css-specificity to find how
  specific a certain rule is. Need to use this to sort rules in css-get.

Tue Dec 10 22:37:59 1996  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-get-style-info): Changes to deal with new css.el -
  should be much much faster now.

* css.el (css-get): Radically changed the internal representation of
  stylesheets, and how they are looked up.

Mon Dec  9 22:31:11 1996  William M. Perry  <wmperry@aventail.com>

* w3-display.el (w3-face-for-element): Fixed bug in w3-face-for-element
  where weight of the element wasn't being taken into account.

* css.el: Changed font-variant style type from string to symbol-list

Mon Dec  9 12:29:59 1996  William Perry  <wmperry@aventail.com>

* default.css: Changed default header sizes - should look better on most
  machines

Sun Dec  8 19:21:07 1996  William M. Perry  <wmperry@aventail.com>

* Emacs-w3 3.0.34 Released

* w3-display.el: New macro w3-get-attribute to replace
  (cdr (assq 'blah args)), just in case I ever decide to replace the
  assoc list currently used.

* New file mule-sysdp.el, to make supporting Mule 2.3, Mule 2.4, and
  XEmacs 20.0 easier.

* url-file.el (url-insert-possibly-compressed-file): handle mule 2.4

Fri Dec  6 06:54:03 1996  William Perry  <wmperry@aventail.com>

* w3-parse.el: Emit warnings when people try to slap attribute/value pairs
  on end tags.  Evil bastards.
  Added SPAN, BDO, OBJECT, BASEFONT

Fri Dec  6 04:42:24 1996  Greg Stark  <gsstark@mit.edu>

* default.css: add th td and caption text-align information

* docomp.el: increase max-specpdl-size so it can compile w3-display

* url.el (url-sentinel): avoid save-excursion around switch-buffer

* w3-display (w3-display-line-break): if we're in nowrap mode but the
  region doesn't end on a newline insert an extra newline, otherwise <br>
  gets ignored inside a <pre> or nowrap environment.
  Also protect against fill-column less than the length of fill-prefix.
  Also avoid infloop in right justification, and
  fix bug that caused right justification to never be executed.

* w3-display (table-cut table-dimensions w3-display-table):
  lots of new code to handle rowspan and autolayout.

* (w3-display-fix-widgets): be more agressive adjust even markers that have
  buffers and adjust parent markers.

* w3-display (w3-display-node): These changes are important for tables
  Don't insert insert-before on <a> tags before the class is adjusted
  Don't insert more than one class into an <a> tag when we adjust it.
  Protect against a negative fill-column when drawing <hr>s
  Set adaptive-fill-mode (what's filladapt-mode?)

* w3-parse.el: remove font from %block. WARNING, i have little idea what
  consequences this has but it seems to have the desired effect of
  handling table cells whose first tag is a <font> without discarding the
  implied <p> tag.

* w3-parse.el: skip-chars-forward "^>" when parsing end tags
  (some people seem to think you can put attributes in end tags)

Fri Dec  6 14:08:30 1996  William M. Perry  <wmperry@cs.indiana.edu>

* css.el: Better handling of text-decoration, to go along with the new version
  of set-font-style-by-keywords

* font.el: Faster version of set-font-style-by-keywords.
  Fixed RGB spec. problem if you used non-floats.

* w3-display.el: (w3-face-for-element) Obey some font function renaming.
  (w3-face-for-element) Changed format specification on w3-style-face-xxx
  creation.
  (w3-display-node) Alignment specified via attributes overrides
  stylesheet, not vice versa.
  (w3-display-node) Fixed stupid mistake in 'link' handling where
  stylesheets were ignored.

Thu Dec  5 17:51:37 1996  William M. Perry  <wmperry@cs.indiana.edu>

* url.el: (url-retrieve-internally) Can now specify an alternative
  function to determine whether a URL should be proxied or not.  modelled
  off the netscape auto-proxy-configuration crap, so hopefully someday we
  can just suck down one of their files and be 'happy' with it.

* w3-display.el, css.el:
  Modified some of the css properties to not be inherited - let
  w3-display figure it out on its own - quicker this way.  Saves a few
  thousand lookups over the life of a parse.

Mon Dec  2 20:22:12 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: use better face names... avoids problems in xemacs
  resource name checking.

* w3-vars.el: Created version 3.0.33

* w3-parse.el: Fixed problem parsing attribute values like <img alt=''> -
  the regexp didn't like empty attribute values specified with single
  quotes.

* w3.el: -Patches from Dave Love

* font.el: Renamed the font-set-*-p to set-font-*-p, to be more in line with
set-face-underline-p and friends.  Fixed stupid problem in
set-font-*-p where it would always just toggle the property, not
actually set it.  Blah.  Added code in x-font-create-name to try
oblique and italic versions of a font if italic is set.

* default.css: Prettied up the :speech: section

* w3-display.el:
Conditionalized get-style-info calls in w3-voice-for-element on
feature 'emacspeak

* w3.el: Added code to try loading dtk-css-speech and w3-speak if the feature
'emacspeak' is available.

* css.el: Fixed a few stupid problems.

* font.el:
made tty-font-create-object return a 12pt font object, just for reference.

* w3.txi: More updates to the documentation

* w3.el, w3-style.el: Moved to using the new 'css' package

* w3-parse.el:
Removed some old functions.  Save some string creation by downcasing
tag and atribute names in the buffer instead of using 'downcase'.

* w3-display.el: Moved to using the new 'css' package

* w3-auto.el: Removed some outdated autoloads

* font.el: Added function font-set-style-by-keywords

* css.el: Better handling of various entities - beter way of specifying new
properties and how they should be handled.

* default.css: *** empty log message ***

* dist.Makefile: Added 'css.el' to targets

* css.el: Initial revision

* w3-vars.el: Renamed w3-right-border to w3-right-margin

Sat Nov 30 17:42:38 1996  William M. Perry  <wmperry@cs.indiana.edu>

* custom-edit.el, custom.el, widget-edit.el, widget.el:
-Synch'd up to Custom/Widget 1.09

Fri Nov 29 23:12:42 1996  William M. Perry  <wmperry@cs.indiana.edu>

* font.el: Actually try to use the 'oblique' property under X

* w3-display.el:
Fix for sometimes getting an invalid glyph error in image retrieval.
Fixed problem where table display would pop something off the open element stack.

* custom-edit.el, custom.el, widget-edit.el, widget.el:
-Synch'd up to Custom/Widget 1.08

* w3-display.el: List filling seems to line up correctly now.
Fixed bug in ordered list handling (wrong arg passed to a format).
Changed the way spacing is handled.

* w3-menu.el: Added new 'search' menu with common web indexes

* dist.Makefile:
Don't specify widget*.el twice in SOURCES _AND_ CUSTOMSOURCES or
install under FreeBSD chokes.

* w3-display.el: Protect against list-item display property outside of a list.

* w3-sysdp.el: Fixed free var reference in make-device

Thu Nov 28 23:01:11 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el:
Protect against bad values of w3-last-fill-pos in w3-display-line-break

* w3-e19.el, w3-menu.el:
-Patches from Dave Love <d.love@dl.ac.uk> for using title of link in menus

Wed Nov 27 22:59:56 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.32

* w3.txi: Started revamping some of the documentation

* url-custom.el: Initial revision

* w3-display.el: Handle 'menu' list type correctly

* url.el: Patch from Thierry.Emery@aar.alcatel-alsthom.fr;
- insert information about processes in buffer "URL Status Display"
  instead of *URL-<i>* : added a local variable `url-status-buf' and a
  call to `set-buffer'

- changed `url-get-working-buffer' to `url-get-working-buffer-name',
  because `url-working-buffer' is expected to be a name, not a buffer
  (my mistake)

* w3-xemac.el, w3-vars.el:
Removed some old variables that aren't used anywhere now.

* w3-e19.el:
Patch from Dave Love <d.love@dl.ac.uk> for 'title' version of w3-echo-link.

* w3-display.el:
Patch from Dave Love <d.love@dl.ac.uk> for 'title' version of w3-echo-link.
Form info is now stuck on a stack instead of in a let-bound variable.
Only call w3-display-fix-widgets once!  recursive calls to
w3-display-node when rendering tables caused it to happen more than it
should.

* w3-forms.el:
Patch from Dave Love <d.love@dl.ac.uk> to protect against bad value
for 'next' in w3-next-widget.

* dist.Makefile: Don't use `install -d', use mkdir -p if necessary

Tue Nov 26 16:21:32 1996  William M. Perry  <wmperry@cs.indiana.edu>

* custom-edit.el, custom.el: synch'd up to custom 1.05

* widget.el, widget-edit.el: *** empty log message ***

* widget-edit.el, widget.el: synch'd up to widget 1.05

* w3-display.el: Handles the 'dir' list type correctly now.

* url.el:
Quick patch to check for url-working-buffer being a buffer, not a string.

* w3-display.el:
Backed out _BAD BAD BAD_ change to protect against invalid values for
w3-last-fill-pos that basically fucked everything in regards to
vertical whitespace.

Mon Nov 25 21:12:17 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: *** empty log message ***

* w3-display.el:
Now only does incrememental display around block level elements.
Does better munging of pre-formatted text CR -> LF CRLF->LF, etc.

* w3.el: Protect against errors in w3-sentinel on bad buffers.

* w3-vars.el: Created version 3.0.31

* widget-edit.el: Fixed compile problems under emacs

* w3-vars.el: *** empty log message ***

* widget.el: Made widget.el compile in emacsen w/o native backquote support

* w3-display.el: *** empty log message ***

* w3-parse.el:
Patch from greg stark for dealing with '=' in misquoted attribute value pairs

Sun Nov 24 23:25:25 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: Reimplemented targetted anchors (#foo)

* url.el: *** empty log message ***

* url-vars.el:
Changed default of url-mime-language-string to '*' to make some sites happy.

* w3-display.el: Protect against w3-last-fill-pos getting an invalid position

* w3.el, w3-display.el, w3-vars.el:
Patch from Dave Love <d.love@dl.ac.uk> to add new possibility 'title'
to w3-echo-link to show the 'title' attribute of a link if its there.

* w3-speak.el: Patch from raman.

* font.el:
Patch from nagae@mickey.ai.kyutech.ac.jp to handle fontsets correctly in mule

* w3-display.el: Implemented a few more CSS properties.
list-style - control how list items are displayed.  Ordered lists are
	     now different from unordered only in their list-style.
	     Need to implement contextual selectors to get ordered
	     lists to work out of the box though.
white-space - control whether whitespace is collapsed or not, and
	      whether text is wrapped.  <pre> <xmp> and <plaintext>
	      are now all specified to use this in the default
	      stylesheet.
text-align - this replaces the old 'align' attribute

Reimplemented inlined styles.

* default.css: Varius updates to take advantage of the new CSS properties
white-space, list-style, etc.

* w3-style.el: Handle url() and rgb() notation in color specifications

* w3-vars.el: Removed a few outdated variables

Sat Nov 23 02:10:37 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: *** empty log message ***

* dsssl.el: Got rid of yet more compilation warnings.

* custom.el, custom-edit.el: Synch'd up to custom 1.0.1

* w3-display.el:
Better handling of <hr> and <center>, and line spacing in general

* default.css: Updates to default stylesheet to deal with <center> and <div>

* w3.el, url.el, url-vars.el, url-http.el:
Patches from Thierry Emery to allow multiple asynch fetches.

Fri Nov 22 22:26:35 1996  William M. Perry  <wmperry@cs.indiana.edu>

* widget-edit.el, widget.el: -Synch'd up to widget 1.01

* w3-style.el: Fixed a few fRemoved a few free variable sets/refs

* w3.el:
When saving a document as html source, try to get into the 'head' before inserting the base.

* w3-display.el, w3-style.el:
Stylesheets now store all there information as property lists instead
of assoc lists.  Just easier.

* font.el: Fix for font-normalize-color under nextstep

Thu Nov 21 04:01:22 1996  William M. Perry  <wmperry@cs.indiana.edu>

* widget-edit.el, widget.el: synch'd to 1.00 of widget/custom

Mon Nov 18 16:26:06 1996  William M. Perry  <wmperry@cs.indiana.edu>

* install.sh: Initial revision

* html32.dsl: Updated to latest from jon bosak

* w3-vars.el: Created version 3.0.30

Thu Nov 14 22:39:36 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3.el: Changed this so you can actually just do a (require 'w3-sysdp) and
each function will check to see if it should overwrite, instead of
conditionalizing that on the whole file.

* url.el: *** empty log message ***

* images.el, font.el, docomp.el, w3-sysdp.el:
Changed this so you can actually just do a (require 'w3-sysdp) and
each function will check to see if it should overwrite, instead of
conditionalizing that on the whole file.

* w3-display.el: Moved some macros around.

* widget.el, widget-edit.el, w3-forms.el: Sync'd up to Widget 0.999

* w3-auto.el, w3-menu.el: *** empty log message ***

Sun Nov 10 18:08:24 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.29

* dsssl.el: Various changes, starting on the actual flow object stuff

Tue Nov  5 05:26:07 1996  William M. Perry  <wmperry@cs.indiana.edu>

* url-news.el: Updated version checking of news to deal with 'red' gnus

Mon Nov  4 14:47:47 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: Don't show the content of 'script' - typo

Fri Nov  1 15:08:45 1996  William M. Perry  <wmperry@cs.indiana.edu>

* default.css: Changes from raman

Thu Oct 31 18:51:52 1996  William M. Perry  <wmperry@cs.indiana.edu>

* widget-edit.el: -

Tue Oct 29 19:53:38 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: *** empty log message ***

Thu Oct 24 02:25:03 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-widget.el: Updated the image widget to the new widget stuff.

Wed Oct 23 13:26:09 1996  William M. Perry  <wmperry@cs.indiana.edu>

* docomp.el: *** empty log message ***

* url.el: Fixed bug in url-remove-relative-links that would choke on something
like: /foo/bar/./../baz/ - they /../ was removed first, removing its
parent directory, the /./ - ack.

* w3-display.el: Image loading is back!
Client-side imagemaps are back!
Forms that span tables are working now.

Mon Oct 21 21:32:33 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.28

* url-mail.el: Make mail handling a little more generic.

* w3-display.el:
Fix for w3-display-fix-widgets so that links right up against each
other don't cause it to skip every-other-one.

Sun Oct 20 16:47:05 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-style.el: don't map a pitch of 9 to 0.

* w3-speak.el:
Added back in the advice for url-lazy-message that provided auditory
feedback during URL retrieval.  Also added back in the
w3-speak-browse-page command.

* w3-speak.el:
Some patches from TV Raman to fix multiline text entry area speaking
and a bogus call to widget-get in text entry area speaking.

Fri Oct 18 12:27:04 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el:
Patches from Thierry Emery <Thierry.Emery@aar.alcatel-alsthom.fr> to
implement 'colspan' on tables.  Patch to support align=xxx on
arbitrary tags.

Thu Oct 17 22:27:44 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.27

* w3-display.el:
fixed voicification of hyperlinks.  Fixed problem in w3-normalize-spaces
and multi-line strings.

Wed Oct 16 20:56:40 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-speak.el: Fix stupid problem.  function renaming lossage.  Fun

* w3-display.el:
Fixed <select> form items that had no <option value=xxx selected>
entry in them.  Wheee.

* w3-display.el:
Fixed <select> form items that had an <option value=xxx selected>
entry in them.  Wheee.

* w3.el: document info is now shown as a table.

* w3.el: Document information is now shown as a table.

* w3-display.el, w3-vars.el: Now keeps better track of the <meta> tag info

* w3-vars.el: Created version 3.0.26

* w3-display.el: *** empty log message ***

Tue Oct 15 13:21:54 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: Added back in <meta> and <link> handling.
Fixed insert-before and insert-after for 'a' tag and pseudo-classes

* w3-display.el:
Fixed some potential runaway style inheritance - need to think about a
better way to pop style info off the various stacks than
(w3-handle-content node) on an empty element.

* w3-display.el: Fixed <textarea> elements in forms

* w3-display.el, w3-forms.el: Fixed <select> elements in forms

Sun Oct 13 23:50:03 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.25

* dsssl.el: Bug fixes

* url-hash.el:
Fixed bug in url-gethash where it wasn't honoring the 'default' parameter

Sat Oct 12 20:32:49 1996  William M. Perry  <wmperry@cs.indiana.edu>

* widget.el, widget-edit.el: Synched up to widget 0.99.4

Fri Oct 11 18:55:02 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: fix for xemacs w/ temp faces

* w3-display.el: Fixed a bug with the insert-after handling. Duhh.

* default.css, w3-display.el: Implemented insert-before and insert-after

Wed Oct  9 19:00:59 1996  William M. Perry  <wmperry@cs.indiana.edu>

* ssl.el, url-cookie.el, url-file.el, url-gopher.el, url-hash.el, url-http.el, url-irc.el, url-mail.el, url-misc.el, url-news.el, url-nfs.el, url-parse.el, url-pgp.el, url-vars.el, url-wais.el, url.el, urlauth.el, w3-about.el, w3-annotat.el, w3-display.el, w3-e19.el, w3-emulate.el, w3-forms.el, w3-hot.el, w3-imap.el, w3-keyword.el, w3-latex.el, w3-menu.el, w3-mouse.el, w3-mule.el, w3-parse.el, w3-prefs.el, w3-print.el, w3-speak.el, w3-style.el, w3-toolbar.el, w3-vars.el, w3-widget.el, w3-xem20.el, w3-xemac.el, w3.el, xbm-button.el, xpm-button.el, base64.el, dsssl.el, font.el, images.el, md5.el, mm.el:
-Updated copyrights/addresses

Tue Oct  8 14:56:22 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: Tables now default to having no border

* w3-forms.el: Require w3-vars so Gnus will work

* w3-vars.el: Created version 3.0.24

* w3-speak.el:
Added a few patches from raman and the latest version of emacspeak -
everything appears to work out of the box now.

* w3-style.el:
Added in a few autoloads for getting emacspeak to work right out of the box.

* w3-display.el: Added back in the :help-echo stuff on widgets

Mon Oct  7 18:09:17 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el:
<isindex> works again.  Automatically turns off filladapt-mode now,
since we apparently don't play well together.

* default.css: Added some margins

* w3-display.el: Fix for emacs 19

Fri Oct  4 17:08:51 1996  William M. Perry  <wmperry@cs.indiana.edu>

* dsssl.el:
Fixed a few errors in calling w3-dsssl-check-args.  Now _EVERYTHING_
compiles cleanly.

* docomp.el: Added a few more variables to the 'expected-to-be-free' list.
Everything but dsssl.el compiles cleanly now.

* url-news.el: Fixed a few typos that resulted in free variable references.

* w3-display.el: New function w3-make-face to 'do the right thing' in
Emacs/XEmacs/Emacs-with-no-X-support.
Implemented margin-left and margin-right.
Fixed a few problems with runaway or insufficient application of styles.

Mon Sep 30 19:43:35 1996  William M. Perry  <wmperry@cs.indiana.edu>

* url-hash.el:
Nasty hack to fix the   !! error (("file \"cl-extra\" didn't define \"gethash\"")) stuff people are seeing under Emacs-19

* w3-vars.el: Created version 3.0.23

* w3-prefs.el: Updates for new widget package

* w3-display.el:
No more recursion!  Lots more shit broke though.  Lists are totally broken.

* w3.el: Updates for new widget package

* w3-keyword.el: *** empty log message ***

Sun Sep 29 21:26:47 1996  William M. Perry  <wmperry@cs.indiana.edu>

* widget.el, widget-edit.el: Updated to version 0.99 of the library

* widget-edit.el: Allow the :help-echo widget stuff to be a symbol

* w3.el: More updates for the latest widget package

* w3-sysdp.el: New functions prepend-text-property, append-text-property,
fillin-text-property

* default.css, url.el: *** empty log message ***

Wed Sep 25 10:53:08 1996  William M. Perry  <wmperry@cs.indiana.edu>

* dist.Makefile: Removed custom.el and custom-edit.el from the distribution.

Tue Sep 24 05:04:47 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.22

* widget.el, widget-edit.el: Updated to latest widget stuff from Per.

* w3-parse.el:
Added <script> to %body.content so that stupid IE 3.0 demo pages would work.

* w3-keyword.el:
Added some new keyword defs to get rid of compile-time warnings

* w3-forms.el, w3-display.el: Now works with newest widget stuff

* url.el: New function url-parse-query-string, to return an assoc list of name
value pairs from a URL-style query. url-unhex-string now takes an
optional second argument for whether to allow decoding of newlines or
not.

* url-mail.el:
Now understands netscape-style 'extensions' to the mailto: specifier.
ie: mailto:wmperry?subject=thesubject&bcc=root

* font.el:
Now always converts to points instead of pixels, seems to give better
results this way.

Mon Sep 23 04:53:56 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.20

* dsssl.el: Made dsssl depend on url-hash

Sun Sep 22 05:16:06 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el, w3-parse.el: *** empty log message ***

* w3-display.el: Some spacing changes, fix for nested lists

* custom.el, widget-edit.el, widget.el: -

* custom-edit.el: *** empty log message ***

Fri Sep 20 05:07:12 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.19

* w3-display.el: *** empty log message ***

* w3-sysdp.el: Added in stub for set-keymap-parents

* w3-speak.el: Patches from raman

* w3-prefs.el, w3-imap.el: *** empty log message ***

* w3-hot.el: Fixed w3-read-html-bookmarks to work with some parser changes.

* w3-forms.el: Made forms work again.

* w3-display.el: Changed how the borders on tables are drawn.
Added back in the voice support.

Thu Sep 19 05:12:49 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.18

* dist.Makefile:
Moved the URL and W3 packages back into one big distrubtion again

* w3-vars.el: Created version 3.0.18

* w3-vars.el: Created version 3.0.19

* w3-display.el: Don't crap out on tables with 0 columns

* docomp.el, url.el: *** empty log message ***

Wed Sep 18 12:50:03 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.18

* docomp.el: *** empty log message ***

* w3-display.el: Space filling fixes

* w3-auto.el: Added autoload for w3-style-post-process-stylesheet

Tue Sep 17 12:50:47 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.16

* w3-display.el, w3-e19.el: *** empty log message ***

Mon Sep 16 04:46:18 1996  William M. Perry  <wmperry@cs.indiana.edu>

* custom-edit.el, custom.el, widget-edit.el, widget-example.el, widget.el:
Initial revision

Sun Sep 15 22:47:53 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.15

* w3-display.el: Alignment stuff works (right, left, full, center).
Tables can now be borderless, and if it has borders, they are all there.
<pre>/<xmp> work.

* url-vars.el: Created version 1.0.42

* url-http.el: *** empty log message ***

* w3-vars.el: Created version 3.0.14

* html32.dsl: Initial revision

* w3.el: Use the new display code.

* w3-forms.el: A few changes for the latest display code

* w3-vars.el: Created version 3.0.14

* w3-display.el: Actually mostly works

* w3-parse.el: Removed hooks into the old display engine

* url.el: *** empty log message ***

* w3-speak.el: Update from raman

* url.el: *** empty log message ***

Sat Sep 14 16:48:24 1996  William M. Perry  <wmperry@cs.indiana.edu>

* url-gopher.el, url.el:
Added '...' to the downloading messages so that they do not show up in
the message log buffer under Emacs 19.xx

* w3-parse.el: Changed content-model of <script> to fix problems on some sites
(notably netscape's) that use an unescaped </ in the script.  BAD SGML
DAMMIT.

Fri Sep 13 05:24:53 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.13

* w3-forms.el: Use the new :ignore-case stuff for choice items

Thu Sep 12 05:57:47 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el: Holy shit tables work.

Tue Sep 10 03:11:55 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-speak.el: Bug-fixes from raman.

Mon Sep  9 05:18:37 1996  William M. Perry  <wmperry@cs.indiana.edu>

* dsssl.el:
Removed a few compiler warnings and fixed a few bugs (equal, error, time

* dsssl.el:
DSSSL (define ...)'d functions are now called correctly.  Wow.  Added
in most of the rest of the DSSSL(o) application profile functions.

* dsssl.el: Initial revision

* w3-parse.el: *** empty log message ***

* w3-about.el, w3-annotat.el, w3-draw.el, w3-e19.el, w3-emulate.el, w3-forms.el, w3-hot.el, w3-imap.el, w3-keyword.el, w3-menu.el, w3-mouse.el, w3-mule.el, w3-prefs.el, w3-print.el, w3-speak.el, w3-style.el, w3-toolbar.el, w3-vars.el, w3-widget.el, w3.el, w3-xemac.el, images.el:
Changed copyright assignment

* font.el: changed copyright assignment

Sun Sep  8 00:31:52 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-draw.el:
Added in a stub handler for the 'frame' tag, so that you can still get
to frame pages written by idiots who don't use a decent 'noframe'
subdocument.

* url.el: Removed nntp-after-change-function, since it screwed up GNUS

Sat Sep  7 01:45:17 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-latex.el: updated email address for stephen peters

Wed Sep  4 02:09:08 1996  William M. Perry  <wmperry@cs.indiana.edu>

* socks.el: Initial revision

Sun Sep  1 16:22:50 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-draw.el: Don't load images on a TTY device in XEmacs.  General speedup

Thu Aug 29 04:09:40 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.12

Sun Aug 25 17:12:32 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-draw.el: Added some stubs for tables

Mon Aug 19 03:30:47 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3.el: fixed bug in w3-insert-formatted-url

Mon Aug 12 03:10:30 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-style.el: Don't make a null voice of paul-5555 if no stuff is specified.

* default.css: Added speech elements to the default stylesheet.

Sun Aug 11 16:41:58 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.11

* font.el:
Fix for font-default-font-for-device under XEmacs when you use a font
like '10x20' instead of the fully specified version

Sat Aug 10 16:14:08 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-forms.el:
Do not encode the '.' in application/x-www-form-urlencoded.  Fucking
netscape compatbility.  What _SPEC_?!  There aren't any specs on the
web, right?!

* w3-forms.el:
Fixed problem with submissions of a form with the exact same arguments
causes elements from both form to be submitted.  ack.

Tue Aug  6 14:03:52 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-parse.el:
fixed stupid mistake in DTD I made when changing to 3.2 DTD - left
'style' out of head's content-model so no in-document stylesheet stuff
was getting parsed.  gack.

* w3-forms.el: No longer put a 'choose' in front of option menus

* w3-speak.el: fixed bugs

Mon Aug  5 14:03:09 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.10

* default.css: A few mild changes, and docs.

Sun Aug  4 23:51:26 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-speak.el: new version of w3-speak from raman

* w3-draw.el: Style search alg. now looks for tag/id|name first.  Now supports
inlined 'style' keyword on any tag.  Gack *sigh*

* w3-style.el:
Can now have periods in class names.  Fixed bug where the class would
be normalized to lowercase as well as the tag name.  BAD BAD BAD.

* w3-speak.el: some changes from raman

* w3-style.el: Think I finally fixed some stylesheet weirdness

* w3.el: Don't override user prefs w/w3-user-colors-take-precedence -duh

* w3-parse.el: fixed graphical entities

Sat Aug  3 20:09:50 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el:
Added textual representation of the 'artist formerly known as prince'
graphical icons

* md5.el: removed /bin/sh dependency in md5

Fri Aug  2 14:08:38 1996  William M. Perry  <wmperry@cs.indiana.edu>

* url-vars.el: Created version 1.0.41

* url.el:
no longer special case file:// urls when checking for no_proxy - thats
just stupid.

Thu Aug  1 13:32:54 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-vars.el: Created version 3.0.9

* url.el: made url-insert-file-contents  interactive

* w3-sysdp.el:
added data-directory to sysdep version of x-library-search-path for
emacs under windows 95/nt

* w3-vars.el:
Implemented &prince; and &princesymbol; graphical entities.  Thanks
for the note Jamie Z!

* w3-forms.el: fix for gopher searches

* w3-draw.el: Added support for balloon-help

Fri Jul 26 05:57:21 1996  William M. Perry  <wmperry@cs.indiana.edu>

* w3-display.el, w3-texinfo.el: Initial revision
